%{
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>
#include <time.h>
#include "typedef.h"

extern int debug_rule;
extern TypeInst* S;
extern TypeInst* T;
extern TypeInst* D;
extern TypeCD* CDIn;

extern TypeInst* N;
extern TypeInst* NT;
extern TypeInst* NS;
extern TypeInst* NO;
extern TypeInst* NSO;
extern TypeInst* NTO;

char tempo[1000];
int  RedoFlag;
extern unsigned long ordinal;

#define TRUE  1
#define FALSE 0

TypeInst* Memoire[100];

#include "fonc.h"
extern char* Table( char*, char* );
extern int   MustSort( char* );

void PrintDebug(char*);

%}


%union
{
	int   code;
	TypeInst* inst; 
	TypeCD*   tcd;
}

%token <code> SEP FIN WNUMBER WSTRING 
%token <code> PLUS MOINS MULTIPLIE DIVISE
%token <code> EQ NE IN GT LT GE LE
%token <code> EXISTS PRECEDES FOLLOWS
%token <code> IF THEN ELSE AND OR NOT  
%token <code> BY STRICT AT BEGINING END BOTH

%token <inst> VARS STRING NUMERIC
%token <inst> VAR_N VAR_NT VAR_NS VAR_NO VAR_NTO VAR_NSO
%token <inst> TAG STAG FIX I1 I2
%token <inst> STR VAL LEN STO MEM EXC CLR LOWER UPPER
%token <inst> FROM TO BETWEEN DELETE REPLACE REPLACEOCC
%token <inst> BFIRST EFIRST BLAST ELAST
%token <inst> REDO SORT NEXT LAST TABLE ORDINAL
%token <inst> YEAR MONTH DAY HOUR MINUTE SECOND
%token <inst> NEXTBAL PREVIOUSBAL

%left  SEP PLUS MOINS MULTIPLIE DIVISE

%type <inst> Program Rules Rule
%type <inst> SetOfInstr
%type <inst> Instruction Condition Translation
%type <tcd>  CD TAGOCC STAGOCC
%type <code> Boolean

%%
Program :
	Rules			{
				  if (!RedoFlag) 
				  {
					FreeMem(S);
					Copie(&S,$$);
					FreeMem($$);
					$$=NULL;
					return 1;
				  }
				  else
				  {
					FreeMem(S);
					S=T;
					Copie(&T,$$);
					FreeMem($$);
					$$=NULL;
					if (T->str[0]==0) return 1;
					else		  return 3;
				  }
				}	
;

Rules :
	Rule			{ 
				  Copie(&$$,S);
				  FreeMem(S);
				  S=NULL;
				}				
|	PLUS Rule		{	
				  $$=Ajout(D,S);
				  D=S=NULL;
				}
;

Rule :
	SetOfInstr FIN
|	SetOfInstr SEP FIN
;

SetOfInstr :
	SetOfInstr SEP SetOfInstr
|	Instruction		{
				  FreeMem(S); 
				  Copie(&S,$1);
				  FreeMem($1);
				  $1=NULL; 
				}
;

Instruction :
	Condition
|	Translation
|	REDO			{ PrintDebug("Redo");
				  Copie(&$$,S);
				  RedoFlag=1;
				  Copie(&T,S);
/*				  ++NO->val;
				  if (NTO->val>=0) ++NTO->val;
				  else
				  if (NSO->val>=0) ++NSO->val;*/
				}
;

CD :
	TAGOCC			{ PrintDebug("Tagocc");
				  $$=$1; 
				  $$->Fixed=NULL;
				  $$->SubField[0]=0;
				  $$->ns=0;
				}
|	TAGOCC STAGOCC 		{ PrintDebug("Tagocc Stagocc");
				  $$=$1;
				  $$->Fixed=NULL;
				  strcpy($$->SubField,$2->SubField);
				  $$->ns=$2->ns;
				  free($2);
				  $2=NULL;}
|	TAGOCC FIX		{ PrintDebug("Tagocc Fix");
				  $$=$1;
				  $$->SubField[0]=0;
				  $$->ns=0;
				  $$->Fixed=strdup($2->str);
				  FreeMem($2);
				  $2=NULL;}
|	TAGOCC STAGOCC FIX	{ PrintDebug("Tagocc Stagocc Fix");
				  $$=$1;
				  strcpy($$->SubField,$2->SubField);
				  $$->ns=$2->ns;
				  $$->Fixed=strdup($3->str);
				  free($2);
				  $2=NULL;
				  FreeMem($3);
				  $3=NULL;}
|	STAGOCC			{ PrintDebug("Stagocc");
				  $$=$1;
				  $$->Fixed=NULL;
				  strcpy($$->Field,CDIn->Field);
				  $$->nt=0; }
|	FIX			{ PrintDebug("Fix");
				  $$=(TypeCD*)malloc(sizeof(TypeCD));
				  strcpy($$->Field,CDIn->Field);
				  $$->nt=0;
				  strcpy($$->SubField,CDIn->SubField);
				  $$->ns=0;
				  $$->Fixed=(char*)strdup($1->str);
				  FreeMem($1);
				  $1=NULL;}
|	STAGOCC FIX		{ PrintDebug("Stagocc Fix");
				  $$=$1;
				  $$->Fixed=strdup($2->str);
				  strcpy($$->Field,CDIn->Field);
				  $$->nt=0;
				  FreeMem($2);
				  $2=NULL;}
;

TAGOCC :
	TAG				{ PrintDebug("Tag");
				  	  $$=(TypeCD*)malloc(sizeof(TypeCD));
					  strcpy($$->Field,$1->str);
					  $$->nt=0;
					  FreeMem($1);
					  $1=NULL; }
|	TAG '(' Translation ')'		{ PrintDebug("Tag(...)");
				  	  $$=(TypeCD*)malloc(sizeof(TypeCD)); 
					  strcpy($$->Field,$1->str);
					  FreeMem($1);
					  $1=NULL;
					  $$->nt=$3->val;
					  free($3);
					  $3=NULL; }
;

STAGOCC :
	STAG				{ PrintDebug("Stag");
				  	  $$=(TypeCD*)malloc(sizeof(TypeCD));
					  strcpy($$->SubField,$1->str);
					  $$->ns=0;
					  FreeMem($1);
					  $1=NULL; }
|	STAG '(' Translation ')'	{ PrintDebug("Stag(...)");
				  	  $$=(TypeCD*)malloc(sizeof(TypeCD)); 
					  strcpy($$->SubField,$1->str);
					  FreeMem($1);
					  $1=NULL;
					  $$->ns=$3->val;
					  free($3);
					  $3=NULL; }
|	I1				{ PrintDebug("I1");
				  	  $$=(TypeCD*)malloc(sizeof(TypeCD));
					  strcpy($$->SubField,"I1"); 
					  $$->ns=0;	
					}
|	I2				{ PrintDebug("I2");
				  	  $$=(TypeCD*)malloc(sizeof(TypeCD));
					  strcpy($$->SubField,"I2"); 
					  $$->ns=0;	
					}
;

Condition :
	IF Boolean THEN Translation 	{ PrintDebug("If...Then...");
					  if ($2) $$=$4; 
					  else 
					   {
					    FreeMem($4);
					    $4=NULL;
					    FreeMem(S);
					    S=NULL;
					    return 2; 
					   }
					}
|	IF Boolean THEN Translation ELSE Translation
					{ PrintDebug("If...Then...Else...");
					  if ($2) 
					  {
						$$=$4;
						FreeMem($6);
					        $6=NULL;
					  }
					  else 
					  {
						$$=$6;
						FreeMem($4);
					        $4=NULL;
					  }
					}
;

Boolean :
	'(' Boolean ')'			{ PrintDebug("(B...)"); $$=$2; }
|	Boolean AND Boolean		{ PrintDebug("B...and B..."); $$=$1 && $3; }
|	Boolean OR Boolean		{ PrintDebug("B...or B...");$$=$1 || $3; }
|	NOT Boolean			{ PrintDebug("!B...");$$=!$2; }
|	Translation EQ Translation	{ PrintDebug("...=...");$$=BoolEQ($1,$3); $1=$3=NULL; }
|	Translation NE Translation	{ PrintDebug("...!=...");$$=!BoolEQ($1,$3); $1=$3=NULL; }
|	Translation IN Translation	{ PrintDebug("...In...");$$=BoolIn($1,$3); $1=$3=NULL; }
|	Translation GT Translation	{ PrintDebug("...>...");$$=BoolGT($1,$3); $1=$3=NULL; }
|	Translation LT Translation	{ PrintDebug("...<...");$$=BoolGT($3,$1); $1=$3=NULL; }
|	Translation GE Translation	{ PrintDebug("...>=...");$$=BoolGE($1,$3); $1=$3=NULL; }
|	Translation LE Translation	{ PrintDebug("...<=...");$$=BoolGE($3,$1); $1=$3=NULL; }
|	EXISTS '(' CD ')'		{ PrintDebug("Exists(...)");
					  $$=Exists($3); 
					  if ($$==2) return 2;
					  FreeCD($3); $3=NULL; }
|	CD PRECEDES CD			{ PrintDebug("...Precedes...");
					  $$=Precedes($1,$3); 
					  if ($$==2) return 2;
					  FreeCD($3); $3=NULL; }
|	CD FOLLOWS CD			{ PrintDebug("...Follows...");
					  $$=Precedes($3,$1); 
					  if ($$==2) return 2;
					  FreeCD($3); $3=NULL; }
;

Translation :
	'(' Translation ')'		{ PrintDebug("(...)");$$=$2; }
|	STRING
|	NUMERIC	
|	YEAR				{
					  time_t ns;
					  struct tm *lt;
					  time(&ns);
					  lt=localtime(&ns);
					  $$=(TypeInst*)malloc(sizeof(TypeInst));
					  sprintf(tempo,"%04d",1900+lt->tm_year);
					  $$->str=strdup(tempo);
					  $$->val=0;
					}
|	MONTH				{
					  time_t ns;
					  struct tm *lt;
					  time(&ns);
					  lt=localtime(&ns);
					  $$=(TypeInst*)malloc(sizeof(TypeInst));
					  sprintf(tempo,"%02d",lt->tm_mon+1);
					  $$->str=strdup(tempo);
					  $$->val=0;
					}
|	DAY				{
					  time_t ns;
					  struct tm *lt;
					  time(&ns);
					  lt=localtime(&ns);
					  $$=(TypeInst*)malloc(sizeof(TypeInst));
					  sprintf(tempo,"%02d",lt->tm_mday);
					  $$->str=strdup(tempo);
					  $$->val=0;
					}
|	HOUR				{
					  time_t ns;
					  struct tm *lt;
					  time(&ns);
					  lt=localtime(&ns);
					  $$=(TypeInst*)malloc(sizeof(TypeInst));
					  sprintf(tempo,"%02d",lt->tm_hour);
					  $$->str=strdup(tempo);
					  $$->val=0;
					}
|	MINUTE				{
					  time_t ns;
					  struct tm *lt;
					  time(&ns);
					  lt=localtime(&ns);
					  $$=(TypeInst*)malloc(sizeof(TypeInst));
					  sprintf(tempo,"%02d",lt->tm_min);
					  $$->str=strdup(tempo);
					  $$->val=0;
					}
|	SECOND				{
					  time_t ns;
					  struct tm *lt;
					  time(&ns);
					  lt=localtime(&ns);
					  $$=(TypeInst*)malloc(sizeof(TypeInst));
					  sprintf(tempo,"%02d",lt->tm_sec);
					  $$->str=strdup(tempo);
					  $$->val=0;
					}
|	ORDINAL '(' Translation ')'	{
					  int i,j;
					  char tmp1[20];
					  $$=(TypeInst*)malloc(sizeof(TypeInst));
					  sprintf(tmp1,"%d",ordinal);
					  for (j=0,i=strlen(tmp1);i<$3->val;++i,++j)
					   tempo[j]='0';
					  strcpy(&tempo[j],tmp1);
					  $$->str=strdup(tempo);
					  $$->val=0;
					  FreeMem($3);
					  $3=NULL;
					}
|	NEXTBAL			{
						PrintDebug("NextSub");$$=NextBal();
					}
|	PREVIOUSBAL		{
						PrintDebug("PreviousSub");$$=PreviousBal();
					}
|	VAR_N				{ PrintDebug("N");Copie(&$$,N); }
|	VAR_NT				{ PrintDebug("NT");Copie(&$$,NT); }
|	VAR_NS				{ PrintDebug("NS");Copie(&$$,NS); }
|	VAR_NO				{ PrintDebug("NO");Copie(&$$,NO); }
|	VAR_NTO				{ PrintDebug("NTO"); Copie(&$$,NTO); }
|	VAR_NSO				{ PrintDebug("NSO");Copie(&$$,NSO); }
|	VARS				{ PrintDebug("S");Copie(&$$,S); }
|	CD			{ char *ptr;
				  PrintDebug("CD");
				  $$=(TypeInst*)malloc(sizeof(TypeInst));
				  ptr=LireCD($1);
				  if (!ptr) return 2;
				  $$->str=ptr; 
				  $$->val=0;
				  if ($1->Fixed) free($1->Fixed);
				  free($1); }
|	Translation PLUS Translation	{ PrintDebug("...+...");$$=Ajout($1,$3); $1=$3=NULL; }
|	Translation MOINS Translation	{ PrintDebug("...-...");$$=Soust($1,$3); $1=$3=NULL; }
|	Translation MULTIPLIE Translation	{ PrintDebug("...*...");$$=Multi($1,$3); $1=$3=NULL; }
|	Translation DIVISE Translation	{ PrintDebug("...:...");$$=Divis($1,$3); $1=$3=NULL; }
|	STR '(' Translation ')'		{ PrintDebug("Str(...)");$$=String($3); }
|	VAL '(' Translation ')'		{ PrintDebug("Val(...)");$$=Value($3); }
|	LEN '(' Translation ')'		{ PrintDebug("Len(...)");$$=Len($3); }
|	UPPER '(' Translation ')'	{ PrintDebug("Upper(...)");$$=Upper($3); }
|	LOWER '(' Translation ')'	{ PrintDebug("Lower(...)");$$=Lower($3); }
|	STO '(' Translation ')'		{ PrintDebug("Sto(...)");Copie(&$$,S); MemSto($3); $3=NULL; }
|	MEM '(' Translation ')'		{ PrintDebug("Mem(...)");$$=MemMem($3); $3=NULL; }
|	EXC '(' Translation ')'		{ PrintDebug("Exc(...)");$$=MemExc($3); $3=NULL; }
|	CLR '(' Translation ')'		{ PrintDebug("Clr(...)");Copie(&$$,S); MemClr($3); $3=NULL; }
|	FROM '(' Translation ')'	{ PrintDebug("From(...)");$$=From($3,0); $3=NULL; }
|	FROM '(' Translation ',' STRICT ')'	
					{ PrintDebug("From(...,STRICT)");$$=From($3,1); $3=NULL; }
|	TO '(' Translation ')'		{ PrintDebug("To(...)");$$=To($3,0); $3=NULL; }
|	TO '(' Translation ',' STRICT ')'	
					{ PrintDebug("To(...,STRICT)");$$=To($3,1); $3=NULL; }
|	BETWEEN '(' Translation ',' Translation ')'	
					{ PrintDebug("Between(...)");$$=Between($3,$5,0); $3=NULL; }
|	BETWEEN '(' Translation ',' Translation ',' STRICT ')'	
					{ PrintDebug("Between(...,STRICT)");$$=Between($3,$5,1); $3=$5=NULL; }
|	DELETE '(' Translation ')'	{ PrintDebug("Delete(...)");$$=Replace($3,NULL,0,0); $3=NULL; }
|	DELETE '(' Translation ',' AT BEGINING ')'	
					{ PrintDebug("Delete(..., AT BEGINING)");$$=Replace($3,NULL,1,0); $3=NULL; }
|	DELETE '(' Translation ',' AT END ')'	
					{ PrintDebug("Delete(..., AT END)");$$=Replace($3,NULL,2,0); $3=NULL; }
|	DELETE '(' Translation ',' AT BOTH ')'	
					{ PrintDebug("Delete(...,EVERYWHERE)");$$=Replace($3,NULL,3,0); $3=NULL; }
|	DELETE '(' Translation ',' STRICT ')'	{ PrintDebug("Delete(...)");$$=Replace($3,NULL,0,1); $3=NULL; }
|	DELETE '(' Translation ',' AT BEGINING ',' STRICT ')'	
					{ PrintDebug("Delete(..., AT BEGINING)");$$=Replace($3,NULL,1,1); $3=NULL; }
|	DELETE '(' Translation ',' AT END ',' STRICT ')'	
					{ PrintDebug("Delete(..., AT END)");$$=Replace($3,NULL,2,1); $3=NULL; }
|	DELETE '(' Translation ',' AT BOTH ',' STRICT ')'	
					{ PrintDebug("replace(...,EVERYWHERE)");$$=Replace($3,NULL,3,1); $3=NULL; }
|	REPLACE '(' Translation BY Translation ')'	{ PrintDebug("replace(...)");$$=Replace($3,$5,0,0); $3=$5=NULL; }
|	REPLACE '(' Translation BY Translation ',' AT BEGINING ')'	
					{ PrintDebug("replace(..., AT BEGINING)");$$=Replace($3,$5,1,0); $3=$5=NULL; }
|	REPLACE '(' Translation BY Translation ',' AT END ')'	
					{ PrintDebug("replace(..., AT END)");$$=Replace($3,$5,2,0); $3=$5=NULL; }
|	REPLACE '(' Translation BY Translation ',' AT BOTH ')'	
					{ PrintDebug("replace(...,EVERYWHERE)");$$=Replace($3,$5,3,0); $3=$5=NULL; }
|	REPLACE '(' Translation BY Translation ',' STRICT ')'	
					{ PrintDebug("replace(...)");$$=Replace($3,$5,0,1); $3=$5=NULL; }
|	REPLACE '(' Translation BY Translation ',' AT BEGINING ',' STRICT ')'	
					{ PrintDebug("replace(..., AT BEGINING)");$$=Replace($3,$5,1,1); $3=$5=NULL; }
|	REPLACE '(' Translation BY Translation ',' AT END ',' STRICT ')'	
					{ PrintDebug("replace(..., AT END)");$$=Replace($3,$5,2,1); $3=$5=NULL; }
|	REPLACE '(' Translation BY Translation ',' AT BOTH ',' STRICT ')'	
					{ PrintDebug("replace(...,EVERYWHERE)");$$=Replace($3,$5,3,1); $3=$5=NULL; }
|	REPLACEOCC '(' Translation BY Translation ',' Translation ')'	
					{ PrintDebug("replace(...,Occ)");$$=ReplaceOcc($3,$5,$7,0); $3=$5=NULL; }
|	REPLACEOCC '(' Translation BY Translation ',' Translation ',' STRICT ')'	
					{ PrintDebug("replace(...,Occ)");$$=ReplaceOcc($3,$5,$7,1); $3=$5=NULL; }
|	BFIRST '(' Translation ')'	{ PrintDebug("BFirst(...)");$$=BFirst($3,0); $3=NULL; }
|	BFIRST '(' WNUMBER ')'		{ PrintDebug("BFirst(Number)");$$=BFirst(NULL,1); }
|	BFIRST '(' WSTRING ')'		{ PrintDebug("BFirst(String)");$$=BFirst(NULL,2); }
|	EFIRST '(' Translation ')'	{ PrintDebug("EFirst(...)");$$=EFirst($3,0); $3=NULL; }
|	EFIRST '(' WNUMBER ')'		{ PrintDebug("EFirst(Number)");$$=EFirst(NULL,1); }
|	EFIRST '(' WSTRING ')'		{ PrintDebug("EFirst(String)");$$=EFirst(NULL,2); }
|	BLAST '(' Translation ')'	{ PrintDebug("BLast(...)");$$=BLast($3,0); $3=NULL; }
|	BLAST '(' WNUMBER ')'		{ PrintDebug("BLast(Number)");$$=BLast(NULL,1); }
|	BLAST '(' WSTRING ')'		{ PrintDebug("BLast(String)");$$=BLast(NULL,2); }
|	ELAST '(' Translation ')'	{ PrintDebug("ELast(...)");$$=ELast($3,0); $3=NULL; }
|	ELAST '(' WNUMBER ')'		{ PrintDebug("ELast(Number)");$$=ELast(NULL,1); }
|	ELAST '(' WSTRING ')'		{ PrintDebug("ELast(String)");$$=ELast(NULL,2); }
|	NEXT '(' CD ')'			{ PrintDebug("Next(...)");$$=Next_($3,NULL,0); $3=NULL; }
|	NEXT '(' CD ',' CD ')'		{ PrintDebug("Next(...,...)");
					  $$=Next_($3,$5,0); 
					  if (!$$) return 2;
					  $3=$5=NULL; }
|	NEXT '(' CD ',' STRICT ')'	{ PrintDebug("Next(...,STRICT)");
					  $$=Next_($3,NULL,1);
					  if (!$$) return 2; 
					  $3=NULL; }
|	NEXT '(' CD ',' CD ',' STRICT ')'
					{ PrintDebug("Next(...,...,STRICT)");
					  $$=Next_($3,$5,1); 
					  if (!$$) return 2;
					  $3=$5=NULL; }
|	LAST '(' CD ')'			{ PrintDebug("Last(...)");
					  $$=Last_($3,NULL,0); 
					  if (!$$) return 2;
					  $3=NULL; }
|	LAST '(' CD ',' CD ')'		{ PrintDebug("Last(...,...)");
					  $$=Last_($3,$5,0); 
					  if (!$$) return 2;
					  $3=$5=NULL; }
|	LAST '(' CD ',' STRICT ')'	{ PrintDebug("Last(...,STRICT)");
					  $$=Last_($3,NULL,1); 
					  if (!$$) return 2;
					  $3=NULL; }
|	LAST '(' CD ',' CD ',' STRICT ')'
					{ PrintDebug("Last(...,...,STRICT)");
					  $$=Last_($3,$5,1); 
					  if (!$$) return 2;
					  $3=$5=NULL; }
|	SORT '(' STRING ')'	{ PrintDebug("Sort");
				  MustSort($3->str);
				  FreeMem($3);
				  $3=NULL;
				  return 2;
				}
|	TABLE '(' STRING ')'		{ PrintDebug("Table(...)");$$=Table_($3); $3=NULL; }
;

%%

void PrintDebug(char*s)
 {
  FILE *fdebug;
  if (!debug_rule) return;
  fdebug=fopen("Usemarco.dbg","a");
  fprintf(fdebug,"%s\n",s);
  fclose(fdebug);
 }

/*
	Affichage d'une valeur d' Instruction
*/
char* PrintT( TypeInst* t, char* buf )
{
	if (t->str) sprintf(buf,"<%s>",t->str);
	else	    sprintf(buf,"(%d)",t->val);
	return buf;
}


/*
	Conversion de numerique en char* si necessaire pour une Instruction
*/
char* ToString( TypeInst* t )
{
	char tmp[80];
	if (t==NULL) return NULL;
	if (t->str==NULL)
	{
		sprintf(tmp,"%d",t->val);
		t->str=strdup(tmp);
	}
	return t->str;
}


/*
	Liberation de la memoire associe a une Instruction
*/
int FreeMem( TypeInst* t )
{
	if (t)
	{
		if (t->str) free(t->str);
		free(t);
	}
	return 0;
}

/*
	Copie d'instruction
*/
int Copie( TypeInst** In, TypeInst* From )
{
	*In=(TypeInst*)malloc(sizeof(TypeInst));
	if (From==NULL || From->str==NULL) (*In)->str=NULL;
	else
	{
		(*In)->str=(char*)malloc(strlen(From->str)+1);
		strcpy((*In)->str,From->str);
	}
	(*In)->val=From->val;
	return 0;
}



/*
	Comparaison de deux instructions
*/
int BoolEQ( TypeInst* t1, TypeInst* t2 )
{
	int rc;
	char b1[200], b2[200];

	if (t1->str==NULL && t2->str==NULL) rc=t1->val==t2->val;
	else rc=!strcmp(ToString(t1),ToString(t2));
	if (rc) rc=TRUE;
	else	rc=FALSE;
	if (debug_rule) printf("%s = %s => %d\n",PrintT(t1,b1), PrintT(t2,b2),rc);
	FreeMem(t1);
	FreeMem(t2);
	return rc;
}


/*
	Comparaison de contenance de deux instructions
*/
int BoolIn( TypeInst* t1, TypeInst* t2 )
{
	int rc;
	char b1[200], b2[200];

	if (strstr(ToString(t2),ToString(t1))) rc=TRUE;
	else				       rc=FALSE;
	if (debug_rule) printf("%s IN %s => %d\n",PrintT(t1,b1), PrintT(t2,b2),rc);
	FreeMem(t1);
	FreeMem(t2);
	return rc;
}


/*
	Comparaison de deux instructions
*/
int BoolGT( TypeInst* t1, TypeInst* t2 )
{
	int rc;
	char b1[200], b2[200];

	if (t1->str==NULL && t2->str==NULL) rc=t1->val-t2->val;
	else rc=strcmp(ToString(t1),ToString(t2));
	if (rc>0) rc=TRUE;
	else	rc=FALSE;
	if (debug_rule) printf("%s > %s => %d\n",PrintT(t1,b1), PrintT(t2,b2),rc);
	FreeMem(t1);
	FreeMem(t2);
	return rc;
}


/*
	Comparaison de deux instructions
*/
int BoolGE( TypeInst* t1, TypeInst* t2 )
{
	int rc;
	char b1[200], b2[200];

	if (t1->str==NULL && t2->str==NULL) rc=t1->val-t2->val;
	else rc=strcmp(ToString(t1),ToString(t2));
	if (rc>=0) rc=TRUE;
	else	rc=FALSE;
	if (debug_rule) printf("%s >= %s => %d\n",PrintT(t1,b1), PrintT(t2,b2),rc);
	FreeMem(t1);
	FreeMem(t2);
	return rc;
}


/*
	Instruction + Instruction
*/
TypeInst* Ajout( TypeInst* t1, TypeInst* t2 )
{
	TypeInst* rc;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
	if (t1->str==NULL && t2->str==NULL)
	{
		rc->str=NULL;
		rc->val=t1->val+t2->val;
	}
	else
	{
		rc->val=0;
		rc->str=(char*)malloc(strlen(ToString(t1))+
				      strlen(ToString(t2))+1);
		strcpy(rc->str,t1->str);
		strcat(rc->str,t2->str);
	}
	FreeMem(t1);
	FreeMem(t2);
	return rc;
}	

/*
	200(1)
*/
TypeInst* AjoutOcc( TypeInst* t1, TypeInst* t2 )
{
	TypeInst* rc;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
	rc->val=0;
	rc->str=(char*)malloc(strlen(ToString(t1))+strlen(ToString(t2))+3);
	sprintf(rc->str,"%s(%d)",t1->str,t2->val);
	FreeMem(t1);
	FreeMem(t2);
	return rc;
}


/*
	Instruction - Instruction
*/
TypeInst* Soust( TypeInst* t1, TypeInst* t2 )
{
	if (t1->str!=NULL || t2->str!=NULL)
	{
		yyerror("Substraction can not be done between strings");
		return NULL;
	}
	else
	{
		TypeInst* rc=(TypeInst*)malloc(sizeof(TypeInst));
		rc->str=NULL;
		rc->val=t1->val-t2->val;
		FreeMem(t1);
		FreeMem(t2);
		return rc;
	}
}	


/*
	Instruction * Instruction
*/
TypeInst* Multi( TypeInst* t1, TypeInst* t2 )
{
	if (t1->str!=NULL || t2->str!=NULL)
	{
		yyerror("Mulitiplication can not be done between strings");
		return NULL;
	}
	else
	{
		TypeInst* rc=(TypeInst*)malloc(sizeof(TypeInst));
		rc->str=NULL;
		rc->val=t1->val*t2->val;
		FreeMem(t1);
		FreeMem(t2);
		return rc;
	}
}


/*
	Instruction : Instruction
*/
TypeInst* Divis( TypeInst* t1, TypeInst* t2 )
{
	if (t1->str!=NULL || t2->str!=NULL)
	{
		yyerror("Division can not be done between strings");
		return NULL;
	}
	else
	if (t2->val==0)
	{
		yyerror("Division by 0 error");
		return NULL;
	}
	else
	{
		TypeInst* rc=(TypeInst*)malloc(sizeof(TypeInst));
		rc->str=NULL;
		rc->val=t1->val/t2->val;
		FreeMem(t1);
		FreeMem(t2);
		return rc;
	}
}

/*
	STR( Instruction )
*/
TypeInst* String( TypeInst* t )
{
	ToString(t);
	return t;
}

/*
	UPPER( Instruction )
*/
TypeInst* Upper( TypeInst* t )
{
	int i;
	ToString(t);
	for (i=0;t->str[i];++i)
		t->str[i]=(char)toupper((int)t->str[i]);
	return t;
}

/*
	LOWER( Instruction )
*/
TypeInst* Lower( TypeInst* t )
{
	int i;
	ToString(t);
	for (i=0;t->str[i];++i)
		t->str[i]=(char)tolower((int)t->str[i]);
	return t;
}


/*
	VAL( Instruction )
*/
TypeInst* Value( TypeInst* t )
{
	int i;
	char*msg;
	if (t->str==NULL) return t;
	for (i=0;t->str[i];++i) 
		if (!isdigit(t->str[i]))
		{
			msg=(char*)malloc(strlen(t->str)+50);
			sprintf(msg,"%s cannot be converted in integer",t->str);
			yyerror(msg);
			free(msg);
		}
	t->val=atoi(t->str);
	free(t->str);
	t->str=NULL;
	return t;
}	

/*
	LEN( Instruction )
*/
TypeInst* Len( TypeInst* t )
{
    char toto[100];
	
 
    TypeInst* rc=(TypeInst*)malloc(sizeof(TypeInst));
	rc->str=NULL;
	if (t->str==NULL)
	  rc->val=0;
	else   
	  rc->val=strlen(t->str);
	/*sprintf(toto,"chaine d'entree : %s %d %d",t->str,strlen(t->str),rc->val);
	PrintDebug(toto);*/
	return rc;
}
	
/*
	STO(i)
*/
int MemSto( TypeInst* n )
{
	int i=n->val;
	if (n->str!=NULL)
	{
		yyerror("Sto( String ) is not correct");
		return 0;
	}
	else
	if (n->val<0 || n->val>99)
	{
		char tmp[100];
		sprintf(tmp,"Sto(%d) is not correct",n->val);
		yyerror(tmp);
		return 0;	
	}	
	if (Memoire[i]!=NULL) FreeMem(Memoire[i]);
	Memoire[i]=NULL;
	Copie( &Memoire[i], S );
	FreeMem(n);
	return 0;
}

/*
	MEM(i)
*/
TypeInst* MemMem( TypeInst* n )
{
	int i=n->val;
	if (n->str!=NULL)
	{
		yyerror("Mem( String ) is not correct");
		return NULL;
	}
	else
	if (n->val<0 || n->val>99)
	{
		char tmp[100];
		sprintf(tmp,"Mem(%d) is not correct",n->val);
		yyerror(tmp);
		return NULL;	
	}	
	if (Memoire[i]!=NULL)
	{
		TypeInst* rc;
		Copie(&rc,Memoire[i]);
		FreeMem(n);
		return rc;
	}
	else
	{
		char tmp[100];
		sprintf(tmp,"Mem(%d) is empty",i);
		yyerror(tmp);
		return NULL;
	}
}

/*
	CLR(i)
*/
int MemClr( TypeInst* n  )
{
	int i=n->val;
	if (n->str!=NULL)
	{
		yyerror("Clr( String ) is not correct");
		return 0;
	}
	else
	if (n->val<0 || n->val>99)
	{
		char tmp[100];
		sprintf(tmp,"Clr(%d) is not correct",n->val);
		yyerror(tmp);
		return 0;	
	}	
	FreeMem(Memoire[i]);
	Memoire[i]=NULL;
	FreeMem(n);
	return 0;
}

/*
	EXC(i)
*/
TypeInst* MemExc( TypeInst* n )
{
	int i=n->val;
	if (n->str!=NULL)
	{
		yyerror("Exc( String ) is not correct");
		return NULL;
	}
	else
	if (n->val<0 || n->val>99)
	{
		char tmp[100];
		sprintf(tmp,"Exc(%d) is not correct",n->val);
		yyerror(tmp);
		return NULL;	
	}	
	if (Memoire[i]!=NULL)
	{
		TypeInst* rc=Memoire[i];
		Copie(&Memoire[i],S);
		FreeMem(n);
		return rc;
	}
	else
	{
		char tmp[100];
		sprintf(tmp,"Exc(%d) is empty",i);
		yyerror(tmp);
		return NULL;
	}
}	

/*
	FROM( translation [, STRICT] )
*/
TypeInst* From( TypeInst* t, int strict )
{
	TypeInst*rc;
	unsigned int i;

	/* Suite a la remarque no 80 */
	Value(t); 
	i=(unsigned int)(t->val-1);
	rc=(TypeInst*)malloc(sizeof(TypeInst));
	ToString(S);
	if (t->str!=NULL || i<0 || i>strlen(S->str))
	{
		rc->str=(char*)malloc(1);
		rc->str[0]=0;
	}
	else
	{
		if (!strict)
		{
			while( (unsigned char)(S->str[i])==' ' ) ++i;
		}	
		rc->str=(char*)malloc(strlen(S->str)-i+1);
		strcpy(rc->str,&S->str[i]);
	}
	rc->val=0;
	FreeMem(t);
	return rc;
}


/*
	TO( translation [, STRICT] )
*/
TypeInst* To( TypeInst* t, int strict )
{
	TypeInst*rc;
	unsigned int i;

	/* Suite a la remarque no 80 */
	Value(t); 
	i=(unsigned int)(t->val-1);
	rc=(TypeInst*)malloc(sizeof(TypeInst));
	ToString(S);
	if (t->str!=NULL || i<0 || i>strlen(S->str))
	{
		rc->str=(char*)malloc(1);
		rc->str[0]=0;
	}
	else
	{
		if (!strict)
		{
			while( (unsigned char)(S->str[i])==' ' ) --i;
		}	
		++i;
		rc->str=(char*)malloc(i+1);
		memcpy(rc->str,S->str,i);
		rc->str[i]=0;
	}
	rc->val=0;
	FreeMem(t);
	return rc;
}

/*
	BETWEEN( translation , translation [, STRICT] )
*/
TypeInst* Between( TypeInst* t1, TypeInst* t2, int strict )
{
	TypeInst *rc;
	unsigned int i1,i2;

	/* Suite a la remarque no 80 */
	Value(t1); 
	Value(t2); 
	i1=(unsigned int)(t1->val-1);
	i2=(unsigned int)(t2->val-1);
	rc=(TypeInst*)malloc(sizeof(TypeInst));
	ToString(S);
	if (t1->str!=NULL || i1<0 || i1>strlen(S->str) ||
	    t2->str!=NULL || i2<0 || i2>strlen(S->str))
	{
		rc->str=(char*)malloc(1);
		rc->str[0]=0;
	}
	else
	{

		if (!strict)
		{
			while( (unsigned char)(S->str[i1])==' ' ) ++i1;
			while( (unsigned char)(S->str[i2])==' ' ) --i2;
		}	
		++i2;
		rc->str=(char*)malloc(i2-i1+1);
		memcpy(rc->str,&S->str[i1],i2-i1);
		rc->str[i2-i1]=0;
	}
	rc->val=0;
	FreeMem(t1);
	FreeMem(t2);
	return rc;
}


/*
	DELETE( translation [, AT ...] [, STRICT] )
 replaced by REPLACE !

TypeInst* Delete( TypeInst* t1, int at, int strict )
{
	TypeInst*rc;
	TypeInst*SS;
	char* stmp;
	int i,i1,i2;
	int l,ok;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
	ToString(S);
	Copie(&SS,S);
	ToString(t1);
	l=strlen(t1->str);

	do
	{
	   ok=0;
	   switch(at)
	   {
	   case 0 :
		i=0;
		while(SS->str[i])
		{
			if (memcmp( &SS->str[i], t1->str, l )) ++i;
			else 
			{
				ok=1;
				break;
			}
		}
		break;
	
	   case 1 :
	   case 3 :
		i=0;
		if (memcmp( &SS->str[i], t1->str, l )==0) ok=1;
		break;
	   case 2 :
		i=strlen(SS->str)-l;
		if (memcmp( &SS->str[i], t1->str, l )==0) ok=1;
		break;
	   }
	

	   if (ok)
	   {
		rc->str=(char*)malloc(strlen(SS->str)-l+1);
		memcpy(rc->str,SS->str,i);
		strcpy(&rc->str[i],&SS->str[i+l]);
		free(SS->str);
		SS->str=rc->str;
	   }
           else	rc->str=strdup(SS->str);
	}
	while (ok);

	if (at==3)
	{
	    do
	    {
		ok=0;
		i=strlen(rc->str)-l;
		if (memcmp( &rc->str[i], t1->str, l )==0) 
		{
			rc->str[i]=0;
			ok=1;
		}
	    }
	    while (ok);
	}
	rc->val=0;

	i1=0;
	i2=strlen(rc->str)-1;
	if (!strict)
	{
		while( (unsigned char)(rc->str[i1])==' ' ) ++i1;
		while( (unsigned char)(rc->str[i2])==' ' ) --i2;
	}
	++i2;
	stmp=rc->str;	
	rc->str=(char*)malloc(i2-i1+1);
	memcpy(rc->str,&stmp[i1],i2-i1);
	rc->str[i2-i1]=0;
	free(stmp);
	FreeMem(t1);
	FreeMem(SS);
	return rc;
}
*/


/*
	REPLACE( translation BY translation [, AT ...] [, STRICT] )
*/
TypeInst* Replace( TypeInst* t1, TypeInst* t2, int at, int strict )
{
	TypeInst*rc;
	TypeInst*SS;
	char* stmp;
	int i,i1,i2;
	int l1,l2,ok;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
	ToString(S);
	Copie(&SS,S);
	ToString(t1);
        l1=strlen(t1->str);
	if (t2==NULL)
	{
		t2=(TypeInst*)malloc(sizeof(TypeInst));
		t2->val=0;
		t2->str=strdup("");
	}
	else	ToString(t2);
        l2=strlen(t2->str);

	if (at==2)
		i=strlen(SS->str)-l1;
	else	i=0;

	do
	{
	   ok=0;
	   switch(at)
	   {
	   case 0 :
		while(SS->str[i])
		{
			if (memcmp( &SS->str[i], t1->str, l1 )) ++i;
			else 
			{
				ok=1;
				break;
			}
		}
		break;
	
	   case 1 :
	   case 3 :
		if (memcmp( &SS->str[i], t1->str, l1 )==0) ok=1;
		break;
	   case 2 :
		if (memcmp( &SS->str[i], t1->str, l1 )==0) ok=1;
		break;
	   }
	

	   if (ok)
	   {
		rc->str=(char*)malloc(strlen(SS->str)-l1+l2+1);
		memcpy(rc->str,SS->str,i);
		strcpy(&rc->str[i],t2->str);
                strcat(rc->str,&SS->str[i+l1]);
		free(SS->str);
		SS->str=rc->str;
		if (at!=2) i+=l2;
	   }
	}
	while (ok);

	if (at==3)
	{
	    do
	    {
		ok=0;
		i=strlen(SS->str)-l1;
		if (memcmp( &SS->str[i], t1->str, l1 )==0) 
		{
			rc->str=(char*)malloc(strlen(SS->str)-l1+l2+1);
			memcpy(rc->str,SS->str,i);
			strcpy(&rc->str[i],t2->str);
			free(SS->str);
			SS->str=rc->str;
			ok=1;
		}
	    }
	    while (ok);
	}
	rc->val=0;
     	rc->str=strdup(SS->str);

	i1=0;
	i2=strlen(rc->str)-1;
	if (!strict)
	{
		while( (unsigned char)(rc->str[i1])==' ' ) ++i1;
		while( (unsigned char)(rc->str[i2])==' ' ) --i2;
	}
	++i2;
	stmp=rc->str;	
	rc->str=(char*)malloc(i2-i1+1);
	memcpy(rc->str,&stmp[i1],i2-i1);
	rc->str[i2-i1]=0;
	free(stmp);
	FreeMem(t1);
	FreeMem(t2);
	FreeMem(SS);
	return rc;
}


/*
	REPLACEOCC( translation BY translation , OCCURENCE  [, STRICT] )
*/
TypeInst* ReplaceOcc( TypeInst* t1, TypeInst* t2, TypeInst* inCondOcc, int strict )
{
	TypeInst*rc;
	TypeInst*SS;
	char* stmp;
	char CondOcc[20];
	char Signe[20];
	int  Valeur;
	int occ;
	int i,i1,i2;
	int l1,l2,ok;


	char toto[1000];

	ToString(inCondOcc);
	/* Nettoyage blancs dans inCondOcc */
	i1=i2=0;
	while(inCondOcc->str[i1])
	{
		if (inCondOcc->str[i1]!=' ')
			CondOcc[i2++]=inCondOcc->str[i1];
		++i1;
	}
	CondOcc[i2]=0;

	/* Sparation signe/valeur */
	i=0;
	while(CondOcc[i])
	{
		if (!isdigit(CondOcc[i]))
			Signe[i]=CondOcc[i];
		else break;
		++i;
	}
	Signe[i]=0;
	Valeur=atoi(&CondOcc[i]);


	rc=(TypeInst*)malloc(sizeof(TypeInst));
	ToString(S);
	Copie(&SS,S);
	ToString(t1);
    l1=strlen(t1->str);
	if (t2==NULL)
	{
		t2=(TypeInst*)malloc(sizeof(TypeInst));
		t2->val=0;
		t2->str=strdup("");
	}
	else	ToString(t2);
    l2=strlen(t2->str);

	/*sprintf(toto,"ReplaceOcc(%s by %s, %s, %d) dans <%s>",t1->str, t2->str, CondOcc, strict, SS->str);
	PrintDebug(toto);
	sprintf(toto,"%s %s %d",Signe, &CondOcc[i], Valeur);
	PrintDebug(toto);*/
	
	occ=0;
	i=0;
	while(SS->str[i])
	{
		if (memcmp( &SS->str[i], t1->str, l1 )) ++i;
		else 
		{
			occ++;
			if (((strcmp(Signe,"=")==0) && (occ==Valeur)) ||
			    ((strcmp(Signe,"!=")==0) && (occ!=Valeur)) ||
			    ((strcmp(Signe,">")==0) && (occ>Valeur)) ||
			    ((strcmp(Signe,">=")==0) && (occ>=Valeur)) ||
			    ((strcmp(Signe,"<")==0) && (occ<Valeur)) ||
			    ((strcmp(Signe,"<=")==0) && (occ<=Valeur)))
				{
						rc->str=(char*)malloc(strlen(SS->str)-l1+l2+1);
						memcpy(rc->str,SS->str,i);
						strcpy(&rc->str[i],t2->str);
						strcat(rc->str,&SS->str[i+l1]);
						free(SS->str);
						SS->str=rc->str;
						i+=l2;
				}
			else ++i;
		}
	}
		
	rc->val=0;
    rc->str=strdup(SS->str);

	i1=0;
	i2=strlen(rc->str)-1;
	if (!strict)
	{
		while( (unsigned char)(rc->str[i1])==' ' ) ++i1;
		while( (unsigned char)(rc->str[i2])==' ' ) --i2;
	}
	++i2;
	stmp=rc->str;	
	rc->str=(char*)malloc(i2-i1+1);
	memcpy(rc->str,&stmp[i1],i2-i1);
	rc->str[i2-i1]=0;
	free(stmp);
	FreeMem(t1);
	FreeMem(t2);
	FreeMem(SS);
	return rc;
}



int IsDigit( char c )
 {
  unsigned char uc=(unsigned char)c;
  return isdigit((int)uc);
 }


/*
	BFIRST( translation | ... )
*/
TypeInst* BFirst( TypeInst* t, int k )
{
	TypeInst*rc;
	int i;
	int l;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
	rc->str=NULL;
	ToString(S);

	switch(k)
	{
	case 0 :
		ToString(t);
		l=strlen(t->str);
		i=0;
		while( S->str[i] )
		{
			if (memcmp(&S->str[i],t->str,l)) ++i;
			else break;
		}
		break;

	case 1 :
		i=0;
		while( S->str[i] )
		{
			if (IsDigit(S->str[i])) break;
			else ++i;
		}
		break;

	case 2 :
		i=0;
		while( S->str[i] )
		{
			if ((unsigned char)(S->str[i])==' ' || IsDigit(S->str[i])) ++i;
			else break;
		}
		break;
	}
	if (S->str[i]) 	rc->val=i+1;
	else		rc->val=0;
	FreeMem(t);
	return rc;
}


/*
	EFIRST( translation | ... )
*/
TypeInst* EFirst( TypeInst* t, int k )
{
	TypeInst*rc;
	int i,ok;
	int l;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
	rc->str=NULL;
	ToString(S);

	ok=0;
	switch(k)
	{
	case 0 :
		ToString(t);
		l=strlen(t->str);
		i=0;
		while( S->str[i] )
		{
			if (memcmp(&S->str[i],t->str,l)) ++i;
			else 
			{
				ok=1;
				break;
			}
		}
		if (S->str[i]) i+=l;
		break;

	case 1 :
		i=0;
		while( S->str[i] )
		{
			if (IsDigit(S->str[i])) 
			{
				ok=1;
				break;
			}
			else ++i;
		}
		while( S->str[i] )
		{
			if (IsDigit(S->str[i])) ++i;
			else break;
		}
		break;

	case 2 :
		i=0;
		while( S->str[i] )
		{
			if ((unsigned char)(S->str[i])==' ' || IsDigit(S->str[i])) ++i;
			else
			{
				ok=1;
				break;
			}
		}
		while( S->str[i] )
		{
			if ((unsigned char)(S->str[i])!=' ' && !IsDigit(S->str[i])) ++i;
			else break;
		}
		break;
	}
	if (ok) 	rc->val=i+1;
	else		rc->val=0;
	FreeMem(t);
	return rc;
}


/*
	BLAST( translation | ... )
*/
TypeInst* BLast( TypeInst* t, int k )
{
	TypeInst*rc;
	int i,ok;
	int l;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
	rc->str=NULL;
	ToString(S);
	ok=0;

	switch(k)
	{
	case 0 :
		ToString(t);
		l=strlen(t->str);
		i=strlen(S->str-l);
		while( i>=0 )
		{
			if (memcmp(&S->str[i],t->str,l)) --i;
			else 
			{
				ok=1;
				break;
			}
		}
		break;

	case 1 :
		i=strlen(S->str);
		while( i>=0 )
		{
			if (IsDigit(S->str[i])) 
			{
				ok=1;
				break;
			}
			else --i;
		}
		while( i>0 )
		{
			if (IsDigit(S->str[i])) --i;
			else break;
		}
		break;

	case 2 :
		i=strlen(S->str);
		while( i>=0 )
		{
			if ((unsigned char)(S->str[i])==' ' || IsDigit(S->str[i])) --i;
			else 
			{
				ok=1;
				break;
			}
		}
		while( i>0 )
		{
			if ((unsigned char)(S->str[i])!=' ' && !IsDigit(S->str[i])) --i;
			else break;
		}
		break;
	}
	if (ok) 	rc->val=i+1;
	else		rc->val=0;
	FreeMem(t);
	return rc;
}


/*
	ELAST( translation | ... )
*/
TypeInst* ELast( TypeInst* t, int k )
{
	TypeInst*rc;
	int i;
	int l;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
	rc->str=NULL;
	ToString(S);

	switch(k)
	{
	case 0 :
		ToString(t);
		l=strlen(t->str);
		i=strlen(S->str)-l;
		while( i>=0 )
		{
			if (memcmp(&S->str[i],t->str,l)) --i;
			else break;
		}
		if (i>=0) i+=l;
		break;

	case 1 :
		i=strlen(S->str);
		while( i>=0 )
		{
			if (IsDigit(S->str[i])) break;
			else --i;
		}
		break;

	case 2 :
		i=strlen(S->str);
		while( i>=0 )
		{
			if ((unsigned char)(S->str[i])==' ' || IsDigit(S->str[i])) --i;
			else break;
		}
		break;
	}
	if (i>=0) 	rc->val=i+1;
	else		rc->val=0;
	FreeMem(t);
	return rc;
}


int FreeCD( TypeCD* CD )
{
	if (CD)
	{
		if (CD->Fixed!=NULL) free(CD->Fixed);
		free(CD);
	}
	return 0;
}


/*
	NEXT ( subfield [,subfield] [,STRICT] )
*/
TypeInst* Next_( TypeCD* cd1, TypeCD* cd2, int strict )
{
	TypeInst* rc;
        char *tempo;
        int i1,i2;

	tempo=NextSubField( cd1, cd2 );
        if (!tempo) return NULL;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
        rc->val=0;
   	if (!strict)
	{
		i1=0;i2=strlen(tempo);
		while( (unsigned char)(tempo[i1])==' ' ) ++i1;
		while( (unsigned char)(tempo[i2])==' ' ) --i2;
		++i2;
	}	
	rc->str=(char*)malloc(i2-i1+1);
	memcpy(rc->str,&tempo[i1],i2-i1);
	rc->str[i2-i1]=0;

	free(tempo);
	FreeCD(cd1);
	FreeCD(cd2);
	return rc;
}


/*
	LAST ( subfield [,subfield] [,STRICT] )
*/
TypeInst* Last_( TypeCD* cd1, TypeCD* cd2, int strict )
{
	TypeInst* rc;
        char *tempo;
        int i1,i2;

	tempo=LastSubField( cd1, cd2 );
	if (!tempo) return NULL;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
        rc->val=0;
   	if (!strict)
	{
		i1=0;i2=strlen(tempo);
		while( (unsigned char)(tempo[i1])==' ' ) ++i1;
		while( (unsigned char)(tempo[i2])==' ' ) --i2;
		++i2;
	}	
	rc->str=(char*)malloc(i2-i1+1);
	memcpy(rc->str,&tempo[i1],i2-i1);
	rc->str[i2-i1]=0;

	free(tempo);
	FreeCD(cd1);
	FreeCD(cd2);
	return rc;
}


/*
	TABLE ( subfield [,subfield] [,STRICT] )
*/
TypeInst* Table_( TypeInst* Nom )
{
	TypeInst* rc;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
	rc->str=Table( Nom->str, S->str );
	FreeMem( Nom );
	return rc;
}


/*
	NEXTSUB
*/
TypeInst* NextBal()
{
	TypeInst* rc;
    char *tempo;
    
	tempo=NextBalise();
    rc=(TypeInst*)malloc(sizeof(TypeInst));
    rc->val=0;	
	if (!tempo) 
		rc->str=strdup("");
	else 
		rc->str=tempo;

	return rc;
}

/*
	PREVIOUSSUB
*/
TypeInst* PreviousBal()
{
	TypeInst* rc;
    char *tempo;
    
	tempo=PreviousBalise();
    rc=(TypeInst*)malloc(sizeof(TypeInst));
    rc->val=0;	
	if (!tempo) 
		rc->str=strdup("");
	else 
		rc->str=tempo;

	return rc;
}