/* 
 *  USEMARCON Software - Command Line version
 *  
 *  File:  chckfile.h
 *
 *
 *  NOTE:  IN NO WAY WHATSOEVER SHOULD THIS FILE BE USED IN THE EARLIER
 *         VERSIONS OF USEMARCON SOFTWARE.
 *

CLASS
    Terror

	implements a class to error reporting

OVERVIEW TEXT
    USEMARCON Software - Command Line version
    Copyright The British Library, The USEMarcon Consortium, 1995-2000
    Adapted by Crossnet Systems Limited - British Library Contract No. BSDS 851
    
AUTHOR
    Crossnet Systems Limited

*/

#ifndef TError_H
#define TError_H 

#include "defines.h"
#include "tmpplctn.h"
          
#define MAX_NB_ERRORS     200
           #define ERROR             0
#define WARNING           1
#define FATAL             2
#define DISPLAY           3
#define FORCER            4
#define STOP              0
#define CONTINUE          1
#define BATCH             0
#define INTERACTIVE       1
#define DEFAULT_ERR_FILE_NAME        "errcodes.txt"
#define DEFAULT_LOG_FILE_NAME        "errlog.txt"
#define EMPTY_STRING                 ""
#define DEFAULT_TOO_MANY_ERRORS      100
#define SetError(ErrCode,Severity)   SetErrorCode((ErrCode),(Severity),__FILE__,__LINE__)
#define SetErrorD(ErrCode,Severity,Data) SetErrorCode((ErrCode),(Severity),__FILE__,__LINE__,(Data))

class TError
{
public:
//////////
        TError       (TUMApplication* theApplication, char *LogFileName=DEFAULT_LOG_FILE_NAME,char *ErrorCodeFileName=DEFAULT_ERR_FILE_NAME);
//////////
       ~TError                          (void);
//////////
  virtual int   ReadErrorCodeFile       (char *ErrorCodeFileName);
//////////
  virtual void  Reset                   (void)                          
               { itsErrorCode=0; };
//////////
  virtual void  CloseErrorLogFile       (void)                                  
       { fclose(itsLogError); };
//////////
  virtual int   OpenErrorLogFile        (char *Name);                           
                        
//////////
  virtual int   SetErrorCode            (int ErrorCode, short Severity, char
*FileName,int LineNumber, char *UserData=EMPTY_STRING);
//////////
  virtual void  SetMode                         (int Mode);
//////////
  virtual void  WriteError                      (char *Message);
//////////
  virtual void  SetTooManyErrors        (int max)                               
       { itsTooManyErrors = max; };
//////////
  virtual void  SetVerboseMode          (int Mode)                              
       { itsVerboseMode=Mode; };
//////////
  virtual void  SetDebugMode            (int Mode)                              
       { itsDebugMode=Mode; };
  
//////////
  virtual int   GetErrorCode            (void);
//////////
  virtual int   GetMode                         (void);
//////////
  virtual int   GetTooManyErrors        (void)                                  
       { return itsTooManyErrors; };
//////////
  virtual int   GetHowManyErrors        (void)                                  
       { return itsHowManyErrors; };
//////////
  virtual char  *GetErrorLogFileName(void)                                      
       { return itsErrorLogFileName; };
  
private:
//////////
    TUMApplication  *itsApplication;     
//////////
    FILE			*itsLogError;
//////////
    int             itsNbErrorCode;
//////////
    char            *itsErrorString[MAX_NB_ERRORS];
//////////
    int             itsErrorNumber[MAX_NB_ERRORS];
//////////
    int             itsMode;
//////////
    int             itsErrorCode;
    
protected:
//////////
    unsigned int    itsTooManyErrors;
//////////
    unsigned int    itsHowManyErrors;
//////////
    int             itsVerboseMode;
//////////
    int             itsDebugMode;
//////////
    char            itsErrorLogFileName[BUFF_SIZE+1];  
};

#ifdef _MAIN_
 TError             *ErrorHandler;
 unsigned char      *Temporary;
 unsigned char      *Temporary2;
 char               *Item;
#else 
 extern TError      *ErrorHandler;
 extern unsigned char   *Temporary;
 extern unsigned char   *Temporary2;
 extern char        *Item;
#endif 

#endif // TError_H

