/* 
 *  USEMARCON Software - Command Line version
 *  
 *  File:  chckfile.h
 *
 *
 *  NOTE:  IN NO WAY WHATSOEVER SHOULD THIS FILE BE USED IN THE EARLIER
 *         VERSIONS OF USEMARCON SOFTWARE.
 *

CLASS
    TMarcFile

	implements a class to manage MARC record files

OVERVIEW TEXT
    USEMARCON Software - Command Line version
    Copyright The British Library, The USEMarcon Consortium, 1995-2000
    Adapted by Crossnet Systems Limited - British Library Contract No. BSDS 851
    
AUTHOR
    Crossnet Systems Limited

*/

#ifndef _TMARC_FILE_H_
#define _TMARC_FILE_H_

#include "tfile.h"
#include "defines.h"
#include "umrecord.h"

class TMarcDoc;

class TMarcFile : public TFile
{
public: 
 
//////////
  					TMarcFile				(FILE_SPEC *FileSpec=NULL,char Mode=FILE_READ,char Kind=FILE_ASCII);
//////////
					~TMarcFile				(void);
//////////
  virtual int		Open					(void);
//////////
  virtual int		Close					(void);
//////////
  virtual int		Reset					(void);
//////////
  virtual int		Read					(TUMRecord *Record);
//////////
  virtual int		Write					(TUMRecord *Record);
//////////
  virtual long		GetRecordNumber			(void)					{ return NumNotice; };
  
//////////
  virtual void		SetMarcInfoFormat		(BOOLEAN theFormat)		{ itsMarcInfo.Format=theFormat; };  
//////////
  virtual void		SetMarcInfoBlockSize	(short theBlockSize)	{ itsMarcInfo.BlockSize=theBlockSize; };  
//////////
  virtual void		SetMarcInfoMinDataFree	(short theMinDataFree)	{ itsMarcInfo.MinDataFree=theMinDataFree; };  
//////////
  virtual void		SetMarcInfoPaddingChar	(char thePaddingChar)	{ itsMarcInfo.PaddingChar=thePaddingChar; };  
//////////
  virtual void		SetMarcInfoLastBlock	(BOOLEAN theLastBlock)	{ itsMarcInfo.LastBlock=theLastBlock; };  
//////////
  virtual BOOLEAN	GetMarcInfoFormat		(void)					{ return itsMarcInfo.Format; };  
//////////
  virtual short		GetMarcInfoBlockSize	(void)					{ return itsMarcInfo.BlockSize; };  
//////////
  virtual short		GetMarcInfoMinDataFree	(void)					{ return itsMarcInfo.MinDataFree; };  
//////////
//////////
  virtual char		GetMarcInfoPaddingChar	(void)					{ return itsMarcInfo.PaddingChar; }; 
//////////
  virtual BOOLEAN	GetMarcInfoLastBlock	(void)					{ return itsMarcInfo.LastBlock; };  


private:
        
//////////
  unsigned char		*Buffer;        
//////////
  unsigned long		NumNotice;
//////////
  unsigned long		PosCour;
//////////
  unsigned long		NumBloc;
//////////
  unsigned long		LngNotice;
//////////
  unsigned long		FinBloc;
//////////
  unsigned char		*Buf;
//////////
  unsigned char		FinBande[6];
//////////
  int				TB;
//////////
  unsigned short	TBuf;
//////////
  unsigned short	PBuf;
//////////
  unsigned short	Reste;
//////////
  char				EndOfFile;
//////////
  char				Eof;    
//////////
  int				lire		(unsigned short, unsigned char*);
//////////
  int				lire_scw	(char);
//////////
  int				debut_bloc	(void);
//////////
  int				ecrire		(unsigned short, unsigned char*);
//////////
  int				ecrire_scw	(short,unsigned short);
//////////
  int				val			(unsigned char*, unsigned short *);
//////////
  int				longval		(unsigned char*, unsigned long *);  


  
protected:
         
//////////
  TMarcDoc			*itsDocument;
//////////
  struct MARCINFO
   {
    BOOLEAN				Format;
    short				BlockSize;
    short				MinDataFree;
    char				PaddingChar;
    BOOLEAN				LastBlock;
   }itsMarcInfo;                         

};
#endif 

