/* 
 *  USEMARCON Software - Command Line version
 *  
 *  File:  chckfile.h
 *
 *
 *  NOTE:  IN NO WAY WHATSOEVER SHOULD THIS FILE BE USED IN THE EARLIER
 *         VERSIONS OF USEMARCON SOFTWARE.
 *

CLASS
    TMarcField

	implements a class to manage MARC fields

OVERVIEW TEXT
    USEMARCON Software - Command Line version
    Copyright The British Library, The USEMarcon Consortium, 1995-2000
    Adapted by Crossnet Systems Limited - British Library Contract No. BSDS 851
    
AUTHOR
    Crossnet Systems Limited

*/

#ifndef _TMARCFIELD_H_
#define _TMARCFIELD_H_ 

#include <stdio.h>            
#include <string.h>
                                 
class TMarcField
{

public:
//////////
				TMarcField			(void);
//////////
				TMarcField			(TMarcField*);
//////////
				~TMarcField			(void);
//////////
  int			NextSubField		(int *_Position,unsigned char* _SubField,unsigned char* _Result);
  
//////////
  char      	*GetTag				(void)			    		{ return itsTag; };
//////////
  char			*GetIndicators		(void)						{ return itsIndicators; };
//////////
  char			GetI1				(void)						{ return itsIndicators[0]; };
//////////
  char			GetI2				(void)						{ return itsIndicators[1]; };
//////////
  char			*GetLib				(void)						{ return itsLib; };
//////////
  TMarcField	*GetNextField		(void)						{ return itsNextField; };
      
//////////
  int			SetTag				(char *aTagString);
//////////
  int			SetTag				(int aTagNumber);
//////////
  int			SetIndicators		(char *theIndicators);
//////////
  int			SetI1				(char anIndicator)			{ itsIndicators[0]=anIndicator; return 0; };
//////////
  int			SetI2				(char anIndicator)			{ itsIndicators[1]=anIndicator; return 0; };  
//////////
  int			SetLib				(char *aLib);
//////////
  int			SetLib				(char *aLib,unsigned int aSize);
//////////
  TMarcField	*SetNextField		(TMarcField *theNextField)	{ itsNextField=theNextField; return itsNextField; };
       
protected:
 
//////////
  char			itsTag[4];
//////////
  char			itsIndicators[3];
//////////
  char			*itsLib;
//////////
  TMarcField	*itsNextField;
};
 
#endif




























