/* 
 *  USEMARCON Software - Command Line version
 *  
 *  File:  chckfile.h
 *
 *
 *  NOTE:  IN NO WAY WHATSOEVER SHOULD THIS FILE BE USED IN THE EARLIER
 *         VERSIONS OF USEMARCON SOFTWARE.
 *

CLASS
    TRuleFile

	implements a class to manage Rule Files

OVERVIEW TEXT
    USEMARCON Software - Command Line version
    Copyright The British Library, The USEMarcon Consortium, 1995-2000
    Adapted by Crossnet Systems Limited - British Library Contract No. BSDS 851
    
AUTHOR
    Crossnet Systems Limited

*/
#ifndef _TRULE_FILE_H_
#define _TRULE_FILE_H_

#include "defines.h"
#include "tfile.h"
#include "trule.h"
#include "codedata.h"

class TRuleFile : public TFile
{
public: 
//////////
  						TRuleFile		(FILE_SPEC *FileSpec=NULL);
//////////
                		~TRuleFile		();
//////////
  virtual int			OpenRuleFile	();
//////////
  virtual int			CloseRuleFile	();
//////////
  virtual int			SaveRuleFile	();
//////////
  virtual int			Convert			(TUMRecord *In, TUMRecord *Out); 
//////////
  virtual void			DelTreeRule		(void);
//////////
  virtual void			DelTreeCodedData(void);  
//////////
  virtual TRule			*GetFirstRule	(void)					{ return itsFirstRule; };
//////////
  virtual TCodedData	*GetCodedData	(char *theName);
//////////
  virtual void			SetFirstRule	(TRule *theRule)		{ itsFirstRule=theRule; };
 
protected:
    
//////////
  void					*itsDocument;
//////////
  TRule					*itsFirstRule;
//////////
  TCD					*itsLastInputCD;
//////////
  TCD					*itsLastOutputCD;
//////////
  TCodedData			*itsFirstCodedData; 
//////////
  TCodedData			*itsLastCodedData;   
};
#endif                 
