/* 
 *  USEMARCON Software - Command Line version
 *  
 *  File:  chckfile.h
 *
 *
 *  NOTE:  IN NO WAY WHATSOEVER SHOULD THIS FILE BE USED IN THE EARLIER
 *         VERSIONS OF USEMARCON SOFTWARE.
 *

CLASS
    TFile

	implements a class to manage file input and output

OVERVIEW TEXT
    USEMARCON Software - Command Line version
    Copyright The British Library, The USEMarcon Consortium, 1995-2000
    Adapted by Crossnet Systems Limited - British Library Contract No. BSDS 851
    
AUTHOR
    Crossnet Systems Limited

*/

#ifndef _TFILE_H_
#define _TFILE_H_
         
#include <stdio.h>
#include <fcntl.h>
#include <io.h>
#include "defines.h"

typedef struct FILE_SPEC
{
	char name[250];
	char dir[250];
	char type[4];
} FILE_SPEC;
  
#define FILE_READ	'r'
#define FILE_WRITE	'w'
#define FILE_APPEND	'a'                                                       
#define FILE_ASCII	'A'
#define FILE_BINARY	'B'

    
class TFile
 {
public: 
//////////
  						TFile(FILE_SPEC *FileInfo, char Mode=FILE_READ, char Kind=FILE_ASCII);
//////////
                		~TFile();

//////////
   virtual int			Open(void);
//////////
   virtual int			Close(void);
//////////
   virtual BOOLEAN		Exists(void);
//////////
   virtual int			NextLine(char *aLine, int aMaxLine, char *aComment=NULL, int aMaxComment=0, FILE_SPEC* Spec=NULL, int *LineNumber=NULL);
//////////
   virtual FILE_SPEC	*GetName(void);
//////////
   virtual void			SetName(FILE_SPEC *aName);
//////////
   virtual char			GetMode(void);
//////////
   virtual void			SetMode(char aMode);
//////////
   virtual char			GetKind(void);
//////////
   virtual void			SetKind(char aKind);
//////////
   virtual long			GetSize(void);    
//////////
   virtual long			GetPos(void);    

protected:
//////////
   int					itsLineNumber;
//////////
   FILE_SPEC			*itsFileInfo;
//////////
   char					itsMode;
//////////
   char					itsKind;
//////////
   FILE					*File;
//////////
   int					iFile;  
//////////
   TFile				*Included;  
//////////
   char 				itsFirstLine[BUFF_SIZE+1];
//////////
   char					itsSecondLine[BUFF_SIZE+1];
//////////
   virtual int			SkipBegining();
 };

#endif
