/* 
 *  USEMARCON Software - Command Line version
 *  
 *  File:  chckfile.h
 *
 *
 *  NOTE:  IN NO WAY WHATSOEVER SHOULD THIS FILE BE USED IN THE EARLIER
 *         VERSIONS OF USEMARCON SOFTWARE.
 *

CLASS
    TMarcRecord

	implements a class to manage MARC record

OVERVIEW TEXT
    USEMARCON Software - Command Line version
    Copyright The British Library, The USEMarcon Consortium, 1995-2000
    Adapted by Crossnet Systems Limited - British Library Contract No. BSDS 851
    
AUTHOR
    Crossnet Systems Limited

*/

#ifndef _TMARCREC_H_
#define _TMARCREC_H_
 
#include "mrcfield.h"
#include "tagnoind.h"

class TMarcRecord
{
public:
//////////
 						TMarcRecord			(void);
//////////
						TMarcRecord			(TMarcRecord*);
//////////
 						~TMarcRecord		(void);            
//////////
  virtual int			NextField			(TMarcField** Field, char *Tag); 						
//////////
  virtual int			FromString			(char *MarcString);
//////////
  virtual int			ToString			(char* marc,long max_size);
//////////
  virtual void			DelTree				(void);
//////////
  virtual int			IsItAFieldWithoutIndicator(char *tag,int IO);  
//////////
  virtual char			*GetLabel			(void)				{ return itsLabel; };
//////////
  virtual int			SetLabel			(char *aLabel);
//////////
  TMarcField			*GetFirstField		(void)				{ return itsFirstField; };
//////////
  virtual void			SetFirstField		(TMarcField *Field)	{ itsFirstField=Field; };
//////////
  TTagNoInd				*GetFirstInputTNI	(void)				{ return itsFirstInputTNI; }; 
//////////
  TTagNoInd				*GetFirstOutputTNI	(void)				{ return itsFirstOutputTNI; };
//////////
  virtual void			SetFirstInputTNI	(TTagNoInd *aTNI)	{ itsFirstInputTNI=aTNI; };   
//////////
  virtual void			SetFirstOutputTNI	(TTagNoInd *aTNI)	{ itsFirstOutputTNI=aTNI; };
//////////
  virtual void			SetIndSeparatorsID	(int IO,long ID);  
//////////
  virtual long			GetIndSeparatorsID	(int IO);  
  
private:
 
//////////
  int					Val					(char *buffer,unsigned long *valeur); 
//////////
  int					LongVal				(char *buffer,unsigned long *valeur);
//////////
  int					IsFieldWithIndicators(int IO,char *tag,char *field,unsigned long l);     
  
protected:
//////////
  char					itsLabel[25];
//////////
  TMarcField			*itsFirstField;
//////////
  TTagNoInd				*itsFirstInputTNI;
//////////
  TTagNoInd				*itsFirstOutputTNI;
//////////
  long					itsInputIndSeparatorsID;
//////////
  long					itsOutputIndSeparatorsID;  
};

#endif 
