/* 
 *  USEMARCON Software - Command Line version
 *  
 *  File:  chckfile.h
 *
 *
 *  NOTE:  IN NO WAY WHATSOEVER SHOULD THIS FILE BE USED IN THE EARLIER
 *         VERSIONS OF USEMARCON SOFTWARE.
 *

CLASS
    TRule

	implements a class to manage Rules

OVERVIEW TEXT
    USEMARCON Software - Command Line version
    Copyright The British Library, The USEMarcon Consortium, 1995-2000
    Adapted by Crossnet Systems Limited - British Library Contract No. BSDS 851
    
AUTHOR
    Crossnet Systems Limited

*/
#ifndef _TRULE_H_
#define _TRULE_H_ 
                 
#include <stdio.h>                 
#include <string.h> 
#include <stdlib.h>
#include "tcd.h"
#include "umrecord.h"

class TRule
{
public:
//////////
 				TRule			(TCD *LastInputCD=NULL, TCD *LastOutputCD=NULL);
//////////
 				TRule			(TRule *aRule);
//////////
 				~TRule			(void);
//////////
  virtual int	FromString		(char *aString, char *aComment);
//////////
  virtual int	ToString		(char *aString, char *aComment);
//////////
  virtual void	ResetComment	(void)				{ free(itsComment); itsComment=NULL; };
//////////
  virtual void	ResetLib		(void)				{ free(itsLib); itsLib=NULL; };
  
//////////
  virtual TCD	*GetInputCD		(void)				{ return itsInputCD; };
//////////
  virtual TCD	*GetOutputCD	(void)              { return itsOutputCD; };
//////////
  virtual char	*GetLib			(void)				{ return itsLib; };      
//////////
  virtual char	*GetComment		(void)				{ return itsComment; };
//////////
  virtual TRule	*GetNextRule	(void)				{ return itsNextRule; };
//////////
  virtual TRule	*GetPreviousRule(void)				{ return itsPreviousRule; };
  
//////////
  virtual int	SetInputCD		(TCD* aCD)			{ itsInputCD=aCD; return 0; };
//////////
  virtual int	SetOutputCD		(TCD *aCD)			{ itsOutputCD=aCD; return 0; };
//////////
  virtual int	SetLib			(char *aLib);
//////////
  virtual int	SetComment		(char *aComment);
//////////
  virtual int	SetNextRule		(TRule *NextRule)	{ itsNextRule=NextRule; return 0; };
//////////
  virtual int	SetPreviousRule	(TRule *PreviousRule)	{ itsPreviousRule=PreviousRule; return 0; };
                                                       
protected:

//////////
  TCD			*itsInputCD;
//////////
  TCD			*itsOutputCD;
//////////
  TCD			*itsLastInputCD;
//////////
  TCD			*itsLastOutputCD;
//////////
  char			*itsLib;
//////////
  char			*itsComment;
//////////
  TRule			*itsNextRule;
//////////
  TRule			*itsPreviousRule;       
};

#endif 
