/*  
 *  USEMARCON Software - Command Line version
 *  Copyright The British Library, The USEMarcon Consortium, 1995-2000
 *  Adapted by Crossnet Systems Limited - British Library Contract No. BSDS 851
 *  
 *  File:  cstartup.cpp
 *
 *  The main() component of the application
 *
 *  NOTE:  IN NO WAY WHATSOEVER SHOULD THIS FILE BE USED IN THE EARLIER
 *         VERSIONS OF USEMARCON SOFTWARE.
 *
 *  Rev history:
 *  17 Aug 2000 -  version raised to v1.1 
	- will not exit if the input or output checking files are not present 
		in the .ini file.
	- ensures any temporary files are deleted on graceful exit

    March 2000 - code built into a library file, called by a test program.


 */


#include <afx.h>
#include <afxcoll.h>

#include "xvtstuff.h"

#include "error.h"
#include "tools.h"

#include "defines.h"
#include "tmpplctn.h"
      
#include "truledoc.h"
#include "dtcnfdlg.h"

// John Hough
#include "cstartup.h"

int               itsArgc;
char            **itsArgv;


// John Hough - additions
TMarcDoc *g_itsDocument = NULL;
TypeInst *g_D;

#include "ytab.h"

extern "C" {
extern int FreeMem( TypeInst* t );
YYSTYPE	yylval;
};


// John Hough
#define OBJECT_DEFS // this line should only appear once in the application before #include "objectlist.h"
#include "objectlist.h"



// John Hough - function prototypes
void origmain( int argc, char** argv );

TUMApplication *g_theApplication;

// John Hough - original main() ...changed name to batchmain() and return type from int to void
void begin( int argc, char** argv )
{

	itsArgc = argc;
	itsArgv = argv;
 
	TUMApplication theApplication;
	g_theApplication = &theApplication;

	if (myrun.GetReadMarcRecordsFromBexFile())
	{
		/* sign on message */
		printf("USEMarcon - MARC record converter\n");
		printf("Win32 Standalone Library Batch version 1.2\n");
		printf("Adapted by Crossnet Systems Limited under contract to The British Library\n");
		printf("Copyright 2001 - The British Library, The USEMarcon Consortium\n");
		printf("\n");
	}

	// John Hough
	yylval.inst = NULL;

	if (yylval.inst)
		{
				if (yylval.inst->str)
					free(yylval.inst->str);

				free(yylval.inst);
			}


	theApplication.StartUp();

	// John Hough
	return;
	
}


