/* 
 *  USEMARCON Software - Command Line version
 *  
 *  File:  chckfile.h
 *
 *
 *  NOTE:  IN NO WAY WHATSOEVER SHOULD THIS FILE BE USED IN THE EARLIER
 *         VERSIONS OF USEMARCON SOFTWARE.
 *

CLASS
    TUMApplication

	implements the parent class for the application

OVERVIEW TEXT
    USEMARCON Software - Command Line version
    Copyright The British Library, The USEMarcon Consortium, 1995-2000
    Adapted by Crossnet Systems Limited - British Library Contract No. BSDS 851
    
AUTHOR
    Crossnet Systems Limited

*/

#ifndef TUMApplication_H
#define TUMApplication_H

#include "defines.h"
#include "tfile.h"
#include "truledoc.h"
#include "tmarcdoc.h"
#include "tchckdoc.h"
#include "ttrnsdoc.h"

class TUMApplication 
{
public:
//////////
                        TUMApplication        (void);
//////////
                        ~TUMApplication       (void);
//////////
  virtual void          StartUp               (void);

  // John Hough - addition
  void					LoadIniFileDetails();

  //////////
  virtual void          StartBatch            (void);

  // John Hough
  virtual void          Convert            (void);
  virtual void          End            (void);

  //////////
  virtual int           DoConvertWrite        (void);  
//////////
  virtual void          convert_file_spec_to_str(FILE_SPEC *theFileSpec,char *theString);
                                              
//////////
  virtual void          SetMarcDoc 
(TMarcDoc *aDoc)        { itsMarcDoc=aDoc; };
//////////
  virtual void          SetCheckDoc                            
(TCheckDoc *aDoc)       { itsCheckDoc=aDoc; };
//////////
  virtual void          SetRuleDoc                             
(TRuleDoc *aDoc)        { itsRuleDoc=aDoc; };             
//////////
  virtual void          SetTransDoc                            
(TTransDoc *aDoc)       { itsTransDoc=aDoc; };             
//////////
  virtual void          SetCloseRequest       (BOOLEAN isClosed)
{ itsCloseRequest=isClosed; };
  
//////////
  virtual TMarcDoc      *GetMarcDoc           (void)  
{ return itsMarcDoc; }; 
//////////
  virtual TCheckDoc     *GetCheckDoc          (void)                  
{ return itsCheckDoc; };
//////////
  virtual TRuleDoc      *GetRuleDoc           (void)  
{ return itsRuleDoc; };
//////////
  virtual TTransDoc     *GetTransDoc          (void)                  
{ return itsTransDoc; };
//////////
  virtual int           GetExecutionMode      (void)          
{ return itsExecutionMode; };

//////////
  char					itsStartupDir[150];
//////////
  TRuleDoc              *itsRuleDoc;        

 
private:
//////////
  char                  itsIniFile[BUFF_SIZE+1];
//////////
  int                   itsExecutionMode;
//////////
  BOOLEAN               itsStopRequest;
//////////
  BOOLEAN               itsCloseRequest;
//////////
  long                  itsMarcInputNumero;  
//////////
  long                  itsMarcOutputOk;  
//////////
  long                  itsMarcOutputKo;  
//////////
  TMarcDoc              *itsMarcDoc;
//////////
  TCheckDoc             *itsCheckDoc;
//////////
  TTransDoc             *itsTransDoc;

};

#endif

