/*  
 *  USEMARCON Software - Command Line version
 *  Copyright The British Library, The USEMarcon Consortium, 1995-2000
 *  Adapted by Crossnet Systems Limited - British Library Contract No. BSDS 851
 *  
 *  File:  tools.cpp
 *
 *  implements a set of string management functions
 *
 *  NOTE:  IN NO WAY WHATSOEVER SHOULD THIS FILE BE USED IN THE EARLIER
 *         VERSIONS OF USEMARCON SOFTWARE.
 *
 */
#include <afx.h>

#include "tools.h"

///////////////////////////////////////////////////////////////////////////////
//
// RemoveSpace
//
/////////////////////////////////////////////////////////////////////////////// 
int RemoveSpace(char *String,int where)
{
 int		CurrentPos=0,
                LastPos,
 		MaxPos=strlen(String); 
 char * tmp_string = NULL;

 if (!MaxPos) return 0;
 		
 LastPos=MaxPos-1;
 for (LastPos; LastPos>=0 && (isspace(String[LastPos]) || String[LastPos]=='\t'); --LastPos)
  ;
 if (LastPos<0)
  {
   *String=0;
   return 0;
  }

 if (where&AT_BEGINING)
 // Remove all spaces at begining
  {
   for (CurrentPos; CurrentPos<MaxPos && (isspace(String[CurrentPos]) || String[CurrentPos]=='\t'); CurrentPos++ )
    ;
   tmp_string = (char *)(malloc (strlen(&String[CurrentPos]) + 1));
   strcpy (tmp_string, &String[CurrentPos]);
   strcpy(String,tmp_string);
   free(tmp_string);
   if (MaxPos)  MaxPos-=CurrentPos;
   if (LastPos) LastPos-=CurrentPos;
  } 
  
 if (where&INSIDE)
 // Remove all spaces inside the string
  {
   for (CurrentPos; CurrentPos && (isspace(String[CurrentPos]) || String[CurrentPos]=='\t'); CurrentPos++)
    ;
   for (CurrentPos; CurrentPos<LastPos; CurrentPos++)
    if (isspace(String[CurrentPos]) || String[CurrentPos]=='\t')
     {
	  tmp_string = (char *)(malloc (strlen(&String[CurrentPos+1]) + 1));
      strcpy (tmp_string, &String[CurrentPos+1]);
      strcpy(&String[CurrentPos],tmp_string);
	  free(tmp_string);
      if (LastPos) LastPos--;
      if (MaxPos)  MaxPos--;
      CurrentPos--;
     }
   }

 if (where&AT_END)
 // Remove all spaces at end
  { 	
   String[LastPos+1]=0;
   MaxPos=LastPos+1;		
  }

 return MaxPos; 
}

///////////////////////////////////////////////////////////////////////////////
//
// InsertChar
//
/////////////////////////////////////////////////////////////////////////////// 
int InsertChar(char *entree,int *lg_entree,int position,char *caracteres,int code)
{
 int i,j,decal,decalage;
 
 decal=strlen(caracteres);
 decalage=decal-code;
 for (j=*lg_entree;j>=position+code;j--)
  entree[j+decalage]=entree[j];
 for (i=0; i<decal; i++) 
  entree[position++]=caracteres[i];
 (*lg_entree)+=decal;
 return(decal);
}

///////////////////////////////////////////////////////////////////////////////
//
// ToUpperCase
//
///////////////////////////////////////////////////////////////////////////////   
int ToUpperCase(char *String)
{
 int		CurrentPos;
 int		MaxPos=strlen(String);
 
 for (CurrentPos=0; CurrentPos<MaxPos; CurrentPos++)
  String[CurrentPos]=(char)toupper((int)String[CurrentPos]);
  
 return 0;  
} 

///////////////////////////////////////////////////////////////////////////////
//
// CodeHexaToChar
//
///////////////////////////////////////////////////////////////////////////////
int CodeHexaToChar(char *String)
{
 int	iLongueur;
 int	iPosEntree;
 int	iPosSortie=0;
 char	sSortie[100];
 char	sCodeHexa[5];
 long	lChar; 

 sSortie[iPosSortie]=0;
 iLongueur=strlen(String);
 // Recherche d'un code Hexa ( introduit par '0x' )
 for (iPosEntree=0; iPosEntree<iLongueur; iPosEntree++)
  if (!memcmp(&String[iPosEntree],"0x",2))
   {
    // chaine '0x' trouvee ==> il s'agit d'un code Hexa uniquement si
    // deux caractres au moins suivent, sinon il s'agit simplement de
    // '0' et de 'x' en tant que caracteres propres.
    memcpy(sCodeHexa,&String[iPosEntree],4);
    sCodeHexa[4]=0;
    if (strlen(sCodeHexa)==4)
     // '0x' introduit bien un code Hexa ==> conversion en caractere.
     {
      sscanf(&sCodeHexa[2],"%x",&lChar);
      sprintf(&sSortie[iPosSortie++],"%c",lChar);
      iPosEntree+=3;
     }
    else
     // '0x' n'est a considerer que comme une chaine composee des deux
     // carateres '0' et 'x' ==> rien a faire.
     sSortie[iPosSortie++]=String[iPosEntree];
   }
  else
   // carateres normal ==> rien a faire.
   sSortie[iPosSortie++]=String[iPosEntree];
 sSortie[iPosSortie]=0;
 strcpy(String,sSortie);
 return 0;
}
