/* 
 *  USEMARCON Software - Command Line version
 *  
 *  File:  chckfile.h
 *
 *
 *  NOTE:  IN NO WAY WHATSOEVER SHOULD THIS FILE BE USED IN THE EARLIER
 *         VERSIONS OF USEMARCON SOFTWARE.
 *

CLASS
    TRuleDoc

	implements a class to manage Rule files

OVERVIEW TEXT
    USEMARCON Software - Command Line version
    Copyright The British Library, The USEMarcon Consortium, 1995-2000
    Adapted by Crossnet Systems Limited - British Library Contract No. BSDS 851
    
AUTHOR
    Crossnet Systems Limited

*/

#ifndef TRuleDoc_H
#define TRuleDoc_H
#include "rulefile.h"
                      

class TRuleDoc 
{
public:

//////////
 						TRuleDoc		();
//////////
  virtual				~TRuleDoc	(void);
//////////
  virtual BOOLEAN		DoOpen			(void);
  
//////////
  virtual BOOLEAN		Open			(void);    
//////////
  virtual BOOLEAN		OpenRuleFile		(char *DefaultFile);
  
  
//////////
  virtual TRuleFile		*GetFile		(void)	{ return itsFile; };
//////////
  virtual FILE_SPEC		*GetRuleSpec		(void)	{ return itsRuleSpec; };
//////////
  virtual char			*GetInputFormat		(void)	{ return itsInputFormat; };
//////////
  virtual char			*GetOutputFormat	(void)	{ return itsOutputFormat; };
//////////
  virtual void			SetInputFormat			(char * aFormat)	{ itsInputFormat=strdup(aFormat); };  
//////////
  virtual void			SetOutputFormat			(char * aFormat)	{ itsOutputFormat=strdup(aFormat); };

private:
   
//////////
  TRuleFile			*itsFile;

//////////
  FILE_SPEC			*itsRuleSpec;
//////////
  FILE_SPEC			*itsXVTFilePointer;
//////////
  char				*itsInputFormat;
//////////
  char				*itsOutputFormat;

};

#endif

