/*  
 *  USEMARCON Software - Command Line version
 *  Copyright The British Library, The USEMarcon Consortium, 1995-2000
 *  Adapted by Crossnet Systems Limited - British Library Contract No. BSDS 851
 *  
 *  File:  ttrnsdoc.cpp
 *
 *  implements a class to manage file transcoding files
 *
 *  NOTE:  IN NO WAY WHATSOEVER SHOULD THIS FILE BE USED IN THE EARLIER
 *         VERSIONS OF USEMARCON SOFTWARE.
 *
 */

#include <afx.h>
#include "error.h"
#include "xvtstuff.h"

#include "defines.h"
#include "ttrnsdoc.h"
#include "tmpplctn.h"


extern TUMApplication *g_theApplication;


///////////////////////////////////////////////////////////////////////////////
//
// Document class constructor
//
// Create and initialize the internal data objects for this class
//
///////////////////////////////////////////////////////////////////////////////
TTransDoc::TTransDoc( ) 
{
 itsFile 		= NULL;
 itsTransSpec	= NULL;  
 itsXVTFilePointer	= NULL;  
}

///////////////////////////////////////////////////////////////////////////////
//
// Document class destructor
//
// Delete the internal data objects for this class
//
///////////////////////////////////////////////////////////////////////////////
TTransDoc::~TTransDoc( void )
{ 
 g_theApplication -> SetTransDoc( NULL );
 if (itsFile) 		{ delete itsFile; 		itsFile			= NULL; }

	// John Hough - added delete 
	if (itsTransSpec)
		delete itsTransSpec;
}



///////////////////////////////////////////////////////////////////////////////
//
// Open
//
// Called by DoOpen().  Do the actual work of restoring the object from
// a data source.
//
///////////////////////////////////////////////////////////////////////////////
BOOLEAN TTransDoc::Open(void)
{
 // Add code here to set internal data members of the class based
 // on information read from some data source 
 if ((itsFile=new TTransFile(itsXVTFilePointer))==NULL)
  {
   ErrorHandler->SetError(9013,ERROR);
   return FALSE;
  }  
 if (itsFile->Open())
  {
   delete itsFile;
   itsFile = NULL;
   return FALSE;
  } 
 return TRUE; 
}



///////////////////////////////////////////////////////////////////////////////
//
// OpenTransFile
//
///////////////////////////////////////////////////////////////////////////////       
BOOLEAN TTransDoc::OpenTransFile(char *DefaultFile)
{
 int			Result;
 char			*ItemPointer; 
 
 if (!itsXVTFilePointer)
  itsXVTFilePointer = new FILE_SPEC;
 memset(itsXVTFilePointer,0,sizeof(FILE_SPEC)); 
 if (DefaultFile)
 // The Transcoding character table has already been selectionned
  {     
   if ((ItemPointer=(char *)strrchr(DefaultFile,SLASH))!=NULL)
    {
     strcpy(itsXVTFilePointer->name,ItemPointer+1);      
     itsXVTFilePointer->type[0]=0;
     *ItemPointer = NULL;
     xvt_fsys_convert_str_to_dir(DefaultFile,itsXVTFilePointer->dir);
    }                                                           
   else
    { 
     strcpy(itsXVTFilePointer->name,DefaultFile);
     itsXVTFilePointer->type[0]=0;            
     xvt_fsys_get_dir(itsXVTFilePointer->dir);
    }
   Result=FL_OK;
  }
  
 switch(Result)  
  {
   case FL_OK:						// a Trans file has been selected
    if (Open()!=TRUE)
     return FALSE;      
    itsTransSpec = itsXVTFilePointer;
    return TRUE;
    break;
   case FL_CANCEL:


    return TRUE;
    break;
   case FL_BAD:
   default:


    return FALSE;
  }
}     




























