/*  
 *  USEMARCON Software - Command Line version
 *  Copyright The British Library, The USEMarcon Consortium, 1995-2000
 *  Adapted by Crossnet Systems Limited - British Library Contract No. BSDS 851
 *  
 *  File:  xvtstuff.cpp
 *
 *  implements a set of functions that emulate expected behaviour from
 *  those that were formally in the XVT libraries
 *
 *  NOTE:  IN NO WAY WHATSOEVER SHOULD THIS FILE BE USED IN THE EARLIER
 *         VERSIONS OF USEMARCON SOFTWARE.
 *
 */

#include  <afx.h>
#include "xvtstuff.h"
#include <direct.h>
#include <stdlib.h>
#include <stdio.h>


#include "error.h"
#include "tools.h"

#include "defines.h"
#include "tmpplctn.h"
      
#include "truledoc.h"
                  
#include "dtcnfdlg.h"
       



extern TUMApplication *g_theApplication; 



/* get the current directory, and copy into the string */       
void xvt_fsys_get_dir(char* mydir) 
{

	char	thisdir[150];

	_getcwd(thisdir, 149);
	strcpy(mydir, thisdir);
	strcat(mydir, "\\");

}
	

/* set the dir value */
void xvt_fsys_set_dir(char *mydir ) 
{

	if (*mydir != NULL) {
		if (strlen(mydir) > 0) {
			_chdir(mydir);
		}
	}

}



/* convert a string to a dir */
void xvt_fsys_convert_str_to_dir(char * str, char * dir) 
{

	char *tmp;
	char *ItemPointer;

	tmp = (char *)(malloc(strlen(str) + 4));
	strcpy(tmp, str);
	if (tmp[strlen(tmp)] != SLASH) {
		strcat(tmp, "\\");
	}
	ItemPointer=(char *)strrchr((char*)tmp,SLASH);
	ItemPointer[0] = '\0';
	strcpy (dir, tmp);
	free(tmp);

};

	
/* convert a dir to a string */
void xvt_fsys_convert_dir_to_str(char * dir, char *str, int buffsize)
{

	strcpy(str, dir);


}





/* set the directory to that the program started up in */
void xvt_fsys_set_dir_startup() 
{

	_chdir(g_theApplication->itsStartupDir);

}


/* returns true or false on test condition */
BOOLEAN xvt_fsys_get_file_attr(FILE_SPEC *fspec,int condition) 
{

	BOOLEAN retval;
	FILE	*fp;
	char	*thisfile;

	thisfile = (char *)(malloc(strlen(fspec->dir) + strlen(fspec->name) + strlen(fspec->type) + 4));
	switch (condition) {

		/* does the file exist */
	case XVT_FILE_ATTR_EXIST:
		strcpy(thisfile, fspec->dir);
		if (fspec->dir[strlen(fspec->dir)] !=SLASH) strcat(thisfile, "\\");
		strcat(thisfile, fspec->name);
		strcat(thisfile, fspec->type);
		fp = fopen(thisfile, "r");
		if (fp == NULL) {
			retval =  FALSE;
		} else {
			fclose(fp);
			retval = TRUE;
		}
		break;


	default:
		retval = FALSE;

		break;

	}

	free(thisfile);
	return retval;
}


/* pots a decision message to the screen */
int xvt_dm_post_ask(char * option1, char* option2, char *message) 
{ 
	int		choice = 0;
	char	str[100];
/*  note this is the code that this should perform - but to avoid screen 
    interaction simply return 0
	while (choice < 1 || choice > 2) {
		printf("\n%s \nplease enter 1 to %s,  or 2 to %s :", message, option1, option2);

		choice = atoi(gets(str));
	}
	if (choice == 1) return RESP_1;

	return RESP_2;
*/
  return 0;
}





/* display a warning */	
int xvt_dm_post_warning(char *Message)
{
	printf("%s\n", Message);	
	return 0;
}


/* display a message to the user */
int xvt_dm_post_note(char *Message) 
{ 
	
	printf("Message: %s\n", Message);
	
	return 0;
}

