/* c:\usemar~1\sources\yacc -d analyse.y */
#ifdef YYTRACE
#define YYDEBUG 1
#else
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#endif
/*
 * Portable way of defining ANSI C prototypes
 */
#ifndef YY_ARGS
#if __STDC__
#define YY_ARGS(x)	x
#else
#define YY_ARGS(x)	()
#endif
#endif

#if YYDEBUG
typedef struct yyNamedType_tag {	/* Tokens */
	char	* name;		/* printable name */
	short	token;		/* token # */
	short	type;		/* token type */
} yyNamedType;
typedef struct yyTypedRules_tag {	/* Typed rule table */
	char	* name;		/* compressed rule string */
	short	type;		/* rule result type */
} yyTypedRules;

#endif

#line 1 "analyse.y"

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>
#include <time.h>
#include "typedef.h"

extern int debug_rule;
extern TypeInst* S;
extern TypeInst* T;
extern TypeInst* D;
extern TypeCD* CDIn;

extern TypeInst* N;
extern TypeInst* NT;
extern TypeInst* NS;
extern TypeInst* NO;
extern TypeInst* NSO;
extern TypeInst* NTO;

char tempo[1000];
int  RedoFlag;
extern unsigned long ordinal;

#define TRUE  1
#define FALSE 0

TypeInst* Memoire[100];

#include "fonc.h"
extern char* Table( char*, char* );
extern int   MustSort( char* );

void PrintDebug(char*);

typedef union {
	int   code;
	TypeInst* inst; 
	TypeCD*   tcd;
} YYSTYPE;
#define SEP	257
#define FIN	258
#define WNUMBER	259
#define WSTRING	260
#define PLUS	261
#define MOINS	262
#define MULTIPLIE	263
#define DIVISE	264
#define EQ	265
#define NE	266
#define IN	267
#define GT	268
#define LT	269
#define GE	270
#define LE	271
#define EXISTS	272
#define PRECEDES	273
#define FOLLOWS	274
#define IF	275
#define THEN	276
#define ELSE	277
#define AND	278
#define OR	279
#define NOT	280
#define BY	281
#define STRICT	282
#define AT	283
#define BEGINING	284
#define END	285
#define BOTH	286
#define VARS	287
#define STRING	288
#define NUMERIC	289
#define VAR_N	290
#define VAR_NT	291
#define VAR_NS	292
#define VAR_NO	293
#define VAR_NTO	294
#define VAR_NSO	295
#define TAG	296
#define STAG	297
#define FIX	298
#define I1	299
#define I2	300
#define STR	301
#define VAL	302
#define LEN	303
#define STO	304
#define MEM	305
#define EXC	306
#define CLR	307
#define LOWER	308
#define UPPER	309
#define FROM	310
#define TO	311
#define BETWEEN	312
#define DELETE	313
#define REPLACE	314
#define REPLACEOCC	315
#define BFIRST	316
#define EFIRST	317
#define BLAST	318
#define ELAST	319
#define REDO	320
#define SORT	321
#define NEXT	322
#define LAST	323
#define TABLE	324
#define ORDINAL	325
#define YEAR	326
#define MONTH	327
#define DAY	328
#define HOUR	329
#define MINUTE	330
#define SECOND	331
#define NEXTBAL	332
#define PREVIOUSBAL	333
extern int yychar, yyerrflag;
extern YYSTYPE yylval;



#if YYDEBUG
enum YY_Types { YY_t_NoneDefined, YY_t_code, YY_t_inst, YY_t_tcd
};
#endif
#if YYDEBUG
yyTypedRules yyRules[] = {
	{ "&00: %01 &00",  0},
	{ "%01: %02",  2},
	{ "%02: %03",  2},
	{ "%02: &06 %03",  2},
	{ "%03: %04 &03",  2},
	{ "%03: %04 &02 &03",  2},
	{ "%04: %04 &02 %04",  2},
	{ "%04: %05",  2},
	{ "%05: %06",  2},
	{ "%05: %07",  2},
	{ "%05: &65",  2},
	{ "%08: %09",  3},
	{ "%08: %09 %10",  3},
	{ "%08: %09 &43",  3},
	{ "%08: %09 %10 &43",  3},
	{ "%08: %10",  3},
	{ "%08: &43",  3},
	{ "%08: %10 &43",  3},
	{ "%09: &41",  3},
	{ "%09: &41 &79 %07 &80",  3},
	{ "%10: &42",  3},
	{ "%10: &42 &79 %07 &80",  3},
	{ "%10: &44",  3},
	{ "%10: &45",  3},
	{ "%06: &20 %11 &21 %07",  2},
	{ "%06: &20 %11 &21 %07 &22 %07",  2},
	{ "%11: &79 %11 &80",  1},
	{ "%11: %11 &23 %11",  1},
	{ "%11: %11 &24 %11",  1},
	{ "%11: &25 %11",  1},
	{ "%11: %07 &10 %07",  1},
	{ "%11: %07 &11 %07",  1},
	{ "%11: %07 &12 %07",  1},
	{ "%11: %07 &13 %07",  1},
	{ "%11: %07 &14 %07",  1},
	{ "%11: %07 &15 %07",  1},
	{ "%11: %07 &16 %07",  1},
	{ "%11: &17 &79 %08 &80",  1},
	{ "%11: %08 &18 %08",  1},
	{ "%11: %08 &19 %08",  1},
	{ "%07: &79 %07 &80",  2},
	{ "%07: &33",  2},
	{ "%07: &34",  2},
	{ "%07: &71",  2},
	{ "%07: &72",  2},
	{ "%07: &73",  2},
	{ "%07: &74",  2},
	{ "%07: &75",  2},
	{ "%07: &76",  2},
	{ "%07: &70 &79 %07 &80",  2},
	{ "%07: &77",  2},
	{ "%07: &78",  2},
	{ "%07: &35",  2},
	{ "%07: &36",  2},
	{ "%07: &37",  2},
	{ "%07: &38",  2},
	{ "%07: &39",  2},
	{ "%07: &40",  2},
	{ "%07: &32",  2},
	{ "%07: %08",  2},
	{ "%07: %07 &06 %07",  2},
	{ "%07: %07 &07 %07",  2},
	{ "%07: %07 &08 %07",  2},
	{ "%07: %07 &09 %07",  2},
	{ "%07: &46 &79 %07 &80",  2},
	{ "%07: &47 &79 %07 &80",  2},
	{ "%07: &48 &79 %07 &80",  2},
	{ "%07: &54 &79 %07 &80",  2},
	{ "%07: &53 &79 %07 &80",  2},
	{ "%07: &49 &79 %07 &80",  2},
	{ "%07: &50 &79 %07 &80",  2},
	{ "%07: &51 &79 %07 &80",  2},
	{ "%07: &52 &79 %07 &80",  2},
	{ "%07: &55 &79 %07 &80",  2},
	{ "%07: &55 &79 %07 &81 &27 &80",  2},
	{ "%07: &56 &79 %07 &80",  2},
	{ "%07: &56 &79 %07 &81 &27 &80",  2},
	{ "%07: &57 &79 %07 &81 %07 &80",  2},
	{ "%07: &57 &79 %07 &81 %07 &81 &27 &80",  2},
	{ "%07: &58 &79 %07 &80",  2},
	{ "%07: &58 &79 %07 &81 &28 &29 &80",  2},
	{ "%07: &58 &79 %07 &81 &28 &30 &80",  2},
	{ "%07: &58 &79 %07 &81 &28 &31 &80",  2},
	{ "%07: &58 &79 %07 &81 &27 &80",  2},
	{ "%07: &58 &79 %07 &81 &28 &29 &81 &27 &80",  2},
	{ "%07: &58 &79 %07 &81 &28 &30 &81 &27 &80",  2},
	{ "%07: &58 &79 %07 &81 &28 &31 &81 &27 &80",  2},
	{ "%07: &59 &79 %07 &26 %07 &80",  2},
	{ "%07: &59 &79 %07 &26 %07 &81 &28 &29 &80",  2},
	{ "%07: &59 &79 %07 &26 %07 &81 &28 &30 &80",  2},
	{ "%07: &59 &79 %07 &26 %07 &81 &28 &31 &80",  2},
	{ "%07: &59 &79 %07 &26 %07 &81 &27 &80",  2},
	{ "%07: &59 &79 %07 &26 %07 &81 &28 &29 &81 &27 &80",  2},
	{ "%07: &59 &79 %07 &26 %07 &81 &28 &30 &81 &27 &80",  2},
	{ "%07: &59 &79 %07 &26 %07 &81 &28 &31 &81 &27 &80",  2},
	{ "%07: &60 &79 %07 &26 %07 &81 %07 &80",  2},
	{ "%07: &60 &79 %07 &26 %07 &81 %07 &81 &27 &80",  2},
	{ "%07: &61 &79 %07 &80",  2},
	{ "%07: &61 &79 &04 &80",  2},
	{ "%07: &61 &79 &05 &80",  2},
	{ "%07: &62 &79 %07 &80",  2},
	{ "%07: &62 &79 &04 &80",  2},
	{ "%07: &62 &79 &05 &80",  2},
	{ "%07: &63 &79 %07 &80",  2},
	{ "%07: &63 &79 &04 &80",  2},
	{ "%07: &63 &79 &05 &80",  2},
	{ "%07: &64 &79 %07 &80",  2},
	{ "%07: &64 &79 &04 &80",  2},
	{ "%07: &64 &79 &05 &80",  2},
	{ "%07: &67 &79 %08 &80",  2},
	{ "%07: &67 &79 %08 &81 %08 &80",  2},
	{ "%07: &67 &79 %08 &81 &27 &80",  2},
	{ "%07: &67 &79 %08 &81 %08 &81 &27 &80",  2},
	{ "%07: &68 &79 %08 &80",  2},
	{ "%07: &68 &79 %08 &81 %08 &80",  2},
	{ "%07: &68 &79 %08 &81 &27 &80",  2},
	{ "%07: &68 &79 %08 &81 %08 &81 &27 &80",  2},
	{ "%07: &66 &79 &33 &80",  2},
	{ "%07: &69 &79 &33 &80",  2},
{ "$accept",  0},{ "error",  0}
};
yyNamedType yyTokenTypes[] = {
	{ "$end",  0,  0},
	{ "error",  256,  0},
	{ "SEP",  257,  1},
	{ "FIN",  258,  1},
	{ "WNUMBER",  259,  1},
	{ "WSTRING",  260,  1},
	{ "PLUS",  261,  1},
	{ "MOINS",  262,  1},
	{ "MULTIPLIE",  263,  1},
	{ "DIVISE",  264,  1},
	{ "EQ",  265,  1},
	{ "NE",  266,  1},
	{ "IN",  267,  1},
	{ "GT",  268,  1},
	{ "LT",  269,  1},
	{ "GE",  270,  1},
	{ "LE",  271,  1},
	{ "EXISTS",  272,  1},
	{ "PRECEDES",  273,  1},
	{ "FOLLOWS",  274,  1},
	{ "IF",  275,  1},
	{ "THEN",  276,  1},
	{ "ELSE",  277,  1},
	{ "AND",  278,  1},
	{ "OR",  279,  1},
	{ "NOT",  280,  1},
	{ "BY",  281,  1},
	{ "STRICT",  282,  1},
	{ "AT",  283,  1},
	{ "BEGINING",  284,  1},
	{ "END",  285,  1},
	{ "BOTH",  286,  1},
	{ "VARS",  287,  2},
	{ "STRING",  288,  2},
	{ "NUMERIC",  289,  2},
	{ "VAR_N",  290,  2},
	{ "VAR_NT",  291,  2},
	{ "VAR_NS",  292,  2},
	{ "VAR_NO",  293,  2},
	{ "VAR_NTO",  294,  2},
	{ "VAR_NSO",  295,  2},
	{ "TAG",  296,  2},
	{ "STAG",  297,  2},
	{ "FIX",  298,  2},
	{ "I1",  299,  2},
	{ "I2",  300,  2},
	{ "STR",  301,  2},
	{ "VAL",  302,  2},
	{ "LEN",  303,  2},
	{ "STO",  304,  2},
	{ "MEM",  305,  2},
	{ "EXC",  306,  2},
	{ "CLR",  307,  2},
	{ "LOWER",  308,  2},
	{ "UPPER",  309,  2},
	{ "FROM",  310,  2},
	{ "TO",  311,  2},
	{ "BETWEEN",  312,  2},
	{ "DELETE",  313,  2},
	{ "REPLACE",  314,  2},
	{ "REPLACEOCC",  315,  2},
	{ "BFIRST",  316,  2},
	{ "EFIRST",  317,  2},
	{ "BLAST",  318,  2},
	{ "ELAST",  319,  2},
	{ "REDO",  320,  2},
	{ "SORT",  321,  2},
	{ "NEXT",  322,  2},
	{ "LAST",  323,  2},
	{ "TABLE",  324,  2},
	{ "ORDINAL",  325,  2},
	{ "YEAR",  326,  2},
	{ "MONTH",  327,  2},
	{ "DAY",  328,  2},
	{ "HOUR",  329,  2},
	{ "MINUTE",  330,  2},
	{ "SECOND",  331,  2},
	{ "NEXTBAL",  332,  2},
	{ "PREVIOUSBAL",  333,  2},
	{ "'('",  40,  0},
	{ "')'",  41,  0},
	{ "','",  44,  0}

};
#endif
static short yydef[] = {

	   7,    6,    5,    3,  120,   -1,   79,    4,   12,   19, 
	  18,   17,   16,   15,   14,   13,   11,   10,    8,    9
};
static short yyex[] = {

	   0,    0,   -1,    1
};
static short yyact[] = {

	-163, -160, -162, -249, -287, -288, -255, -254, -253, -252, 
	-251, -250,   -2,   -1, -275, -271, -270, -165, -166, -167, 
	-170, -171, -172, -173, -169, -168, -174, -175, -176, -177, 
	-178, -179, -180, -181, -182, -183, -278, -186, -184, -185, 
	-187, -164, -264, -263, -262, -261, -260, -259, -257, -256, 
	 333,  332,  331,  330,  329,  328,  327,  326,  325,  324, 
	 323,  322,  321,  320,  319,  318,  317,  316,  315,  314, 
	 313,  312,  311,  310,  309,  308,  307,  306,  305,  304, 
	 303,  302,  301,  300,  299,  298,  297,  296,  295,  294, 
	 293,  292,  291,  290,  289,  288,  287,  275,  261,   40, 
	-159,   40, -158,   40, -157,   40, -156,   40, -155,   40, 
	-154,   40, -153,   40, -152,   40, -151,   40, -150,   40, 
	-149,   40, -148,   40, -147,   40, -146,   40, -145,   40, 
	-144,   40, -143,   40, -142,   40, -141,   40, -140,   40, 
	-139,   40, -138,   40, -137,   40, -136,   40, -163, -249, 
	-287, -288, -255, -254, -253, -252, -251, -250,   -2,   -1, 
	-275, -271, -270, -165, -166, -167, -170, -171, -172, -173, 
	-169, -168, -174, -175, -176, -177, -178, -179, -180, -181, 
	-182, -183, -186, -184, -185, -187, -164, -264, -263, -262, 
	-261, -260, -259, -257, -256,  333,  332,  331,  330,  329, 
	 328,  327,  326,  325,  324,  323,  322,  321,  319,  318, 
	 317,  316,  315,  314,  313,  312,  311,  310,  309,  308, 
	 307,  306,  305,  304,  303,  302,  301,  300,  299,  298, 
	 297,  296,  295,  294,  293,  292,  291,  290,  289,  288, 
	 287,   40, -131, -134, -132, -249, -287, -288, -255, -254, 
	-253, -252, -251, -250,   -2,   -1, -275, -271, -270, -165, 
	-166, -167, -170, -171, -172, -173, -169, -168, -174, -175, 
	-176, -177, -178, -179, -180, -181, -182, -183, -186, -184, 
	-185, -187, -164, -264, -263, -262, -261, -260, -259, -257, 
	-256,  333,  332,  331,  330,  329,  328,  327,  326,  325, 
	 324,  323,  322,  321,  319,  318,  317,  316,  315,  314, 
	 313,  312,  311,  310,  309,  308,  307,  306,  305,  304, 
	 303,  302,  301,  300,  299,  298,  297,  296,  295,  294, 
	 293,  292,  291,  290,  289,  288,  287,  280,  272,   40, 
	-129,   40, -128,   40, -274,  298,   -1, -277, -271, -270, 
	 300,  299,  298,  297, -124, -125, -126, -127,  264,  263, 
	 262,  261, -123, -283,  258,  257, -163, -162, -249, -287, 
	-288, -255, -254, -253, -252, -251, -250,   -2,   -1, -275, 
	-271, -270, -165, -166, -167, -170, -171, -172, -173, -169, 
	-168, -174, -175, -176, -177, -178, -179, -180, -181, -182, 
	-183, -278, -186, -184, -185, -187, -164, -264, -263, -262, 
	-261, -260, -259, -257, -256,  333,  332,  331,  330,  329, 
	 328,  327,  326,  325,  324,  323,  322,  321,  320,  319, 
	 318,  317,  316,  315,  314,  313,  312,  311,  310,  309, 
	 308,  307,  306,  305,  304,  303,  302,  301,  300,  299, 
	 298,  297,  296,  295,  294,  293,  292,  291,  290,  289, 
	 288,  287,  275,   40, -122,  288, -121,  288,   -2,   -1, 
	-275, -271, -270,  300,  299,  298,  297,  296, -163, -117, 
	-118, -249, -287, -288, -255, -254, -253, -252, -251, -250, 
	  -2,   -1, -275, -271, -270, -165, -166, -167, -170, -171, 
	-172, -173, -169, -168, -174, -175, -176, -177, -178, -179, 
	-180, -181, -182, -183, -186, -184, -185, -187, -164, -264, 
	-263, -262, -261, -260, -259, -257, -256,  333,  332,  331, 
	 330,  329,  328,  327,  326,  325,  324,  323,  322,  321, 
	 319,  318,  317,  316,  315,  314,  313,  312,  311,  310, 
	 309,  308,  307,  306,  305,  304,  303,  302,  301,  300, 
	 299,  298,  297,  296,  295,  294,  293,  292,  291,  290, 
	 289,  288,  287,  260,  259,   40, -163, -114, -115, -249, 
	-287, -288, -255, -254, -253, -252, -251, -250,   -2,   -1, 
	-275, -271, -270, -165, -166, -167, -170, -171, -172, -173, 
	-169, -168, -174, -175, -176, -177, -178, -179, -180, -181, 
	-182, -183, -186, -184, -185, -187, -164, -264, -263, -262, 
	-261, -260, -259, -257, -256,  333,  332,  331,  330,  329, 
	 328,  327,  326,  325,  324,  323,  322,  321,  319,  318, 
	 317,  316,  315,  314,  313,  312,  311,  310,  309,  308, 
	 307,  306,  305,  304,  303,  302,  301,  300,  299,  298, 
	 297,  296,  295,  294,  293,  292,  291,  290,  289,  288, 
	 287,  260,  259,   40, -163, -111, -112, -249, -287, -288, 
	-255, -254, -253, -252, -251, -250,   -2,   -1, -275, -271, 
	-270, -165, -166, -167, -170, -171, -172, -173, -169, -168, 
	-174, -175, -176, -177, -178, -179, -180, -181, -182, -183, 
	-186, -184, -185, -187, -164, -264, -263, -262, -261, -260, 
	-259, -257, -256,  333,  332,  331,  330,  329,  328,  327, 
	 326,  325,  324,  323,  322,  321,  319,  318,  317,  316, 
	 315,  314,  313,  312,  311,  310,  309,  308,  307,  306, 
	 305,  304,  303,  302,  301,  300,  299,  298,  297,  296, 
	 295,  294,  293,  292,  291,  290,  289,  288,  287,  260, 
	 259,   40, -163, -108, -109, -249, -287, -288, -255, -254, 
	-253, -252, -251, -250,   -2,   -1, -275, -271, -270, -165, 
	-166, -167, -170, -171, -172, -173, -169, -168, -174, -175, 
	-176, -177, -178, -179, -180, -181, -182, -183, -186, -184, 
	-185, -187, -164, -264, -263, -262, -261, -260, -259, -257, 
	-256,  333,  332,  331,  330,  329,  328,  327,  326,  325, 
	 324,  323,  322,  321,  319,  318,  317,  316,  315,  314, 
	 313,  312,  311,  310,  309,  308,  307,  306,  305,  304, 
	 303,  302,  301,  300,  299,  298,  297,  296,  295,  294, 
	 293,  292,  291,  290,  289,  288,  287,  260,  259,   40, 
	-265, -124, -125, -126, -127,  264,  263,  262,  261,   41, 
	 -89,  -90,  274,  273,  -88,   40, -124, -125, -126, -127, 
	 -81,  -82,  -83,  -84,  -85,  -86,  -87,  271,  270,  269, 
	 268,  267,  266,  265,  264,  263,  262,  261,  -76,  -77, 
	 -78,  279,  278,  276, -276,  298, -163, -284, -162, -249, 
	-287, -288, -255, -254, -253, -252, -251, -250,   -2,   -1, 
	-275, -271, -270, -165, -166, -167, -170, -171, -172, -173, 
	-169, -168, -174, -175, -176, -177, -178, -179, -180, -181, 
	-182, -183, -278, -186, -184, -185, -187, -164, -264, -263, 
	-262, -261, -260, -259, -257, -256,  333,  332,  331,  330, 
	 329,  328,  327,  326,  325,  324,  323,  322,  321,  320, 
	 319,  318,  317,  316,  315,  314,  313,  312,  311,  310, 
	 309,  308,  307,  306,  305,  304,  303,  302,  301,  300, 
	 299,  298,  297,  296,  295,  294,  293,  292,  291,  290, 
	 289,  288,  287,  275,  258,   40, -189,   41, -190,   41, 
	-194,  -73,   44,   41, -198,  -72,   44,   41, -199,   41, 
	-200,   41, -201, -124, -125, -126, -127,  264,  263,  262, 
	 261,   41, -202,   41, -203,   41, -204, -124, -125, -126, 
	-127,  264,  263,  262,  261,   41, -205,   41, -206,   41, 
	-207, -124, -125, -126, -127,  264,  263,  262,  261,   41, 
	-208,   41, -209,   41, -210, -124, -125, -126, -127,  264, 
	 263,  262,  261,   41, -124, -125, -126, -127,  -71,  281, 
	 264,  263,  262,  261, -124, -125, -126, -127,  -70,  281, 
	 264,  263,  262,  261, -228,  -69, -124, -125, -126, -127, 
	 264,  263,  262,  261,   44,   41,  -68, -124, -125, -126, 
	-127,  264,  263,  262,  261,   44, -232,  -67, -124, -125, 
	-126, -127,  264,  263,  262,  261,   44,   41, -234,  -66, 
	-124, -125, -126, -127,  264,  263,  262,  261,   44,   41, 
	-235, -124, -125, -126, -127,  264,  263,  262,  261,   41, 
	-236, -124, -125, -126, -127,  264,  263,  262,  261,   41, 
	-237, -124, -125, -126, -127,  264,  263,  262,  261,   41, 
	-238, -124, -125, -126, -127,  264,  263,  262,  261,   41, 
	-239, -124, -125, -126, -127,  264,  263,  262,  261,   41, 
	-240, -124, -125, -126, -127,  264,  263,  262,  261,   41, 
	-241, -124, -125, -126, -127,  264,  263,  262,  261,   41, 
	-242, -124, -125, -126, -127,  264,  263,  262,  261,   41, 
	-243, -124, -125, -126, -127,  264,  263,  262,  261,   41, 
	-258, -124, -125, -126, -127,  264,  263,  262,  261,   41, 
	 -77,  -78,  279,  278, -265, -124, -125, -126, -127,  -81, 
	 -82,  -83,  -84,  -85,  -86,  -87,  271,  270,  269,  268, 
	 267,  266,  265,  264,  263,  262,  261,   41, -269,  -77, 
	 -78,  279,  278,   41, -272, -124, -125, -126, -127,  264, 
	 263,  262,  261,   41, -273, -124, -125, -126, -127,  264, 
	 263,  262,  261,   41,  -63,   -2,   -1, -275, -271, -270, 
	 300,  299,  298,  297,  296,  282,  -61,   -2,   -1, -275, 
	-271, -270,  300,  299,  298,  297,  296,  282,  -57,  -56, 
	 283,  282,  -54,  282,  -53,  282, -268,   41, -124, -125, 
	-126, -127,  -52,  277,  264,  263,  262,  261, -192,   41, 
	-193,  -51,   44,   41, -196,   41, -197,  -50,   44,   41, 
	 -49, -124, -125, -126, -127,  264,  263,  262,  261,   44, 
	-220,  -48, -124, -125, -126, -127,  264,  263,  262,  261, 
	  44,   41, -224,   41,  -45,  -46,  -47,  286,  285,  284, 
	-230,  -44, -124, -125, -126, -127,  264,  263,  262,  261, 
	  44,   41, -231,   41, -233,   41,  -43,  282,  -42,  282, 
	 -40,  -39,  283,  282, -225,  -38,   44,   41, -226,  -37, 
	  44,   41, -227,  -36,   44,   41,  -35,  282, -191,   41, 
	-195,   41, -212,  -34, -124, -125, -126, -127,  264,  263, 
	 262,  261,   44,   41, -216,   41,  -31,  -32,  -33,  286, 
	 285,  284,  -30,  282,  -29,  282,  -28,  282, -229,   41, 
	 -27,  282, -217,  -26,   44,   41, -218,  -25,   44,   41, 
	-219,  -24,   44,   41, -221,   41, -222,   41, -223,   41, 
	-211,   41,  -23,  282,  -22,  282,  -21,  282, -213,   41, 
	-214,   41, -215,   41,   -1
};
static short yypact[] = {

	 341,  343,  345,  350,  358,  464,  882,  915, 1252,  358, 
	 358,  358,  358,  358,  358,  358, 1252, 1252, 1343,  358, 
	1493, 1491, 1489, 1487, 1485, 1483, 1481, 1479, 1477, 1475, 
	1472, 1468, 1464, 1461, 1459, 1457, 1455, 1453, 1449, 1445, 
	1438, 1431, 1429, 1427, 1424, 1420, 1416, 1412,  195, 1409, 
	1407,  195, 1405, 1403, 1396, 1387, 1383, 1376, 1365, 1358, 
	1355, 1352, 1349,  415, 1337, 1335, 1333,  195, 1330,  195, 
	 195, 1322, 1310, 1299, 1289,  195,  291,  291, 1281, 1266, 
	 195,  195,  195,  195,  195,  195,  195,  473,  473,  473, 
	1245, 1235, 1225, 1215, 1205, 1195, 1185, 1175, 1165, 1155, 
	1144, 1132, 1121, 1110, 1099, 1089, 1079, 1073, 1071, 1065, 
	1059, 1057, 1051, 1045, 1043, 1037, 1031, 1029, 1026, 1022, 
	1019, 1017,  966,  195,  195,  195,  195,  195,  195,  911, 
	 291,  291,  897,  885,  875,  195,  195,  195,  195,  195, 
	 195,  195,  195,  195,  195,  195,  195,  195,  195,  195, 
	 195,  821,  723,  625,  527,  473,  473,  467,  465,  415, 
	 364,  291,  195,  147,  145,  143,  141,  139,  137,  135, 
	 133,  131,  129,  127,  125,  123,  121,  119,  117,  115, 
	 113,  111,  109,  107,  105,  103,  101,   50
};
static short yygo[] = {

	  -6, -282, -280, -281,  159, -285, -285, -161,  122,   63, 
	-279, -286,  -41,  -20,  -55,  -58,  -59,  -19, -133, -133, 
	 -16,  -15,  -14,  -13,  -12,  -11,  -10, -247, -246, -245, 
	-244,  -74,  -75,  -80, -133,  -91,  -92,  -93,  -94,  -95, 
	 -96,  -97,  -98,  -99, -100, -101, -102, -103, -104, -105, 
	-106, -107, -110, -113, -116, -133, -135,   -5,  162,  161, 
	 154,  153,  152,  151,  150,  149,  148,  147,  146,  145, 
	 144,  143,  142,  141,  140,  139,  138,  137,  136,  135, 
	 131,  130,  128,  127,  126,  125,  124,  123,   86,   85, 
	  84,   83,   82,   81,   80,   77,   76,   75,   70,   69, 
	  67,   51,   48,  -60,  -62,   -7,   -7,  -65, -267, -266, 
	  -7,   -7, -119, -120,   -7, -248,  161,  156,  155,  131, 
	 130,   89,   88,   87,   77,   76,   72,   71,   -4,   -8, 
	  -3,    3,  -18,  -17,  -79,   -9, -130,  131,  130,   77, 
	  76,   -1
};
static short yypgo[] = {

	   0,    0,    0,  115,  115,  115,  128,  130,   11,   11, 
	 136,  136,  136,  136,  136,  136,  136,  136,  136,  136, 
	  57,   57,   57,   57,   57,   57,   57,   57,   57,   57, 
	  57,   57,   57,   57,   57,   57,   57,   57,   57,   57, 
	  57,   57,   57,   57,   57,   57,   57,   57,   57,   57, 
	  57,   57,   57,   57,   57,   57,   57,   57,   57,   57, 
	  57,   57,   57,   57,   57,   57,   57,   57,   57,   57, 
	  57,   57,   57,   57,   57,   57,   57,   57,   57,   57, 
	  57,   57,   57,   57,   57,   57,   57,   57,   57,   57, 
	  57,   57,   57,   57,   57,   57,   57,  136,  136,  136, 
	 136,  130,  130,  130,  128,  115,  115,  115,  115,   10, 
	   7,    1,    1,    0,    3,    3,    7,   10,   57,   57, 
	  10,    0
};
static short yyrlen[] = {

	   0,    0,    0,    1,    2,    1,    1,    1,    4,    6, 
	   3,    3,    2,    3,    3,    3,    3,    3,    3,    3, 
	   4,    4,    8,    6,    6,    4,    8,    6,    6,    4, 
	   4,    4,    4,    4,    4,    4,    4,    4,    4,    4, 
	   4,    4,   10,    8,   11,   11,   11,    8,    9,    9, 
	   9,    6,    9,    9,    9,    6,    7,    7,    7,    4, 
	   8,    6,    6,    4,    6,    4,    4,    4,    4,    4, 
	   4,    4,    4,    4,    4,    3,    3,    3,    3,    1, 
	   1,    1,    1,    1,    1,    1,    1,    1,    1,    4, 
	   1,    1,    1,    1,    1,    1,    3,    3,    3,    4, 
	   3,    1,    1,    4,    4,    2,    1,    3,    2,    1, 
	   1,    2,    1,    1,    2,    3,    3,    1,    1,    1, 
	   1,    2
};
#define YYS0	187
#define YYDELTA	168
#define YYNPACT	188
#define YYNDEF	20

#define YYr119	0
#define YYr120	1
#define YYr121	2
#define YYr11	3
#define YYr12	4
#define YYr15	5
#define YYr18	6
#define YYr20	7
#define YYr24	8
#define YYr25	9
#define YYr27	10
#define YYr28	11
#define YYr29	12
#define YYr30	13
#define YYr31	14
#define YYr32	15
#define YYr33	16
#define YYr34	17
#define YYr35	18
#define YYr36	19
#define YYr118	20
#define YYr117	21
#define YYr116	22
#define YYr115	23
#define YYr114	24
#define YYr113	25
#define YYr112	26
#define YYr111	27
#define YYr110	28
#define YYr109	29
#define YYr108	30
#define YYr107	31
#define YYr106	32
#define YYr105	33
#define YYr104	34
#define YYr103	35
#define YYr102	36
#define YYr101	37
#define YYr100	38
#define YYr99	39
#define YYr98	40
#define YYr97	41
#define YYr96	42
#define YYr95	43
#define YYr94	44
#define YYr93	45
#define YYr92	46
#define YYr91	47
#define YYr90	48
#define YYr89	49
#define YYr88	50
#define YYr87	51
#define YYr86	52
#define YYr85	53
#define YYr84	54
#define YYr83	55
#define YYr82	56
#define YYr81	57
#define YYr80	58
#define YYr79	59
#define YYr78	60
#define YYr77	61
#define YYr76	62
#define YYr75	63
#define YYr74	64
#define YYr73	65
#define YYr72	66
#define YYr71	67
#define YYr70	68
#define YYr69	69
#define YYr68	70
#define YYr67	71
#define YYr66	72
#define YYr65	73
#define YYr64	74
#define YYr63	75
#define YYr62	76
#define YYr61	77
#define YYr60	78
#define YYr59	79
#define YYr58	80
#define YYr57	81
#define YYr56	82
#define YYr55	83
#define YYr54	84
#define YYr53	85
#define YYr52	86
#define YYr51	87
#define YYr50	88
#define YYr49	89
#define YYr48	90
#define YYr47	91
#define YYr46	92
#define YYr45	93
#define YYr44	94
#define YYr43	95
#define YYr40	96
#define YYr39	97
#define YYr38	98
#define YYr37	99
#define YYr26	100
#define YYr23	101
#define YYr22	102
#define YYr21	103
#define YYr19	104
#define YYr17	105
#define YYr16	106
#define YYr14	107
#define YYr13	108
#define YYr10	109
#define YYr7	110
#define YYr3	111
#define YYr2	112
#define YYr1	113
#define YYrACCEPT	YYr119
#define YYrERROR	YYr120
#define YYrLR2	YYr121
#if YYDEBUG
char * yysvar[] = {
	"$accept",
	"Program",
	"Rules",
	"Rule",
	"SetOfInstr",
	"Instruction",
	"Condition",
	"Translation",
	"CD",
	"TAGOCC",
	"STAGOCC",
	"Boolean",
	0
};
short yyrmap[] = {

	 119,  120,  121,   11,   12,   15,   18,   20,   24,   25, 
	  27,   28,   29,   30,   31,   32,   33,   34,   35,   36, 
	 118,  117,  116,  115,  114,  113,  112,  111,  110,  109, 
	 108,  107,  106,  105,  104,  103,  102,  101,  100,   99, 
	  98,   97,   96,   95,   94,   93,   92,   91,   90,   89, 
	  88,   87,   86,   85,   84,   83,   82,   81,   80,   79, 
	  78,   77,   76,   75,   74,   73,   72,   71,   70,   69, 
	  68,   67,   66,   65,   64,   63,   62,   61,   60,   59, 
	  58,   57,   56,   55,   54,   53,   52,   51,   50,   49, 
	  48,   47,   46,   45,   44,   43,   40,   39,   38,   37, 
	  26,   23,   22,   21,   19,   17,   16,   14,   13,   10, 
	   7,    3,    2,    1,    4,    5,    6,    8,   41,   42, 
	   9,    0
};
short yysmap[] = {

	  47,   48,   50,   51,   53,   60,   86,   96,  147,  202, 
	 203,  204,  205,  206,  207,  208,  210,  211,  212,  246, 
	 284,  283,  282,  276,  274,  272,  271,  269,  268,  267, 
	 266,  265,  264,  261,  258,  256,  254,  252,  251,  250, 
	 249,  248,  247,  242,  241,  240,  239,  236,  235,  233, 
	 230,  228,  226,  225,  224,  223,  222,  221,  220,  219, 
	 218,  217,  216,  215,  201,  187,  185,  184,  182,  181, 
	 180,  166,  164,  154,  153,  152,  151,  150,  149,  148, 
	 146,  145,  144,  143,  142,  141,  140,  139,  138,  137, 
	 135,  134,  133,  132,  131,  130,  129,  128,  127,  126, 
	 125,  124,  123,  122,  121,  120,  119,  118,  117,  116, 
	 115,  114,  113,  112,  111,  110,  109,  108,  107,  106, 
	 105,  104,  101,  100,   99,   98,   97,   93,   92,   91, 
	  90,   89,   88,   87,   85,   84,   83,   82,   81,   80, 
	  79,   78,   77,   76,   75,   74,   73,   72,   71,   70, 
	  69,   68,   67,   66,   65,   64,   63,   62,   61,   57, 
	  56,   44,   43,   34,   23,   22,   21,   20,   19,   18, 
	  17,   16,   15,   14,   13,   12,   11,   10,    9,    8, 
	   7,    6,    5,    4,    3,    2,    1,    0,  162,  163, 
	 259,  229,  231,  165,  260,  232,  234,  167,  168,  169, 
	 170,  171,  172,  173,  174,  175,  176,  177,  178,  179, 
	 281,  262,  285,  286,  287,  263,  273,  275,  277,  237, 
	 278,  279,  280,  238,  253,  255,  257,  183,  270,  243, 
	 244,  186,  245,  188,  189,  190,  191,  192,  193,  194, 
	 195,  196,  197,  156,  157,  158,  159,   24,   25,   26, 
	  27,   28,   29,   30,   31,   32,   33,  198,   35,   36, 
	  37,   38,   39,   40,  136,  199,  200,  227,  209,   45, 
	  46,  213,  214,   94,   49,  155,   95,   52,   55,  103, 
	  58,   59,  102,  161,  160,   54,   42,   41
};
int yyntoken = 82;
int yynvar = 12;
int yynstate = 288;
int yynrule = 122;
#endif

#if YYDEBUG
/*
 * Package up YACC context for tracing
 */
typedef struct yyTraceItems_tag {
	int	state, lookahead, errflag, done;
	int	rule, npop;
	short	* states;
	int	nstates;
	YYSTYPE * values;
	int	nvalues;
	short	* types;
} yyTraceItems;
#endif

#line 2 "/etc/yyparse.c"

/*
 * Copyright 1985, 1990 by Mortice Kern Systems Inc.  All rights reserved.
 * 
 * Automaton to interpret LALR(1) tables.
 *
 * Macros:
 *	yyclearin - clear the lookahead token.
 *	yyerrok - forgive a pending error
 *	YYERROR - simulate an error
 *	YYACCEPT - halt and return 0
 *	YYABORT - halt and return 1
 *	YYRETURN(value) - halt and return value.  You should use this
 *		instead of return(value).
 *	YYREAD - ensure yychar contains a lookahead token by reading
 *		one if it does not.  See also YYSYNC.
 *	YYRECOVERING - 1 if syntax error detected and not recovered
 *		yet; otherwise, 0.
 *
 * Preprocessor flags:
 *	YYDEBUG - includes debug code if 1.  The parser will print
 *		 a travelogue of the parse if this is defined as 1
 *		 and yydebug is non-zero.
 *		yacc -t sets YYDEBUG to 1, but not yydebug.
 *	YYTRACE - turn on YYDEBUG, and undefine default trace functions
 *		so that the interactive functions in 'ytrack.c' will
 *		be used.
 *	YYSSIZE - size of state and value stacks (default 150).
 *	YYSTATIC - By default, the state stack is an automatic array.
 *		If this is defined, the stack will be static.
 *		In either case, the value stack is static.
 *	YYALLOC - Dynamically allocate both the state and value stacks
 *		by calling malloc() and free().
 *	YYSYNC - if defined, yacc guarantees to fetch a lookahead token
 *		before any action, even if it doesnt need it for a decision.
 *		If YYSYNC is defined, YYREAD will never be necessary unless
 *		the user explicitly sets yychar = -1
 *
 * Copyright (c) 1983, by the University of Waterloo
 */
/*
 * Prototypes
 */

extern int yylex YY_ARGS((void));

#if YYDEBUG

#include <stdlib.h>		/* common prototypes */
#include <string.h>

extern char *	yyValue YY_ARGS((YYSTYPE, int));	/* print yylval */
extern void yyShowState YY_ARGS((yyTraceItems *));
extern void yyShowReduce YY_ARGS((yyTraceItems *));
extern void yyShowGoto YY_ARGS((yyTraceItems *));
extern void yyShowShift YY_ARGS((yyTraceItems *));
extern void yyShowErrRecovery YY_ARGS((yyTraceItems *));
extern void yyShowErrDiscard YY_ARGS((yyTraceItems *));

extern void yyShowRead YY_ARGS((int));
#endif

/*
 * If YYDEBUG defined and yydebug set,
 * tracing functions will be called at appropriate times in yyparse()
 * Pass state of YACC parse, as filled into yyTraceItems yyx
 * If yyx.done is set by the tracing function, yyparse() will terminate
 * with a return value of -1
 */
#define YY_TRACE(fn) { \
	yyx.state = yystate; yyx.lookahead = yychar; yyx.errflag =yyerrflag; \
	yyx.states = yys+1; yyx.nstates = yyps-yys; \
	yyx.values = yyv+1; yyx.nvalues = yypv-yyv; \
	yyx.types = yytypev+1; yyx.done = 0; \
	yyx.rule = yyi; yyx.npop = yyj; \
	fn(&yyx); \
	if (yyx.done) YYRETURN(-1); }

#ifndef I18N
#define	gettext(x)	x
#endif

#ifndef YYSSIZE
# define YYSSIZE	1000
#endif

#define YYERROR		goto yyerrlabel
#define yyerrok		yyerrflag = 0
#if YYDEBUG
#define yyclearin	{ if (yydebug) yyShowRead(-1); yychar = -1; }
#else
#define yyclearin	yychar = -1
#endif
#define YYACCEPT	YYRETURN(0)
#define YYABORT		YYRETURN(1)
#define YYRECOVERING()	(yyerrflag != 0)
#ifdef YYALLOC
# define YYRETURN(val)	{ retval = (val); goto yyReturn; }
#else
# define YYRETURN(val)	return(val)
#endif
#if YYDEBUG
/* The if..else makes this macro behave exactly like a statement */
# define YYREAD	if (yychar < 0) {					\
			if ((yychar = yylex()) < 0)			\
				yychar = 0;				\
			if (yydebug)					\
				yyShowRead(yychar);			\
		} else
#else
# define YYREAD	if (yychar < 0) {					\
			if ((yychar = yylex()) < 0)			\
				yychar = 0;				\
		} else
#endif

#define YYERRCODE	256		/* value of `error' */
#define	YYQYYP	yyq[yyq-yyp]

YYSTYPE	yyval;				/* $ */
YYSTYPE	*yypvt;				/* $n */
YYSTYPE	yylval;				/* yylex() sets this */

int	yychar,				/* current token */
	yyerrflag,			/* error flag */
	yynerrs;			/* error count */

#if YYDEBUG
int yydebug = 0;		/* debug if this flag is set */
extern char	*yysvar[];	/* table of non-terminals (aka 'variables') */
extern yyNamedType yyTokenTypes[];	/* table of terminals & their types */
extern short	yyrmap[], yysmap[];	/* map internal rule/states */
extern int	yynstate, yynvar, yyntoken, yynrule;

extern int	yyGetType YY_ARGS((int));	/* token type */
extern char	*yyptok YY_ARGS((int));	/* printable token string */
extern int	yyExpandName YY_ARGS((int, int, char *, int));
				  /* expand yyRules[] or yyStates[] */
static char *	yygetState YY_ARGS((int));

#define yyassert(condition, msg, arg) \
	if (!(condition)) { \
		printf(gettext("\nyacc bug: ")); \
		printf(msg, arg); \
		YYABORT; }
#else /* !YYDEBUG */
#define yyassert(condition, msg, arg)
#endif

#line 499 "analyse.y"
void PrintDebug(char*s)
 {
  FILE *fdebug;
  if (!debug_rule) return;
  fdebug=fopen("Usemarco.dbg","a");
  fprintf(fdebug,"%s\n",s);
  fclose(fdebug);
 }

/*
	Affichage d'une valeur d' Instruction
*/
char* PrintT( TypeInst* t, char* buf )
{
	if (t->str) sprintf(buf,"<%s>",t->str);
	else	    sprintf(buf,"(%d)",t->val);
	return buf;
}


/*
	Conversion de numerique en char* si necessaire pour une Instruction
*/
char* ToString( TypeInst* t )
{
	char tmp[80];
	if (t==NULL) return NULL;
	if (t->str==NULL)
	{
		sprintf(tmp,"%d",t->val);
		t->str=strdup(tmp);
	}
	return t->str;
}


/*
	L  iberation de la memoire associe a une Instruction
*/
int FreeMem( TypeInst* t )
{
	int a;

	// John Hough tester
	
	if (t)
	{
		if (t->str) free(t->str);

		free(t);
	}
	
	return 0;
		
  

}

/*
	Copie d'instruction
*/
int Copie( TypeInst** In, TypeInst* From )
{
	*In=(TypeInst*)malloc(sizeof(TypeInst));
	if (From==NULL || From->str==NULL) (*In)->str=NULL;
	else
	{
		(*In)->str=(char*)malloc(strlen(From->str)+1);
		strcpy((*In)->str,From->str);
	}
	(*In)->val=From->val;
	return 0;
}



/*
	Comparaison de deux instructions
*/
int BoolEQ( TypeInst* t1, TypeInst* t2 )
{
	int rc;
	char b1[400], b2[400];

	if (t1->str==NULL && t2->str==NULL) rc=t1->val==t2->val;
	else rc=!strcmp(ToString(t1),ToString(t2));
	if (rc) rc=TRUE;
	else	rc=FALSE;
	if (debug_rule) printf("%s = %s => %d\n",PrintT(t1,b1), PrintT(t2,b2),rc);
	FreeMem(t1);
	FreeMem(t2);
	return rc;
}


/*
	Comparaison de contenance de deux instructions
*/
int BoolIn( TypeInst* t1, TypeInst* t2 )
{
	int rc;
	char b1[400], b2[400];

	if (strstr(ToString(t2),ToString(t1))) rc=TRUE;
	else				       rc=FALSE;
	if (debug_rule) printf("%s IN %s => %d\n",PrintT(t1,b1), PrintT(t2,b2),rc);
	FreeMem(t1);
	FreeMem(t2);
	return rc;
}


/*
	Comparaison de deux instructions
*/
int BoolGT( TypeInst* t1, TypeInst* t2 )
{
	int rc;
	char b1[400], b2[400];

	if (t1->str==NULL && t2->str==NULL) rc=t1->val-t2->val;
	else rc=strcmp(ToString(t1),ToString(t2));
	if (rc>0) rc=TRUE;
	else	rc=FALSE;
	if (debug_rule) printf("%s > %s => %d\n",PrintT(t1,b1), PrintT(t2,b2),rc);
	FreeMem(t1);
	FreeMem(t2);
	return rc;
}


/*
	Comparaison de deux instructions
*/
int BoolGE( TypeInst* t1, TypeInst* t2 )
{
	int rc;
	char b1[400], b2[400];

	if (t1->str==NULL && t2->str==NULL) rc=t1->val-t2->val;
	else rc=strcmp(ToString(t1),ToString(t2));
	if (rc>=0) rc=TRUE;
	else	rc=FALSE;
	if (debug_rule) printf("%s >= %s => %d\n",PrintT(t1,b1), PrintT(t2,b2),rc);
	FreeMem(t1);
	FreeMem(t2);
	return rc;
}


/*
	Instruction + Instruction
*/
TypeInst* Ajout( TypeInst* t1, TypeInst* t2 )
{
	TypeInst* rc;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
	if (t1->str==NULL && t2->str==NULL)
	{
		rc->str=NULL;
		rc->val=t1->val+t2->val;
	}
	else
	{
		rc->val=0;
		rc->str=(char*)malloc(strlen(ToString(t1))+
				      strlen(ToString(t2))+1);
		strcpy(rc->str,t1->str);
		strcat(rc->str,t2->str);
	}
	FreeMem(t1);
	FreeMem(t2);
	return rc;
}	

/*
	200(1)
*/
TypeInst* AjoutOcc( TypeInst* t1, TypeInst* t2 )
{
	TypeInst* rc;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
	rc->val=0;
	rc->str=(char*)malloc(strlen(ToString(t1))+strlen(ToString(t2))+3);
	sprintf(rc->str,"%s(%d)",t1->str,t2->val);
	FreeMem(t1);
	FreeMem(t2);
	return rc;
}


/*
	Instruction - Instruction
*/
TypeInst* Soust( TypeInst* t1, TypeInst* t2 )
{
	if (t1->str!=NULL || t2->str!=NULL)
	{
		yyerror("Substraction can not be done between strings");
		return NULL;
	}
	else
	{
		TypeInst* rc=(TypeInst*)malloc(sizeof(TypeInst));
		rc->str=NULL;
		rc->val=t1->val-t2->val;
		FreeMem(t1);
		FreeMem(t2);
		return rc;
	}
}	


/*
	Instruction * Instruction
*/
TypeInst* Multi( TypeInst* t1, TypeInst* t2 )
{
	if (t1->str!=NULL || t2->str!=NULL)
	{
		yyerror("Mulitiplication can not be done between strings");
		return NULL;
	}
	else
	{
		TypeInst* rc=(TypeInst*)malloc(sizeof(TypeInst));
		rc->str=NULL;
		rc->val=t1->val*t2->val;
		FreeMem(t1);
		FreeMem(t2);
		return rc;
	}
}


/*
	Instruction : Instruction
*/
TypeInst* Divis( TypeInst* t1, TypeInst* t2 )
{
	if (t1->str!=NULL || t2->str!=NULL)
	{
		yyerror("Division can not be done between strings");
		return NULL;
	}
	else
	if (t2->val==0)
	{
		yyerror("Division by 0 error");
		return NULL;
	}
	else
	{
		TypeInst* rc=(TypeInst*)malloc(sizeof(TypeInst));
		rc->str=NULL;
		rc->val=t1->val/t2->val;
		FreeMem(t1);
		FreeMem(t2);
		return rc;
	}
}

/*
	STR( Instruction )
*/
TypeInst* String( TypeInst* t )
{
	ToString(t);
	return t;
}

/*
	UPPER( Instruction )
*/
TypeInst* Upper( TypeInst* t )
{
	int i;
	ToString(t);
	for (i=0;t->str[i];++i)
		t->str[i]=(char)toupper((int)t->str[i]);
	return t;
}

/*
	LOWER( Instruction )
*/
TypeInst* Lower( TypeInst* t )
{
	int i;
	ToString(t);
	for (i=0;t->str[i];++i)
		t->str[i]=(char)tolower((int)t->str[i]);
	return t;
}


/*
	VAL( Instruction )
*/
TypeInst* Value( TypeInst* t )
{
	int i;
	char*msg;
	if (t->str==NULL) return t;
	for (i=0;t->str[i];++i) 
		if (!isdigit(t->str[i]))
		{
			msg=(char*)malloc(strlen(t->str)+50);
			sprintf(msg,"%s cannot be converted in integer",t->str);
			yyerror(msg);
			free(msg);
		}
	t->val=atoi(t->str);
	free(t->str);
	t->str=NULL;
	return t;
}	

/*
	LEN( Instruction )
*/
TypeInst* Len( TypeInst* t )
{
    char toto[100];
	
 
    TypeInst* rc=(TypeInst*)malloc(sizeof(TypeInst));
	rc->str=NULL;
	if (t->str==NULL)
	  rc->val=0;
	else   
	  rc->val=strlen(t->str);
	/*sprintf(toto,"chaine d'entree : %s %d %d",t->str,strlen(t->str),rc->val);
	PrintDebug(toto);*/
	return rc;
}
	
/*
	STO(i)
*/
int MemSto( TypeInst* n )
{
	int i=n->val;
	if (n->str!=NULL)
	{
		yyerror("Sto( String ) is not correct");
		return 0;
	}
	else
	if (n->val<0 || n->val>99)
	{
		char tmp[100];
		sprintf(tmp,"Sto(%d) is not correct",n->val);
		yyerror(tmp);
		return 0;	
	}	
	if (Memoire[i]!=NULL) FreeMem(Memoire[i]);
	Memoire[i]=NULL;
	Copie( &Memoire[i], S );
	FreeMem(n);
	return 0;
}

/*
	MEM(i)
*/
TypeInst* MemMem( TypeInst* n )
{
	int i=n->val;
	if (n->str!=NULL)
	{
		yyerror("Mem( String ) is not correct");
		return NULL;
	}
	else
	if (n->val<0 || n->val>99)
	{
		char tmp[100];
		sprintf(tmp,"Mem(%d) is not correct",n->val);
		yyerror(tmp);
		return NULL;	
	}	
	if (Memoire[i]!=NULL)
	{
		TypeInst* rc;
		Copie(&rc,Memoire[i]);
		FreeMem(n);
		return rc;
	}
	else
	{
		char tmp[100];
		sprintf(tmp,"Mem(%d) is empty",i);
		yyerror(tmp);
		return NULL;
	}
}

/*
	CLR(i)
*/
int MemClr( TypeInst* n  )
{
	int i=n->val;
	if (n->str!=NULL)
	{
		yyerror("Clr( String ) is not correct");
		return 0;
	}
	else
	if (n->val<0 || n->val>99)
	{
		char tmp[100];
		sprintf(tmp,"Clr(%d) is not correct",n->val);
		yyerror(tmp);
		return 0;	
	}	
	FreeMem(Memoire[i]);
	Memoire[i]=NULL;
	FreeMem(n);
	return 0;
}

/*
	EXC(i)
*/
TypeInst* MemExc( TypeInst* n )
{
	int i=n->val;
	if (n->str!=NULL)
	{
		yyerror("Exc( String ) is not correct");
		return NULL;
	}
	else
	if (n->val<0 || n->val>99)
	{
		char tmp[100];
		sprintf(tmp,"Exc(%d) is not correct",n->val);
		yyerror(tmp);
		return NULL;	
	}	
	if (Memoire[i]!=NULL)
	{
		TypeInst* rc=Memoire[i];
		Copie(&Memoire[i],S);
		FreeMem(n);
		return rc;
	}
	else
	{
		char tmp[100];
		sprintf(tmp,"Exc(%d) is empty",i);
		yyerror(tmp);
		return NULL;
	}
}	

/*
	FROM( translation [, STRICT] )
*/
TypeInst* From( TypeInst* t, int strict )
{
	TypeInst*rc;
	unsigned int i;

	/* Suite a la remarque no 80 */
	Value(t); 
	i=(unsigned int)(t->val-1);
	rc=(TypeInst*)malloc(sizeof(TypeInst));
	ToString(S);
	if (t->str!=NULL || i<0 || i>strlen(S->str))
	{
		rc->str=(char*)malloc(1);
		rc->str[0]=0;
	}
	else
	{
		if (!strict)
		{
			while( (unsigned char)(S->str[i])==' ' ) ++i;
		}	
		rc->str=(char*)malloc(strlen(S->str)-i+1);
		strcpy(rc->str,&S->str[i]);
	}
	rc->val=0;
	FreeMem(t);
	return rc;
}


/*
	TO( translation [, STRICT] )
*/
TypeInst* To( TypeInst* t, int strict )
{
	TypeInst*rc;
	unsigned int i;

	/* Suite a la remarque no 80 */
	Value(t); 
	i=(unsigned int)(t->val-1);
	rc=(TypeInst*)malloc(sizeof(TypeInst));
	ToString(S);
	if (t->str!=NULL || i<0 || i>strlen(S->str))
	{
		rc->str=(char*)malloc(1);
		rc->str[0]=0;
	}
	else
	{
		if (!strict)
		{
			while( (unsigned char)(S->str[i])==' ' ) --i;
		}	
		++i;
		rc->str=(char*)malloc(i+1);
		memcpy(rc->str,S->str,i);
		rc->str[i]=0;
	}
	rc->val=0;
	FreeMem(t);
	return rc;
}

/*
	BETWEEN( translation , translation [, STRICT] )
*/
TypeInst* Between( TypeInst* t1, TypeInst* t2, int strict )
{
	TypeInst *rc;
	unsigned int i1,i2;

	/* Suite a la remarque no 80 */
	Value(t1); 
	Value(t2); 
	i1=(unsigned int)(t1->val-1);
	i2=(unsigned int)(t2->val-1);
	rc=(TypeInst*)malloc(sizeof(TypeInst));
	ToString(S);
	if (t1->str!=NULL || i1<0 || i1>strlen(S->str) ||
	    t2->str!=NULL || i2<0 || i2>strlen(S->str))
	{
		rc->str=(char*)malloc(1);
		rc->str[0]=0;
	}
	else
	{

		if (!strict)
		{
			while( (unsigned char)(S->str[i1])==' ' ) ++i1;
			while( (unsigned char)(S->str[i2])==' ' ) --i2;
		}	
		++i2;
		rc->str=(char*)malloc(i2-i1+1);
		memcpy(rc->str,&S->str[i1],i2-i1);
		rc->str[i2-i1]=0;
	}
	rc->val=0;
	FreeMem(t1);
	FreeMem(t2);
	return rc;
}


/*
	DELETE( translation [, AT ...] [, STRICT] )
 replaced by REPLACE !

TypeInst* Delete( TypeInst* t1, int at, int strict )
{
	TypeInst*rc;
	TypeInst*SS;
	char* stmp;
	int i,i1,i2;
	int l,ok;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
	ToString(S);
	Copie(&SS,S);
	ToString(t1);
	l=strlen(t1->str);

	do
	{
	   ok=0;
	   switch(at)
	   {
	   case 0 :
		i=0;
		while(SS->str[i])
		{
			if (memcmp( &SS->str[i], t1->str, l )) ++i;
			else 
			{
				ok=1;
				break;
			}
		}
		break;
	
	   case 1 :
	   case 3 :
		i=0;
		if (memcmp( &SS->str[i], t1->str, l )==0) ok=1;
		break;
	   case 2 :
		i=strlen(SS->str)-l;
		if (memcmp( &SS->str[i], t1->str, l )==0) ok=1;
		break;
	   }
	

	   if (ok)
	   {
		rc->str=(char*)malloc(strlen(SS->str)-l+1);
		memcpy(rc->str,SS->str,i);
		strcpy(&rc->str[i],&SS->str[i+l]);
		free(SS->str);
		SS->str=rc->str;
	   }
           else	rc->str=strdup(SS->str);
	}
	while (ok);

	if (at==3)
	{
	    do
	    {
		ok=0;
		i=strlen(rc->str)-l;
		if (memcmp( &rc->str[i], t1->str, l )==0) 
		{
			rc->str[i]=0;
			ok=1;
		}
	    }
	    while (ok);
	}
	rc->val=0;

	i1=0;
	i2=strlen(rc->str)-1;
	if (!strict)
	{
		while( (unsigned char)(rc->str[i1])==' ' ) ++i1;
		while( (unsigned char)(rc->str[i2])==' ' ) --i2;
	}
	++i2;
	stmp=rc->str;	
	rc->str=(char*)malloc(i2-i1+1);
	memcpy(rc->str,&stmp[i1],i2-i1);
	rc->str[i2-i1]=0;
	free(stmp);
	FreeMem(t1);
	FreeMem(SS);
	return rc;
}
*/


/*
	REPLACE( translation BY translation [, AT ...] [, STRICT] )
*/
TypeInst* Replace( TypeInst* t1, TypeInst* t2, int at, int strict )
{
	TypeInst*rc;
	TypeInst*SS;
	char* stmp;
	int i,i1,i2;
	int l1,l2,ok;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
	ToString(S);
	Copie(&SS,S);
	ToString(t1);
        l1=strlen(t1->str);
	if (t2==NULL)
	{
		t2=(TypeInst*)malloc(sizeof(TypeInst));
		t2->val=0;
		t2->str=strdup("");
	}
	else	ToString(t2);
        l2=strlen(t2->str);

	if (at==2)
		i=strlen(SS->str)-l1;
	else	i=0;

	do
	{
	   ok=0;
	   switch(at)
	   {
	   case 0 :
		while(SS->str[i])
		{
			if (memcmp( &SS->str[i], t1->str, l1 )) ++i;
			else 
			{
				ok=1;
				break;
			}
		}
		break;
	
	   case 1 :
	   case 3 :
		if (memcmp( &SS->str[i], t1->str, l1 )==0) ok=1;
		break;
	   case 2 :
		if (memcmp( &SS->str[i], t1->str, l1 )==0) ok=1;
		break;
	   }
	

	   if (ok)
	   {
		rc->str=(char*)malloc(strlen(SS->str)-l1+l2+1);
		memcpy(rc->str,SS->str,i);
		strcpy(&rc->str[i],t2->str);
                strcat(rc->str,&SS->str[i+l1]);
		free(SS->str);
		SS->str=rc->str;
		if (at!=2) i+=l2;
	   }
	}
	while (ok);

	if (at==3)
	{
	    do
	    {
		ok=0;
		i=strlen(SS->str)-l1;
		if (memcmp( &SS->str[i], t1->str, l1 )==0) 
		{
			rc->str=(char*)malloc(strlen(SS->str)-l1+l2+1);
			memcpy(rc->str,SS->str,i);
			strcpy(&rc->str[i],t2->str);
			free(SS->str);
			SS->str=rc->str;
			ok=1;
		}
	    }
	    while (ok);
	}
	rc->val=0;
     	rc->str=strdup(SS->str);

	i1=0;
	i2=strlen(rc->str)-1;
	if (!strict)
	{
		while( (unsigned char)(rc->str[i1])==' ' ) ++i1;
		while( (unsigned char)(rc->str[i2])==' ' ) --i2;
	}
	++i2;
	stmp=rc->str;	
	if ((i2-i1+1) > 0) { rc->str=(char*)malloc(i2-i1+1); rc->str[0] = '\0';} else {rc->str=(char*)malloc(1); } 
	if ((i2-i1) > 0) memcpy(rc->str,&stmp[i1],i2-i1);
	if ((i2 - i1) >= 0) rc->str[i2-i1]=0;
	free(stmp); 
	FreeMem(t1);
	FreeMem(t2);
	FreeMem(SS);
	return rc;
}
 

/*
	REPLACEOCC( translation BY translation , OCCURENCE  [, STRICT] )
*/
TypeInst* ReplaceOcc( TypeInst* t1, TypeInst* t2, TypeInst* inCondOcc, int strict )
{
	TypeInst*rc;
	TypeInst*SS;
	char* stmp;
	char CondOcc[20];
	char Signe[20];
	int  Valeur;
	int occ;
	int i,i1,i2;
	int l1,l2,ok;


	char toto[1000];

	ToString(inCondOcc);
	/* Nettoyage blancs dans inCondOcc */
	i1=i2=0;
	while(inCondOcc->str[i1])
	{
		if (inCondOcc->str[i1]!=' ')
			CondOcc[i2++]=inCondOcc->str[i1];
		++i1;
	}
	CondOcc[i2]=0;
 
	/* Sparation signe/valeur */
	i=0;
	while(CondOcc[i])
	{
		if (!isdigit(CondOcc[i]))
			Signe[i]=CondOcc[i];
		else break;
		++i;
	}
	Signe[i]=0;
	Valeur=atoi(&CondOcc[i]);


	rc=(TypeInst*)malloc(sizeof(TypeInst));
	ToString(S);
	Copie(&SS,S);
	ToString(t1);
    l1=strlen(t1->str);
	if (t2==NULL)
	{
		t2=(TypeInst*)malloc(sizeof(TypeInst));
		t2->val=0;
		t2->str=strdup("");
	}
	else	ToString(t2);
    l2=strlen(t2->str);

	/*sprintf(toto,"ReplaceOcc(%s by %s, %s, %d) dans <%s>",t1->str, t2->str, CondOcc, strict, SS->str);
	PrintDebug(toto);
	sprintf(toto,"%s %s %d",Signe, &CondOcc[i], Valeur);
	PrintDebug(toto);*/
	
	occ=0;
	i=0;
	while(SS->str[i])
	{
		if (memcmp( &SS->str[i], t1->str, l1 )) ++i;
		else 
		{
			occ++;
			if (((strcmp(Signe,"=")==0) && (occ==Valeur)) ||
			    ((strcmp(Signe,"!=")==0) && (occ!=Valeur)) ||
			    ((strcmp(Signe,">")==0) && (occ>Valeur)) ||
			    ((strcmp(Signe,">=")==0) && (occ>=Valeur)) ||
			    ((strcmp(Signe,"<")==0) && (occ<Valeur)) ||
			    ((strcmp(Signe,"<=")==0) && (occ<=Valeur)))
				{
						rc->str=(char*)malloc(strlen(SS->str)-l1+l2+1);
						memcpy(rc->str,SS->str,i);
						strcpy(&rc->str[i],t2->str);
						strcat(rc->str,&SS->str[i+l1]);
						free(SS->str);
						SS->str=rc->str;
						i+=l2;
				}
			else ++i;
		}
	}
		
	rc->val=0;
    rc->str=strdup(SS->str);

	i1=0;
	i2=strlen(rc->str)-1;
	if (!strict)
	{
		while( (unsigned char)(rc->str[i1])==' ' ) ++i1;
		while( (unsigned char)(rc->str[i2])==' ' ) --i2;
	}
	++i2;
	stmp=rc->str;	
	rc->str=(char*)malloc(i2-i1+1);
	memcpy(rc->str,&stmp[i1],i2-i1);
	rc->str[i2-i1]=0;
	free(stmp);
	FreeMem(t1);
	FreeMem(t2);
	FreeMem(SS);
	return rc;
}



int IsDigit( char c )
 {
  unsigned char uc=(unsigned char)c;
  return isdigit((int)uc);
 }


/*
	BFIRST( translation | ... )
*/
TypeInst* BFirst( TypeInst* t, int k )
{
	TypeInst*rc;
	int i;
	int l;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
	rc->str=NULL;
	ToString(S);

	switch(k)
	{
	case 0 :
		ToString(t);
		l=strlen(t->str);
		i=0;
		while( S->str[i] )
		{
			if (memcmp(&S->str[i],t->str,l)) ++i;
			else break;
		}
		break;

	case 1 :
		i=0;
		while( S->str[i] )
		{
			if (IsDigit(S->str[i])) break;
			else ++i;
		}
		break;

	case 2 :
		i=0;
		while( S->str[i] )
		{
			if ((unsigned char)(S->str[i])==' ' || IsDigit(S->str[i])) ++i;
			else break;
		}
		break;
	}
	if (S->str[i]) 	rc->val=i+1;
	else		rc->val=0;
	FreeMem(t);
	return rc;
}


/*
	EFIRST( translation | ... )
*/
TypeInst* EFirst( TypeInst* t, int k )
{
	TypeInst*rc;
	int i,ok;
	int l;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
	rc->str=NULL;
	ToString(S);

	ok=0;
	switch(k)
	{
	case 0 :
		ToString(t);
		l=strlen(t->str);
		i=0;
		while( S->str[i] )
		{
			if (memcmp(&S->str[i],t->str,l)) ++i;
			else 
			{
				ok=1;
				break;
			}
		}
		if (S->str[i]) i+=l;
		break;

	case 1 :
		i=0;
		while( S->str[i] )
		{
			if (IsDigit(S->str[i])) 
			{
				ok=1;
				break;
			}
			else ++i;
		}
		while( S->str[i] )
		{
			if (IsDigit(S->str[i])) ++i;
			else break;
		}
		break;

	case 2 :
		i=0;
		while( S->str[i] )
		{
			if ((unsigned char)(S->str[i])==' ' || IsDigit(S->str[i])) ++i;
			else
			{
				ok=1;
				break;
			}
		}
		while( S->str[i] )
		{
			if ((unsigned char)(S->str[i])!=' ' && !IsDigit(S->str[i])) ++i;
			else break;
		}
		break;
	}
	if (ok) 	rc->val=i+1;
	else		rc->val=0;
	FreeMem(t);
	return rc;
}


/*
	BLAST( translation | ... )
*/
TypeInst* BLast( TypeInst* t, int k )
{
	TypeInst*rc;
	int i,ok;
	int l;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
	rc->str=NULL;
	ToString(S);
	ok=0;

	switch(k)
	{
	case 0 :
		ToString(t);
		l=strlen(t->str);
		i=strlen(S->str-l);
		while( i>=0 )
		{
			if (memcmp(&S->str[i],t->str,l)) --i;
			else 
			{
				ok=1;
				break;
			}
		}
		break;

	case 1 :
		i=strlen(S->str);
		while( i>=0 )
		{
			if (IsDigit(S->str[i])) 
			{
				ok=1;
				break;
			}
			else --i;
		}
		while( i>0 )
		{
			if (IsDigit(S->str[i])) --i;
			else break;
		}
		break;

	case 2 :
		i=strlen(S->str);
		while( i>=0 )
		{
			if ((unsigned char)(S->str[i])==' ' || IsDigit(S->str[i])) --i;
			else 
			{
				ok=1;
				break;
			}
		}
		while( i>0 )
		{
			if ((unsigned char)(S->str[i])!=' ' && !IsDigit(S->str[i])) --i;
			else break;
		}
		break;
	}
	if (ok) 	rc->val=i+1;
	else		rc->val=0;
	FreeMem(t);
	return rc;
}


/*
	ELAST( translation | ... )
*/
TypeInst* ELast( TypeInst* t, int k )
{
	TypeInst*rc;
	int i;
	int l;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
	rc->str=NULL;
	ToString(S);

	switch(k)
	{
	case 0 :
		ToString(t);
		l=strlen(t->str);
		i=strlen(S->str)-l;
		while( i>=0 )
		{
			if (memcmp(&S->str[i],t->str,l)) --i;
			else break;
		}
		if (i>=0) i+=l;
		break;

	case 1 :
		i=strlen(S->str);
		while( i>=0 )
		{
			if (IsDigit(S->str[i])) break;
			else --i;
		}
		break;

	case 2 :
		i=strlen(S->str);
		while( i>=0 )
		{
			if ((unsigned char)(S->str[i])==' ' || IsDigit(S->str[i])) --i;
			else break;
		}
		break;
	}
	if (i>=0) 	rc->val=i+1;
	else		rc->val=0;
	FreeMem(t);
	return rc;
}


int FreeCD( TypeCD* CD )
{
	if (CD)
	{
		if (CD->Fixed!=NULL) free(CD->Fixed);
		free(CD);
	}
	return 0;
}


/*
	NEXT ( subfield [,subfield] [,STRICT] )
*/
TypeInst* Next_( TypeCD* cd1, TypeCD* cd2, int strict )
{
	TypeInst* rc;
        char *tempo;
        int i1,i2;

	tempo=NextSubField( cd1, cd2 );
        if (!tempo) return NULL;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
        rc->val=0;
   	if (!strict)
	{
		i1=0;i2=strlen(tempo);
		while( (unsigned char)(tempo[i1])==' ' ) ++i1;
		while( (unsigned char)(tempo[i2])==' ' ) --i2;
		++i2;
	}	
	rc->str=(char*)malloc(i2-i1+1);
	memcpy(rc->str,&tempo[i1],i2-i1);
	rc->str[i2-i1]=0;

	free(tempo);
	FreeCD(cd1);
	FreeCD(cd2);
	return rc;
}


/*
	LAST ( subfield [,subfield] [,STRICT] )
*/
TypeInst* Last_( TypeCD* cd1, TypeCD* cd2, int strict )
{
	TypeInst* rc;
        char *tempo;
        int i1,i2;

	tempo=LastSubField( cd1, cd2 );
	if (!tempo) return NULL;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
        rc->val=0;
   	if (!strict)
	{
		i1=0;i2=strlen(tempo);
		while( (unsigned char)(tempo[i1])==' ' ) ++i1;
		while( (unsigned char)(tempo[i2])==' ' ) --i2;
		++i2;
	}	
	rc->str=(char*)malloc(i2-i1+1);
	memcpy(rc->str,&tempo[i1],i2-i1);
	rc->str[i2-i1]=0;

	free(tempo);
	FreeCD(cd1);
	FreeCD(cd2);
	return rc;
}


/*
	TABLE ( subfield [,subfield] [,STRICT] )
*/
TypeInst* Table_( TypeInst* Nom )
{
	TypeInst* rc;

	rc=(TypeInst*)malloc(sizeof(TypeInst));
	rc->str=Table( Nom->str, S->str );
	FreeMem( Nom );
	return rc;
}


/*
	NEXTSUB
*/
TypeInst* NextBal()
{
	TypeInst* rc;
    char *tempo;
    
	tempo=NextBalise();
    rc=(TypeInst*)malloc(sizeof(TypeInst));
    rc->val=0;	
	if (!tempo) 
		rc->str=strdup("");
	else 
		rc->str=tempo;

	return rc;
}

/*
	PREVIOUSSUB
*/
TypeInst* PreviousBal()
{
	TypeInst* rc;
    char *tempo;
    
	tempo=PreviousBalise();
    rc=(TypeInst*)malloc(sizeof(TypeInst));
    rc->val=0;	
	if (!tempo) 
		rc->str=strdup("");
	else 
		rc->str=tempo;

	return rc;
}
yyparse()
{
	register short		yyi, *yyp;	/* for table lookup */
	register short		*yyps;		/* top of state stack */
	register short		yystate;	/* current state */
	register YYSTYPE	*yypv;		/* top of value stack */
	register short		*yyq;
	register int		yyj;
#if YYDEBUG
	yyTraceItems	yyx;			/* trace block */
	short	* yytp;
	int	yyruletype = 0;
#endif
#ifdef YYSTATIC
	static short	yys[YYSSIZE + 1];
	static YYSTYPE	yyv[YYSSIZE + 1];
#if YYDEBUG
	static short	yytypev[YYSSIZE+1];	/* type assignments */
#endif
#else /* ! YYSTATIC */
#ifdef YYALLOC
	YYSTYPE *yyv;
	short	*yys;
#if YYDEBUG
	short	*yytypev;
#endif
	YYSTYPE save_yylval;
	YYSTYPE save_yyval;
	YYSTYPE *save_yypvt;
	int save_yychar, save_yyerrflag, save_yynerrs;
	int retval;
#else
	short		yys[YYSSIZE + 1];
	static YYSTYPE	yyv[YYSSIZE + 1];	/* historically static */
#if YYDEBUG
	short	yytypev[YYSSIZE+1];		/* mirror type table */
#endif
#endif /* ! YYALLOC */
#endif /* ! YYSTATIC */


#ifdef YYALLOC
	yys = (short *) malloc((YYSSIZE + 1) * sizeof(short));
	yyv = (YYSTYPE *) malloc((YYSSIZE + 1) * sizeof(YYSTYPE));
#if YYDEBUG
	yytypev = (short *) malloc((YYSSIZE+1) * sizeof(short));
#endif
	if (yys == (short *)0 || yyv == (YYSTYPE *)0
#if YYDEBUG
		|| yytypev == (short *) 0
#endif
	) {
		yyerror("Not enough space for parser stacks");
		return 1;
	}
	save_yylval = yylval;
	save_yyval = yyval;
	save_yypvt = yypvt;
	save_yychar = yychar;
	save_yyerrflag = yyerrflag;
	save_yynerrs = yynerrs;
#endif

	yynerrs = 0;
	yyerrflag = 0;
	yyclearin;
	yyps = yys;
	yypv = yyv;
	*yyps = yystate = YYS0;		/* start state */
#if YYDEBUG
	yytp = yytypev;
	yyi = yyj = 0;			/* silence compiler warnings */
#endif

yyStack:
	yyassert((unsigned)yystate < yynstate, gettext("state %d\n"), yystate);
	if (++yyps > &yys[YYSSIZE]) {
		yyerror("Parser stack overflow");
		YYABORT;
	}
	*yyps = yystate;	/* stack current state */
	*++yypv = yyval;	/* ... and value */
#if YYDEBUG
	*++yytp = yyruletype;	/* ... and type */

	if (yydebug)
		YY_TRACE(yyShowState)
#endif

	/*
	 *	Look up next action in action table.
	 */
yyEncore:
#ifdef YYSYNC
	YYREAD;
#endif
	if (yystate >= sizeof yypact/sizeof yypact[0]) 	/* simple state */
		yyi = yystate - YYDELTA;	/* reduce in any case */
	else {
		if(*(yyp = &yyact[yypact[yystate]]) >= 0) {
			/* Look for a shift on yychar */
#ifndef YYSYNC
			YYREAD;
#endif
			yyq = yyp;
			yyi = yychar;
			while (yyi < *yyp++)
				;
			if (yyi == yyp[-1]) {
				yystate = ~YYQYYP;
#if YYDEBUG
				if (yydebug) {
					yyruletype = yyGetType(yychar);
					YY_TRACE(yyShowShift)
				}
#endif
				yyval = yylval;	/* stack what yylex() set */
				yyclearin;		/* clear token */
				if (yyerrflag)
					yyerrflag--;	/* successful shift */
				goto yyStack;
			}
		}

		/*
	 	 *	Fell through - take default action
	 	 */

		if (yystate >= sizeof yydef /sizeof yydef[0])
			goto yyError;
		if ((yyi = yydef[yystate]) < 0)	 { /* default == reduce? */
			/* Search exception table */
			yyassert((unsigned)~yyi < sizeof yyex/sizeof yyex[0],
				gettext("exception %d\n"), yystate);
			yyp = &yyex[~yyi];
#ifndef YYSYNC
			YYREAD;
#endif
			while((yyi = *yyp) >= 0 && yyi != yychar)
				yyp += 2;
			yyi = yyp[1];
			yyassert(yyi >= 0,
				 gettext("Ex table not reduce %d\n"), yyi);
		}
	}

	yyassert((unsigned)yyi < yynrule, gettext("reduce %d\n"), yyi);
	yyj = yyrlen[yyi];
#if YYDEBUG
	if (yydebug)
		YY_TRACE(yyShowReduce)
	yytp -= yyj;
#endif
	yyps -= yyj;		/* pop stacks */
	yypvt = yypv;		/* save top */
	yypv -= yyj;
	yyval = yypv[1];	/* default action $ = $1 */
#if YYDEBUG
	yyruletype = yyRules[yyrmap[yyi]].type;
#endif

	switch (yyi) {		/* perform semantic action */
		
case YYr1: {	/* Program :  Rules */
#line 75 "analyse.y"

				  if (!RedoFlag) 
				  {
					FreeMem(S);
					Copie(&S,yyval.inst);
					FreeMem(yyval.inst);
					yyval.inst=NULL;
					return 1;
				  }
				  else
				  {
					FreeMem(S);
					S=T;
					Copie(&T,yyval.inst);
					FreeMem(yyval.inst);
					yyval.inst=NULL;
					if (T->str[0]==0) return 1;
					else		  return 3;
				  }
				
} break;

case YYr2: {	/* Rules :  Rule */
#line 98 "analyse.y"
 
				  Copie(&yyval.inst,S);
				  FreeMem(S);
				  S=NULL;
				
} break;

case YYr3: {	/* Rules :  PLUS Rule */
#line 103 "analyse.y"
	
				  yyval.inst=Ajout(D,S);
				  D=S=NULL;
				
} break;

case YYr7: {	/* SetOfInstr :  Instruction */
#line 116 "analyse.y"

				  FreeMem(S); 
				  Copie(&S,yypvt[0].inst);
				  FreeMem(yypvt[0].inst);
				  yypvt[0].inst=NULL; 
				
} break;

case YYr10: {	/* Instruction :  REDO */
#line 127 "analyse.y"
 PrintDebug("Redo");
				  Copie(&yyval.inst,S);
				  RedoFlag=1;
				  Copie(&T,S);

				
} break;

case YYr11: {	/* CD :  TAGOCC */
#line 139 "analyse.y"
 PrintDebug("Tagocc");
				  yyval.tcd=yypvt[0].tcd; 
				  yyval.tcd->Fixed=NULL;
				  yyval.tcd->SubField[0]=0;
				  yyval.tcd->ns=0;
				
} break;

case YYr12: {	/* CD :  TAGOCC STAGOCC */
#line 145 "analyse.y"
 PrintDebug("Tagocc Stagocc");
				  yyval.tcd=yypvt[-1].tcd;
				  yyval.tcd->Fixed=NULL;
				  strcpy(yyval.tcd->SubField,yypvt[0].tcd->SubField);
				  yyval.tcd->ns=yypvt[0].tcd->ns;
				  free(yypvt[0].tcd);
				  yypvt[0].tcd=NULL;
} break;

case YYr13: {	/* CD :  TAGOCC FIX */
#line 152 "analyse.y"
 PrintDebug("Tagocc Fix");
				  yyval.tcd=yypvt[-1].tcd;
				  yyval.tcd->SubField[0]=0;
				  yyval.tcd->ns=0;
				  yyval.tcd->Fixed=strdup(yypvt[0].inst->str);
				  FreeMem(yypvt[0].inst);
				  yypvt[0].inst=NULL;
} break;

case YYr14: {	/* CD :  TAGOCC STAGOCC FIX */
#line 159 "analyse.y"
 PrintDebug("Tagocc Stagocc Fix");
				  yyval.tcd=yypvt[-2].tcd;
				  strcpy(yyval.tcd->SubField,yypvt[-1].tcd->SubField);
				  yyval.tcd->ns=yypvt[-1].tcd->ns;
				  yyval.tcd->Fixed=strdup(yypvt[0].inst->str);
				  free(yypvt[-1].tcd);
				  yypvt[-1].tcd=NULL;
				  FreeMem(yypvt[0].inst);
				  yypvt[0].inst=NULL;
} break;

case YYr15: {	/* CD :  STAGOCC */
#line 168 "analyse.y"
 PrintDebug("Stagocc");
				  yyval.tcd=yypvt[0].tcd;
				  yyval.tcd->Fixed=NULL;
				  strcpy(yyval.tcd->Field,CDIn->Field);
				  yyval.tcd->nt=0; 
} break;

case YYr16: {	/* CD :  FIX */
#line 173 "analyse.y"
 PrintDebug("Fix");
				  yyval.tcd=(TypeCD*)malloc(sizeof(TypeCD));
				  strcpy(yyval.tcd->Field,CDIn->Field);
				  yyval.tcd->nt=0;
				  strcpy(yyval.tcd->SubField,CDIn->SubField);
				  yyval.tcd->ns=0;
				  yyval.tcd->Fixed=(char*)strdup(yypvt[0].inst->str);
				  FreeMem(yypvt[0].inst);
				  yypvt[0].inst=NULL;
} break;

case YYr17: {	/* CD :  STAGOCC FIX */
#line 182 "analyse.y"
 PrintDebug("Stagocc Fix");
				  yyval.tcd=yypvt[-1].tcd;
				  yyval.tcd->Fixed=strdup(yypvt[0].inst->str);
				  strcpy(yyval.tcd->Field,CDIn->Field);
				  yyval.tcd->nt=0;
				  FreeMem(yypvt[0].inst);
				  yypvt[0].inst=NULL;
} break;

case YYr18: {	/* TAGOCC :  TAG */
#line 192 "analyse.y"
 PrintDebug("Tag");
				  	  yyval.tcd=(TypeCD*)malloc(sizeof(TypeCD));
					  strcpy(yyval.tcd->Field,yypvt[0].inst->str);
					  yyval.tcd->nt=0;
					  FreeMem(yypvt[0].inst);
					  yypvt[0].inst=NULL; 
} break;

case YYr19: {	/* TAGOCC :  TAG '(' Translation ')' */
#line 198 "analyse.y"
 PrintDebug("Tag(...)");
				  	  yyval.tcd=(TypeCD*)malloc(sizeof(TypeCD)); 
					  strcpy(yyval.tcd->Field,yypvt[-3].inst->str);
					  FreeMem(yypvt[-3].inst);
					  yypvt[-3].inst=NULL;
					  yyval.tcd->nt=yypvt[-1].inst->val;
					  free(yypvt[-1].inst);
					  yypvt[-1].inst=NULL; 
} break;

case YYr20: {	/* STAGOCC :  STAG */
#line 209 "analyse.y"
 PrintDebug("Stag");
				  	  yyval.tcd=(TypeCD*)malloc(sizeof(TypeCD));
					  strcpy(yyval.tcd->SubField,yypvt[0].inst->str);
					  yyval.tcd->ns=0;
					  FreeMem(yypvt[0].inst);
					  yypvt[0].inst=NULL; 
} break;

case YYr21: {	/* STAGOCC :  STAG '(' Translation ')' */
#line 215 "analyse.y"
 PrintDebug("Stag(...)");
				  	  yyval.tcd=(TypeCD*)malloc(sizeof(TypeCD)); 
					  strcpy(yyval.tcd->SubField,yypvt[-3].inst->str);
					  FreeMem(yypvt[-3].inst);
					  yypvt[-3].inst=NULL;
					  yyval.tcd->ns=yypvt[-1].inst->val;
					  free(yypvt[-1].inst);
					  yypvt[-1].inst=NULL; 
} break;

case YYr22: {	/* STAGOCC :  I1 */
#line 223 "analyse.y"
 PrintDebug("I1");
				  	  yyval.tcd=(TypeCD*)malloc(sizeof(TypeCD));
					  strcpy(yyval.tcd->SubField,"I1"); 
					  yyval.tcd->ns=0;	
					
} break;

case YYr23: {	/* STAGOCC :  I2 */
#line 228 "analyse.y"
 PrintDebug("I2");
				  	  yyval.tcd=(TypeCD*)malloc(sizeof(TypeCD));
					  strcpy(yyval.tcd->SubField,"I2"); 
					  yyval.tcd->ns=0;	
					
} break;

case YYr24: {	/* Condition :  IF Boolean THEN Translation */
#line 236 "analyse.y"
 PrintDebug("If...Then...");
					  if (yypvt[-2].code) yyval.inst=yypvt[0].inst; 
					  else 
					   {
					    FreeMem(yypvt[0].inst);
					    yypvt[0].inst=NULL;
					    FreeMem(S);
					    S=NULL;
					    return 2; 
					   }
					
} break;

case YYr25: {	/* Condition :  IF Boolean THEN Translation ELSE Translation */
#line 248 "analyse.y"
 PrintDebug("If...Then...Else...");
					  if (yypvt[-4].code) 
					  {
						yyval.inst=yypvt[-2].inst;
						FreeMem(yypvt[0].inst);
					        yypvt[0].inst=NULL;
					  }
					  else 
					  {
						yyval.inst=yypvt[0].inst;
						FreeMem(yypvt[-2].inst);
					        yypvt[-2].inst=NULL;
					  }
					
} break;

case YYr26: {	/* Boolean :  '(' Boolean ')' */
#line 265 "analyse.y"
 PrintDebug("(B...)"); yyval.code=yypvt[-1].code; 
} break;

case YYr27: {	/* Boolean :  Boolean AND Boolean */
#line 266 "analyse.y"
 PrintDebug("B...and B..."); yyval.code=yypvt[-2].code && yypvt[0].code; 
} break;

case YYr28: {	/* Boolean :  Boolean OR Boolean */
#line 267 "analyse.y"
 PrintDebug("B...or B...");yyval.code=yypvt[-2].code || yypvt[0].code; 
} break;

case YYr29: {	/* Boolean :  NOT Boolean */
#line 268 "analyse.y"
 PrintDebug("!B...");yyval.code=!yypvt[0].code; 
} break;

case YYr30: {	/* Boolean :  Translation EQ Translation */
#line 269 "analyse.y"
 PrintDebug("...=...");yyval.code=BoolEQ(yypvt[-2].inst,yypvt[0].inst); yypvt[-2].inst=yypvt[0].inst=NULL; 
} break;

case YYr31: {	/* Boolean :  Translation NE Translation */
#line 270 "analyse.y"
 PrintDebug("...!=...");yyval.code=!BoolEQ(yypvt[-2].inst,yypvt[0].inst); yypvt[-2].inst=yypvt[0].inst=NULL; 
} break;

case YYr32: {	/* Boolean :  Translation IN Translation */
#line 271 "analyse.y"
 PrintDebug("...In...");yyval.code=BoolIn(yypvt[-2].inst,yypvt[0].inst); yypvt[-2].inst=yypvt[0].inst=NULL; 
} break;

case YYr33: {	/* Boolean :  Translation GT Translation */
#line 272 "analyse.y"
 PrintDebug("...>...");yyval.code=BoolGT(yypvt[-2].inst,yypvt[0].inst); yypvt[-2].inst=yypvt[0].inst=NULL; 
} break;

case YYr34: {	/* Boolean :  Translation LT Translation */
#line 273 "analyse.y"
 PrintDebug("...<...");yyval.code=BoolGT(yypvt[0].inst,yypvt[-2].inst); yypvt[-2].inst=yypvt[0].inst=NULL; 
} break;

case YYr35: {	/* Boolean :  Translation GE Translation */
#line 274 "analyse.y"
 PrintDebug("...>=...");yyval.code=BoolGE(yypvt[-2].inst,yypvt[0].inst); yypvt[-2].inst=yypvt[0].inst=NULL; 
} break;

case YYr36: {	/* Boolean :  Translation LE Translation */
#line 275 "analyse.y"
 PrintDebug("...<=...");yyval.code=BoolGE(yypvt[0].inst,yypvt[-2].inst); yypvt[-2].inst=yypvt[0].inst=NULL; 
} break;

case YYr37: {	/* Boolean :  EXISTS '(' CD ')' */
#line 276 "analyse.y"
 PrintDebug("Exists(...)");
					  yyval.code=Exists(yypvt[-1].tcd); 
					  if (yyval.code==2) return 2;
					  FreeCD(yypvt[-1].tcd); yypvt[-1].tcd=NULL; 
} break;

case YYr38: {	/* Boolean :  CD PRECEDES CD */
#line 280 "analyse.y"
 PrintDebug("...Precedes...");
					  yyval.code=Precedes(yypvt[-2].tcd,yypvt[0].tcd); 
					  if (yyval.code==2) return 2;
					  FreeCD(yypvt[0].tcd); yypvt[0].tcd=NULL; 
} break;

case YYr39: {	/* Boolean :  CD FOLLOWS CD */
#line 284 "analyse.y"
 PrintDebug("...Follows...");
					  yyval.code=Precedes(yypvt[0].tcd,yypvt[-2].tcd); 
					  if (yyval.code==2) return 2;
					  FreeCD(yypvt[0].tcd); yypvt[0].tcd=NULL; 
} break;

case YYr40: {	/* Translation :  '(' Translation ')' */
#line 291 "analyse.y"
 PrintDebug("(...)");yyval.inst=yypvt[-1].inst; 
} break;

case YYr43: {	/* Translation :  YEAR */
#line 294 "analyse.y"

					  time_t ns;
					  struct tm *lt;
					  time(&ns);
					  lt=localtime(&ns);
					  yyval.inst=(TypeInst*)malloc(sizeof(TypeInst));
					  sprintf(tempo,"%04d",1900+lt->tm_year);
					  yyval.inst->str=strdup(tempo);
					  yyval.inst->val=0;
					
} break;

case YYr44: {	/* Translation :  MONTH */
#line 304 "analyse.y"

					  time_t ns;
					  struct tm *lt;
					  time(&ns);
					  lt=localtime(&ns);
					  yyval.inst=(TypeInst*)malloc(sizeof(TypeInst));
					  sprintf(tempo,"%02d",lt->tm_mon+1);
					  yyval.inst->str=strdup(tempo);
					  yyval.inst->val=0;
					
} break;

case YYr45: {	/* Translation :  DAY */
#line 314 "analyse.y"

					  time_t ns;
					  struct tm *lt;
					  time(&ns);
					  lt=localtime(&ns);
					  yyval.inst=(TypeInst*)malloc(sizeof(TypeInst));
					  sprintf(tempo,"%02d",lt->tm_mday);
					  yyval.inst->str=strdup(tempo);
					  yyval.inst->val=0;
					
} break;

case YYr46: {	/* Translation :  HOUR */
#line 324 "analyse.y"

					  time_t ns;
					  struct tm *lt;
					  time(&ns);
					  lt=localtime(&ns);
					  yyval.inst=(TypeInst*)malloc(sizeof(TypeInst));
					  sprintf(tempo,"%02d",lt->tm_hour);
					  yyval.inst->str=strdup(tempo);
					  yyval.inst->val=0;
					
} break;

case YYr47: {	/* Translation :  MINUTE */
#line 334 "analyse.y"

					  time_t ns;
					  struct tm *lt;
					  time(&ns);
					  lt=localtime(&ns);
					  yyval.inst=(TypeInst*)malloc(sizeof(TypeInst));
					  sprintf(tempo,"%02d",lt->tm_min);
					  yyval.inst->str=strdup(tempo);
					  yyval.inst->val=0;
					
} break;

case YYr48: {	/* Translation :  SECOND */
#line 344 "analyse.y"

					  time_t ns;
					  struct tm *lt;
					  time(&ns);
					  lt=localtime(&ns);
					  yyval.inst=(TypeInst*)malloc(sizeof(TypeInst));
					  sprintf(tempo,"%02d",lt->tm_sec);
					  yyval.inst->str=strdup(tempo);
					  yyval.inst->val=0;
					
} break;

case YYr49: {	/* Translation :  ORDINAL '(' Translation ')' */
#line 354 "analyse.y"

					  int i,j;
					  char tmp1[20];
					  yyval.inst=(TypeInst*)malloc(sizeof(TypeInst));
					  sprintf(tmp1,"%d",ordinal);
					  for (j=0,i=strlen(tmp1);i<yypvt[-1].inst->val;++i,++j)
					   tempo[j]='0';
					  strcpy(&tempo[j],tmp1);
					  yyval.inst->str=strdup(tempo);
					  yyval.inst->val=0;
					  FreeMem(yypvt[-1].inst);
					  yypvt[-1].inst=NULL;
					
} break;

case YYr50: {	/* Translation :  NEXTBAL */
#line 367 "analyse.y"

						PrintDebug("NextSub");yyval.inst=NextBal();
					
} break;

case YYr51: {	/* Translation :  PREVIOUSBAL */
#line 370 "analyse.y"

						PrintDebug("PreviousSub");yyval.inst=PreviousBal();
					
} break;

case YYr52: {	/* Translation :  VAR_N */
#line 373 "analyse.y"
 PrintDebug("N");Copie(&yyval.inst,N); 
} break;

case YYr53: {	/* Translation :  VAR_NT */
#line 374 "analyse.y"
 PrintDebug("NT");Copie(&yyval.inst,NT); 
} break;

case YYr54: {	/* Translation :  VAR_NS */
#line 375 "analyse.y"
 PrintDebug("NS");Copie(&yyval.inst,NS); 
} break;

case YYr55: {	/* Translation :  VAR_NO */
#line 376 "analyse.y"
 PrintDebug("NO");Copie(&yyval.inst,NO); 
} break;

case YYr56: {	/* Translation :  VAR_NTO */
#line 377 "analyse.y"
 PrintDebug("NTO"); Copie(&yyval.inst,NTO); 
} break;

case YYr57: {	/* Translation :  VAR_NSO */
#line 378 "analyse.y"
 PrintDebug("NSO");Copie(&yyval.inst,NSO); 
} break;

case YYr58: {	/* Translation :  VARS */
#line 379 "analyse.y"
 PrintDebug("S");Copie(&yyval.inst,S); 
} break;

case YYr59: {	/* Translation :  CD */
#line 380 "analyse.y"
 char *ptr;
				  PrintDebug("CD");
				  yyval.inst=(TypeInst*)malloc(sizeof(TypeInst));
				  ptr=LireCD(yypvt[0].tcd);
				  if (!ptr) return 2;
				  yyval.inst->str=ptr; 
				  yyval.inst->val=0;
				  if (yypvt[0].tcd->Fixed) free(yypvt[0].tcd->Fixed);
				  free(yypvt[0].tcd); 
} break;

case YYr60: {	/* Translation :  Translation PLUS Translation */
#line 389 "analyse.y"
 PrintDebug("...+...");yyval.inst=Ajout(yypvt[-2].inst,yypvt[0].inst); yypvt[-2].inst=yypvt[0].inst=NULL; 
} break;

case YYr61: {	/* Translation :  Translation MOINS Translation */
#line 390 "analyse.y"
 PrintDebug("...-...");yyval.inst=Soust(yypvt[-2].inst,yypvt[0].inst); yypvt[-2].inst=yypvt[0].inst=NULL; 
} break;

case YYr62: {	/* Translation :  Translation MULTIPLIE Translation */
#line 391 "analyse.y"
 PrintDebug("...*...");yyval.inst=Multi(yypvt[-2].inst,yypvt[0].inst); yypvt[-2].inst=yypvt[0].inst=NULL; 
} break;

case YYr63: {	/* Translation :  Translation DIVISE Translation */
#line 392 "analyse.y"
 PrintDebug("...:...");yyval.inst=Divis(yypvt[-2].inst,yypvt[0].inst); yypvt[-2].inst=yypvt[0].inst=NULL; 
} break;

case YYr64: {	/* Translation :  STR '(' Translation ')' */
#line 393 "analyse.y"
 PrintDebug("Str(...)");yyval.inst=String(yypvt[-1].inst); 
} break;

case YYr65: {	/* Translation :  VAL '(' Translation ')' */
#line 394 "analyse.y"
 PrintDebug("Val(...)");yyval.inst=Value(yypvt[-1].inst); 
} break;

case YYr66: {	/* Translation :  LEN '(' Translation ')' */
#line 395 "analyse.y"
 PrintDebug("Len(...)");yyval.inst=Len(yypvt[-1].inst); 
} break;

case YYr67: {	/* Translation :  UPPER '(' Translation ')' */
#line 396 "analyse.y"
 PrintDebug("Upper(...)");yyval.inst=Upper(yypvt[-1].inst); 
} break;

case YYr68: {	/* Translation :  LOWER '(' Translation ')' */
#line 397 "analyse.y"
 PrintDebug("Lower(...)");yyval.inst=Lower(yypvt[-1].inst); 
} break;

case YYr69: {	/* Translation :  STO '(' Translation ')' */
#line 398 "analyse.y"
 PrintDebug("Sto(...)");Copie(&yyval.inst,S); MemSto(yypvt[-1].inst); yypvt[-1].inst=NULL; 
} break;

case YYr70: {	/* Translation :  MEM '(' Translation ')' */
#line 399 "analyse.y"
 PrintDebug("Mem(...)");yyval.inst=MemMem(yypvt[-1].inst); yypvt[-1].inst=NULL; 
} break;

case YYr71: {	/* Translation :  EXC '(' Translation ')' */
#line 400 "analyse.y"
 PrintDebug("Exc(...)");yyval.inst=MemExc(yypvt[-1].inst); yypvt[-1].inst=NULL; 
} break;

case YYr72: {	/* Translation :  CLR '(' Translation ')' */
#line 401 "analyse.y"
 PrintDebug("Clr(...)");Copie(&yyval.inst,S); MemClr(yypvt[-1].inst); yypvt[-1].inst=NULL; 
} break;

case YYr73: {	/* Translation :  FROM '(' Translation ')' */
#line 402 "analyse.y"
 PrintDebug("From(...)");yyval.inst=From(yypvt[-1].inst,0); yypvt[-1].inst=NULL; 
} break;

case YYr74: {	/* Translation :  FROM '(' Translation ',' STRICT ')' */
#line 404 "analyse.y"
 PrintDebug("From(...,STRICT)");yyval.inst=From(yypvt[-3].inst,1); yypvt[-3].inst=NULL; 
} break;

case YYr75: {	/* Translation :  TO '(' Translation ')' */
#line 405 "analyse.y"
 PrintDebug("To(...)");yyval.inst=To(yypvt[-1].inst,0); yypvt[-1].inst=NULL; 
} break;

case YYr76: {	/* Translation :  TO '(' Translation ',' STRICT ')' */
#line 407 "analyse.y"
 PrintDebug("To(...,STRICT)");yyval.inst=To(yypvt[-3].inst,1); yypvt[-3].inst=NULL; 
} break;

case YYr77: {	/* Translation :  BETWEEN '(' Translation ',' Translation ')' */
#line 409 "analyse.y"
 PrintDebug("Between(...)");yyval.inst=Between(yypvt[-3].inst,yypvt[-1].inst,0); yypvt[-3].inst=NULL; 
} break;

case YYr78: {	/* Translation :  BETWEEN '(' Translation ',' Translation ',' STRICT ')' */
#line 411 "analyse.y"
 PrintDebug("Between(...,STRICT)");yyval.inst=Between(yypvt[-5].inst,yypvt[-3].inst,1); yypvt[-5].inst=yypvt[-3].inst=NULL; 
} break;

case YYr79: {	/* Translation :  DELETE '(' Translation ')' */
#line 412 "analyse.y"
 PrintDebug("Delete(...)");yyval.inst=Replace(yypvt[-1].inst,NULL,0,0); yypvt[-1].inst=NULL; 
} break;

case YYr80: {	/* Translation :  DELETE '(' Translation ',' AT BEGINING ')' */
#line 414 "analyse.y"
 PrintDebug("Delete(..., AT BEGINING)");yyval.inst=Replace(yypvt[-4].inst,NULL,1,0); yypvt[-4].inst=NULL; 
} break;

case YYr81: {	/* Translation :  DELETE '(' Translation ',' AT END ')' */
#line 416 "analyse.y"
 PrintDebug("Delete(..., AT END)");yyval.inst=Replace(yypvt[-4].inst,NULL,2,0); yypvt[-4].inst=NULL; 
} break;

case YYr82: {	/* Translation :  DELETE '(' Translation ',' AT BOTH ')' */
#line 418 "analyse.y"
 PrintDebug("Delete(...,EVERYWHERE)");yyval.inst=Replace(yypvt[-4].inst,NULL,3,0); yypvt[-4].inst=NULL; 
} break;

case YYr83: {	/* Translation :  DELETE '(' Translation ',' STRICT ')' */
#line 419 "analyse.y"
 PrintDebug("Delete(...)");yyval.inst=Replace(yypvt[-3].inst,NULL,0,1); yypvt[-3].inst=NULL; 
} break;

case YYr84: {	/* Translation :  DELETE '(' Translation ',' AT BEGINING ',' STRICT ')' */
#line 421 "analyse.y"
 PrintDebug("Delete(..., AT BEGINING)");yyval.inst=Replace(yypvt[-6].inst,NULL,1,1); yypvt[-6].inst=NULL; 
} break;

case YYr85: {	/* Translation :  DELETE '(' Translation ',' AT END ',' STRICT ')' */
#line 423 "analyse.y"
 PrintDebug("Delete(..., AT END)");yyval.inst=Replace(yypvt[-6].inst,NULL,2,1); yypvt[-6].inst=NULL; 
} break;

case YYr86: {	/* Translation :  DELETE '(' Translation ',' AT BOTH ',' STRICT ')' */
#line 425 "analyse.y"
 PrintDebug("replace(...,EVERYWHERE)");yyval.inst=Replace(yypvt[-6].inst,NULL,3,1); yypvt[-6].inst=NULL; 
} break;

case YYr87: {	/* Translation :  REPLACE '(' Translation BY Translation ')' */
#line 426 "analyse.y"
 PrintDebug("replace(...)");yyval.inst=Replace(yypvt[-3].inst,yypvt[-1].inst,0,0); yypvt[-3].inst=yypvt[-1].inst=NULL; 
} break;

case YYr88: {	/* Translation :  REPLACE '(' Translation BY Translation ',' AT BEGINING ')' */
#line 428 "analyse.y"
 PrintDebug("replace(..., AT BEGINING)");yyval.inst=Replace(yypvt[-6].inst,yypvt[-4].inst,1,0); yypvt[-6].inst=yypvt[-4].inst=NULL; 
} break;

case YYr89: {	/* Translation :  REPLACE '(' Translation BY Translation ',' AT END ')' */
#line 430 "analyse.y"
 PrintDebug("replace(..., AT END)");yyval.inst=Replace(yypvt[-6].inst,yypvt[-4].inst,2,0); yypvt[-6].inst=yypvt[-4].inst=NULL; 
} break;

case YYr90: {	/* Translation :  REPLACE '(' Translation BY Translation ',' AT BOTH ')' */
#line 432 "analyse.y"
 PrintDebug("replace(...,EVERYWHERE)");yyval.inst=Replace(yypvt[-6].inst,yypvt[-4].inst,3,0); yypvt[-6].inst=yypvt[-4].inst=NULL; 
} break;

case YYr91: {	/* Translation :  REPLACE '(' Translation BY Translation ',' STRICT ')' */
#line 434 "analyse.y"
 PrintDebug("replace(...)");yyval.inst=Replace(yypvt[-5].inst,yypvt[-3].inst,0,1); yypvt[-5].inst=yypvt[-3].inst=NULL; 
} break;

case YYr92: {	/* Translation :  REPLACE '(' Translation BY Translation ',' AT BEGINING ',' STRICT ')' */
#line 436 "analyse.y"
 PrintDebug("replace(..., AT BEGINING)");yyval.inst=Replace(yypvt[-8].inst,yypvt[-6].inst,1,1); yypvt[-8].inst=yypvt[-6].inst=NULL; 
} break;

case YYr93: {	/* Translation :  REPLACE '(' Translation BY Translation ',' AT END ',' STRICT ')' */
#line 438 "analyse.y"
 PrintDebug("replace(..., AT END)");yyval.inst=Replace(yypvt[-8].inst,yypvt[-6].inst,2,1); yypvt[-8].inst=yypvt[-6].inst=NULL; 
} break;

case YYr94: {	/* Translation :  REPLACE '(' Translation BY Translation ',' AT BOTH ',' STRICT ')' */
#line 440 "analyse.y"
 PrintDebug("replace(...,EVERYWHERE)");yyval.inst=Replace(yypvt[-8].inst,yypvt[-6].inst,3,1); yypvt[-8].inst=yypvt[-6].inst=NULL; 
} break;

case YYr95: {	/* Translation :  REPLACEOCC '(' Translation BY Translation ',' Translation ')' */
#line 442 "analyse.y"
 PrintDebug("replace(...,Occ)");yyval.inst=ReplaceOcc(yypvt[-5].inst,yypvt[-3].inst,yypvt[-1].inst,0); yypvt[-5].inst=yypvt[-3].inst=NULL; 
} break;

case YYr96: {	/* Translation :  REPLACEOCC '(' Translation BY Translation ',' Translation ',' STRICT ')' */
#line 444 "analyse.y"
 PrintDebug("replace(...,Occ)");yyval.inst=ReplaceOcc(yypvt[-7].inst,yypvt[-5].inst,yypvt[-3].inst,1); yypvt[-7].inst=yypvt[-5].inst=NULL; 
} break;

case YYr97: {	/* Translation :  BFIRST '(' Translation ')' */
#line 445 "analyse.y"
 PrintDebug("BFirst(...)");yyval.inst=BFirst(yypvt[-1].inst,0); yypvt[-1].inst=NULL; 
} break;

case YYr98: {	/* Translation :  BFIRST '(' WNUMBER ')' */
#line 446 "analyse.y"
 PrintDebug("BFirst(Number)");yyval.inst=BFirst(NULL,1); 
} break;

case YYr99: {	/* Translation :  BFIRST '(' WSTRING ')' */
#line 447 "analyse.y"
 PrintDebug("BFirst(String)");yyval.inst=BFirst(NULL,2); 
} break;

case YYr100: {	/* Translation :  EFIRST '(' Translation ')' */
#line 448 "analyse.y"
 PrintDebug("EFirst(...)");yyval.inst=EFirst(yypvt[-1].inst,0); yypvt[-1].inst=NULL; 
} break;

case YYr101: {	/* Translation :  EFIRST '(' WNUMBER ')' */
#line 449 "analyse.y"
 PrintDebug("EFirst(Number)");yyval.inst=EFirst(NULL,1); 
} break;

case YYr102: {	/* Translation :  EFIRST '(' WSTRING ')' */
#line 450 "analyse.y"
 PrintDebug("EFirst(String)");yyval.inst=EFirst(NULL,2); 
} break;

case YYr103: {	/* Translation :  BLAST '(' Translation ')' */
#line 451 "analyse.y"
 PrintDebug("BLast(...)");yyval.inst=BLast(yypvt[-1].inst,0); yypvt[-1].inst=NULL; 
} break;

case YYr104: {	/* Translation :  BLAST '(' WNUMBER ')' */
#line 452 "analyse.y"
 PrintDebug("BLast(Number)");yyval.inst=BLast(NULL,1); 
} break;

case YYr105: {	/* Translation :  BLAST '(' WSTRING ')' */
#line 453 "analyse.y"
 PrintDebug("BLast(String)");yyval.inst=BLast(NULL,2); 
} break;

case YYr106: {	/* Translation :  ELAST '(' Translation ')' */
#line 454 "analyse.y"
 PrintDebug("ELast(...)");yyval.inst=ELast(yypvt[-1].inst,0); yypvt[-1].inst=NULL; 
} break;

case YYr107: {	/* Translation :  ELAST '(' WNUMBER ')' */
#line 455 "analyse.y"
 PrintDebug("ELast(Number)");yyval.inst=ELast(NULL,1); 
} break;

case YYr108: {	/* Translation :  ELAST '(' WSTRING ')' */
#line 456 "analyse.y"
 PrintDebug("ELast(String)");yyval.inst=ELast(NULL,2); 
} break;

case YYr109: {	/* Translation :  NEXT '(' CD ')' */
#line 457 "analyse.y"
 PrintDebug("Next(...)");yyval.inst=Next_(yypvt[-1].tcd,NULL,0); yypvt[-1].tcd=NULL; 
} break;

case YYr110: {	/* Translation :  NEXT '(' CD ',' CD ')' */
#line 458 "analyse.y"
 PrintDebug("Next(...,...)");
					  yyval.inst=Next_(yypvt[-3].tcd,yypvt[-1].tcd,0); 
					  if (!yyval.inst) return 2;
					  yypvt[-3].tcd=yypvt[-1].tcd=NULL; 
} break;

case YYr111: {	/* Translation :  NEXT '(' CD ',' STRICT ')' */
#line 462 "analyse.y"
 PrintDebug("Next(...,STRICT)");
					  yyval.inst=Next_(yypvt[-3].tcd,NULL,1);
					  if (!yyval.inst) return 2; 
					  yypvt[-3].tcd=NULL; 
} break;

case YYr112: {	/* Translation :  NEXT '(' CD ',' CD ',' STRICT ')' */
#line 467 "analyse.y"
 PrintDebug("Next(...,...,STRICT)");
					  yyval.inst=Next_(yypvt[-5].tcd,yypvt[-3].tcd,1); 
					  if (!yyval.inst) return 2;
					  yypvt[-5].tcd=yypvt[-3].tcd=NULL; 
} break;

case YYr113: {	/* Translation :  LAST '(' CD ')' */
#line 471 "analyse.y"
 PrintDebug("Last(...)");
					  yyval.inst=Last_(yypvt[-1].tcd,NULL,0); 
					  if (!yyval.inst) return 2;
					  yypvt[-1].tcd=NULL; 
} break;

case YYr114: {	/* Translation :  LAST '(' CD ',' CD ')' */
#line 475 "analyse.y"
 PrintDebug("Last(...,...)");
					  yyval.inst=Last_(yypvt[-3].tcd,yypvt[-1].tcd,0); 
					  if (!yyval.inst) return 2;
					  yypvt[-3].tcd=yypvt[-1].tcd=NULL; 
} break;

case YYr115: {	/* Translation :  LAST '(' CD ',' STRICT ')' */
#line 479 "analyse.y"
 PrintDebug("Last(...,STRICT)");
					  yyval.inst=Last_(yypvt[-3].tcd,NULL,1); 
					  if (!yyval.inst) return 2;
					  yypvt[-3].tcd=NULL; 
} break;

case YYr116: {	/* Translation :  LAST '(' CD ',' CD ',' STRICT ')' */
#line 484 "analyse.y"
 PrintDebug("Last(...,...,STRICT)");
					  yyval.inst=Last_(yypvt[-5].tcd,yypvt[-3].tcd,1); 
					  if (!yyval.inst) return 2;
					  yypvt[-5].tcd=yypvt[-3].tcd=NULL; 
} break;

case YYr117: {	/* Translation :  SORT '(' STRING ')' */
#line 488 "analyse.y"
 PrintDebug("Sort");
				  MustSort(yypvt[-1].inst->str);
				  FreeMem(yypvt[-1].inst);
				  yypvt[-1].inst=NULL;
				  return 2;
				
} break;

case YYr118: {	/* Translation :  TABLE '(' STRING ')' */
#line 494 "analyse.y"
 PrintDebug("Table(...)");yyval.inst=Table_(yypvt[-1].inst); yypvt[-1].inst=NULL; 
} break;
#line 314 "/etc/yyparse.c"
	case YYrACCEPT:
		YYACCEPT;
	case YYrERROR:
		goto yyError;
	}

	/*
	 *	Look up next state in goto table.
	 */

	yyp = &yygo[yypgo[yyi]];
	yyq = yyp++;
	yyi = *yyps;
	while (yyi < *yyp++)
		;

	yystate = ~(yyi == *--yyp? YYQYYP: *yyq);
#if YYDEBUG
	if (yydebug)
		YY_TRACE(yyShowGoto)
#endif
	goto yyStack;

yyerrlabel:	;		/* come here from YYERROR	*/
/*
#pragma used yyerrlabel
 */
	yyerrflag = 1;
	if (yyi == YYrERROR) {
		yyps--;
		yypv--;
#if YYDEBUG
		yytp--;
#endif
	}

yyError:
	switch (yyerrflag) {

	case 0:		/* new error */
		yynerrs++;
		yyi = yychar;
		yyerror("Syntax error");
		if (yyi != yychar) {
			/* user has changed the current token */
			/* try again */
			yyerrflag++;	/* avoid loops */
			goto yyEncore;
		}

	case 1:		/* partially recovered */
	case 2:
		yyerrflag = 3;	/* need 3 valid shifts to recover */
			
		/*
		 *	Pop states, looking for a
		 *	shift on `error'.
		 */

		for ( ; yyps > yys; yyps--, yypv--
#if YYDEBUG
					, yytp--
#endif
		) {
			if (*yyps >= sizeof yypact/sizeof yypact[0])
				continue;
			yyp = &yyact[yypact[*yyps]];
			yyq = yyp;
			do
				;
			while (YYERRCODE < *yyp++);

			if (YYERRCODE == yyp[-1]) {
				yystate = ~YYQYYP;
				goto yyStack;
			}
				
			/* no shift in this state */
#if YYDEBUG
			if (yydebug && yyps > yys+1)
				YY_TRACE(yyShowErrRecovery)
#endif
			/* pop stacks; try again */
		}
		/* no shift on error - abort */
		break;

	case 3:
		/*
		 *	Erroneous token after
		 *	an error - discard it.
		 */

		if (yychar == 0)  /* but not EOF */
			break;
#if YYDEBUG
		if (yydebug)
			YY_TRACE(yyShowErrDiscard)
#endif
		yyclearin;
		goto yyEncore;	/* try again in same state */
	}
	YYABORT;

#ifdef YYALLOC
yyReturn:
	yylval = save_yylval;
	yyval = save_yyval;
	yypvt = save_yypvt;
	yychar = save_yychar;
	yyerrflag = save_yyerrflag;
	yynerrs = save_yynerrs;
	free((char *)yys);
	free((char *)yyv);
	return(retval);
#endif
}

		
#if YYDEBUG
/*
 * Return type of token
 */
int
yyGetType(tok)
int tok;
{
	yyNamedType * tp;
	for (tp = &yyTokenTypes[yyntoken-1]; tp > yyTokenTypes; tp--)
		if (tp->token == tok)
			return tp->type;
	return 0;
}
/*
 * Print a token legibly.
 */
char *
yyptok(tok)
int tok;
{
	yyNamedType * tp;
	for (tp = &yyTokenTypes[yyntoken-1]; tp > yyTokenTypes; tp--)
		if (tp->token == tok)
			return tp->name;
	return "";
}

/*
 * Read state 'num' from YYStatesFile
 */
#ifdef YYTRACE
static FILE *yyStatesFile = (FILE *) 0;
static char yyReadBuf[YYMAX_READ+1];

static char *
yygetState(num)
int num;
{
	int	size;

	if (yyStatesFile == (FILE *) 0
	 && (yyStatesFile = fopen(YYStatesFile, "r")) == (FILE *) 0)
		return "yyExpandName: cannot open states file";

	if (num < yynstate - 1)
		size = (int)(yyStates[num+1] - yyStates[num]);
	else {
		/* length of last item is length of file - ptr(last-1) */
		if (fseek(yyStatesFile, 0L, 2) < 0)
			goto cannot_seek;
		size = (int) (ftell(yyStatesFile) - yyStates[num]);
	}
	if (size < 0 || size > YYMAX_READ)
		return "yyExpandName: bad read size";
	if (fseek(yyStatesFile, yyStates[num], 0) < 0) {
	cannot_seek:
		return "yyExpandName: cannot seek in states file";
	}

	(void) fread(yyReadBuf, 1, size, yyStatesFile);
	yyReadBuf[size] = '\0';
	return yyReadBuf;
}
#endif /* YYTRACE */
/*
 * Expand encoded string into printable representation
 * Used to decode yyStates and yyRules strings.
 * If the expansion of 's' fits in 'buf', return 1; otherwise, 0.
 */
int
yyExpandName(num, isrule, buf, len)
int num, isrule;
char * buf;
int len;
{
	int	i, n, cnt, type;
	char	* endp, * cp;
	char	*s;

	if (isrule)
		s = yyRules[num].name;
	else
#ifdef YYTRACE
		s = yygetState(num);
#else
		s = "*no states*";
#endif

	for (endp = buf + len - 8; *s; s++) {
		if (buf >= endp) {		/* too large: return 0 */
		full:	(void) strcpy(buf, " ...\n");
			return 0;
		} else if (*s == '%') {		/* nonterminal */
			type = 0;
			cnt = yynvar;
			goto getN;
		} else if (*s == '&') {		/* terminal */
			type = 1;
			cnt = yyntoken;
		getN:
			if (cnt < 100)
				i = 2;
			else if (cnt < 1000)
				i = 3;
			else
				i = 4;
			for (n = 0; i-- > 0; )
				n = (n * 10) + *++s - '0';
			if (type == 0) {
				if (n >= yynvar)
					goto too_big;
				cp = yysvar[n];
			} else if (n >= yyntoken) {
			    too_big:
				cp = "<range err>";
			} else
				cp = yyTokenTypes[n].name;

			if ((i = strlen(cp)) + buf > endp)
				goto full;
			(void) strcpy(buf, cp);
			buf += i;
		} else
			*buf++ = *s;
	}
	*buf = '\0';
	return 1;
}
#ifndef YYTRACE
/*
 * Show current state of yyparse
 */
void
yyShowState(tp)
yyTraceItems * tp;
{
	short * p;
	YYSTYPE * q;

	printf(
	    gettext("state %d (%d), char %s (%d)\n"),
	      yysmap[tp->state], tp->state,
	      yyptok(tp->lookahead), tp->lookahead);
}
/*
 * show results of reduction
 */
void
yyShowReduce(tp)
yyTraceItems * tp;
{
	printf("reduce %d (%d), pops %d (%d)\n",
		yyrmap[tp->rule], tp->rule,
		tp->states[tp->nstates - tp->npop],
		yysmap[tp->states[tp->nstates - tp->npop]]);
}
void
yyShowRead(val)
int val;
{
	printf(gettext("read %s (%d)\n"), yyptok(val), val);
}
void
yyShowGoto(tp)
yyTraceItems * tp;
{
	printf(gettext("goto %d (%d)\n"), yysmap[tp->state], tp->state);
}
void
yyShowShift(tp)
yyTraceItems * tp;
{
	printf(gettext("shift %d (%d)\n"), yysmap[tp->state], tp->state);
}
void
yyShowErrRecovery(tp)
yyTraceItems * tp;
{
	short	* top = tp->states + tp->nstates - 1;

	printf(
	gettext("Error recovery pops state %d (%d), uncovers %d (%d)\n"),
		yysmap[*top], *top, yysmap[*(top-1)], *(top-1));
}
void
yyShowErrDiscard(tp)
yyTraceItems * tp;
{
	printf(gettext("Error recovery discards %s (%d), "),
		yyptok(tp->lookahead), tp->lookahead);
}
#endif	/* ! YYTRACE */
#endif	/* YYDEBUG */
