#include <stdio.h>
#include <string.h>
#include "objectlist.h"


// John Hough
// Define BATCHRUN for a run which uses .bex files
// Define nothing (comment out #define BATCHRUN) for a run which uses the api interface 
//#define BATCHRUN


int main( int argc, char** argv )
{

#ifdef BATCHRUN // batch run

	myrun.SetReadMarcRecordsFromBexFile(true);
	myrun.SetIniFileName(argv[1]); // could use argv[1]
	myrun.start();	// do the conversion 

#else // api based run
	
	myrun.SetReadMarcRecordsFromBexFile(false);
	myrun.SetIniFileName("c:\\usemarcon_devel\\software_master\\runtime\\pc.ini"); // could use argv[1]
	
	// Load and convert 2 marc records - the first conversion will be slower than others because .ini file details are loaded
	for (int iLoop = 0; iLoop < 1; iLoop++)
	{
		// Load a marc record to convert
		FILE *fp; 
		int iInLength = 0; 
		char acInRecord[TBUF + 1]; 
		fp = fopen("hough2.bex", "r");
		if (fp)
		{		 
			iInLength = fread( acInRecord, sizeof( char ), TBUF, fp );
			fclose( fp );
		}
		printf("++++ input marc record ++++\n");
		printf(acInRecord);
		myrun.SetInputMarcRecord(acInRecord, iInLength);
		myrun.start();		  // do the conversion

		// Get marc record produced by the conversion
		char *pcOutRecord;
		int iOutLength = 0;
		myrun.GetOutputMarcRecord(pcOutRecord, iOutLength);

		printf("++++ output marc record ++++\n");
		printf(pcOutRecord);

		printf("\n\n");
	}
	return 0;
#endif
}


